
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)33	1.47  src/oss/kazn/kazn/kazn_kpcfilesubr.c, oss.kazn.src, oss600, 060907a  8/31/06  10:48:32";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
extern int pal_netSockFdToAddrInfo(int, int *, pal_nwAddr_t *, pal_nwAddr_t *);
extern int pal_netSaddrToNwAddr(pal_sockaddr_t *, pal_nwAddr_t *);
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
extern int csc_open(kenv_envHandle_t, int);
extern int csc_chdir(kenv_envHandle_t);



extern int csc_exec(kenv_envHandle_t,int);
extern int csc_chdir(kenv_envHandle_t);
extern int csc_mkdir(kenv_envHandle_t);
extern int csc_kill(kenv_envHandle_t, pal_pid_t);
extern int csc_delete(kenv_envHandle_t);
extern int csc_chmod(kenv_envHandle_t);
extern int csc_chown(kenv_envHandle_t);
extern int csc_truncate(kenv_envHandle_t);
extern int csc_settime(kenv_envHandle_t);
extern int csc_reboot(kenv_envHandle_t);
extern int csc_mknod(kenv_envHandle_t);
extern int csc_hardLink(kenv_envHandle_t);
extern int csc_symLink(kenv_envHandle_t);
extern int csc_readSlink(kenv_envHandle_t);
extern int csc_rename(kenv_envHandle_t);
extern int csc_readattr(kenv_envHandle_t);

extern int csc_setUserIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupSet(kenv_envHandle_t, int, pal_idSet_t *, int);

extern int csc_connect(kenv_envHandle_t);
extern int csc_accept(kenv_envHandle_t);
extern int csc_bind(kenv_envHandle_t);
typedef struct loginData {
    int32_t callerFlags;
    int32_t global_audit;
    int32_t loginLocType;
    int32_t activeLogins;



    int32_t activeLoginsOnTerm;




    char loginPgmKPON[256];
    union {
        char localTermKPON[128];
        oss_nwAddr_t nwTermAddr;
    } termInfo;
} kosseal_loginData_t;
extern int kutil_kossDebugFlag;
extern int kutil_kossActive;
extern int32_t kutil_optionalTraps;







extern int kutil_kossChecksum;




extern kutil_kconfig(pal_scall_parm_t, pal_scall_parm_t,
                       pal_scall_parm_t, pal_scall_parm_t, pal_scall_parm_t,
                       int *);
typedef struct nct_asyncNode {
    kutil_q_t q;
    int op;
    int aflags;
    int returnCode;
    pal_pid_t accPid;
    void *uniquifier;

    int reqSeqNum;
    pal_idList_t idList;
    void (*notify_func)(void *);
    void *notify_arg;
    int nwProto;
    char remAddrBuf[48];
    char locAddrBuf[48];
} nct_asyncNode_t;
typedef struct _cpath {
    char *path;
    int allocLen;




    char lclStr[80];
} cpPath_t;
extern int nct_asyncRequest(nct_asyncNode_t *);
extern void nct_asyncInit(void);
extern void nct_asyncShutdown(void);

extern int nct_addAuxPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_processPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_callCsc(kenv_env_t *, int);
extern int nct_checkPathOp(kenv_env_t *, char *, cpPath_t *, int, int);
extern int nct_checkFdOp(kenv_env_t *, int, int);
extern int nct_openCommon(char *, cpPath_t *, int, kenv_env_t *, int *);
extern int nct_killCommon(pal_pid_t, int, int *);
extern int nct_mkdirCommon(char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_linkCommon(char *, char *,
                          cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_renameCommon(char *, char *,
                            cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_symlinkCommon(char *, char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_mknodCommon(char *, pal_dev_t *,
                           pal_ftypes_t, cpPath_t *, kenv_env_t *, int *);
extern int nct_execCommon(char *, cpPath_t *, void *, kenv_env_t *, int *);
extern int nct_runAsync(void);
extern void nct_stopAsync(void);
extern void nct_postRenameCommon(kenv_env_t *);
extern void nct_postLinkCommon(kenv_env_t *);
extern void nct_postSymlinkCommon(kenv_env_t *);
extern void nct_postMknodCommon(kenv_env_t *);
extern void nct_postOpenCommon(kenv_env_t *, int, int);
extern void nct_postMkdirCommon(kenv_env_t *);
extern int nct_setuidCommon(kenv_env_t *, pal_idSet_t *,
                            pal_authID_t, int, int *);
extern int nct_setgidCommon(kenv_env_t *, pal_idSet_t *, int, int *);
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion __attribute__ ((aligned (8)));
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} __attribute__ ((aligned (8))) kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
typedef struct kpcfStats {
    int32_t resChecks;
    int32_t resCheckHits;
    int32_t directHits;
    int32_t inheritHits;
    int32_t exceptionHits;
    int32_t wildCardHits;
    int32_t multiHits;
    int32_t exceptionSearches;
    int32_t pfcHits;
    int32_t ncAdds;
    int32_t ncSize;
    int32_t ncChecks;
    int32_t ncHits;
    int32_t ncFlushes;
    int32_t padB;
    int32_t resAdds;
    int32_t resDeletes;
    int32_t resUpdates;
    int32_t excResources;
    int32_t allocedResources;
    int32_t padC;
    int32_t fileRefreshes;
    int32_t refreshAllCalls;
    int32_t refreshSkippedLock;
    int32_t refreshFastExit;
    int32_t dhashRefreshes;
    int32_t refreshGenWrapped;
    int32_t padD;
    int32_t mkdirNotifies;
    int32_t rmdirNotifies;
    int32_t epochRemoves;

    int32_t dhashRefRestarts;


    int32_t tooManyClinks;

    int32_t errorResources;



} kpcFileStats_t;
typedef struct dhashInfo {
    int32_t maxChainLen;
    int32_t avgChainLen;
    int32_t totEntries;
    int32_t numEmptyChains;
    int32_t dirs;
    int32_t nonDirs;
    int32_t oneDir;
} kpcFileDhashInfo_t;






typedef struct pfcStats {
    uint32_t cacheSize;
    uint32_t finds;
    uint32_t hits;
    uint32_t compares;
    uint32_t hashBoosts;
    uint32_t adds;
    uint32_t flushes;
    uint32_t hashPurges;
    uint32_t lruBoost;
} kpcf_pfcStats_t;
typedef struct fileRes {
    kutil_q_t refreshQ;
    kutil_q_t dirFidHashQ;
    kutil_q_t nameHashQ;
    kutil_q_t excQ;


    char *resName;
    void *extData;

    pal_time_t lastRefresh;
    pal_time_t firstDirTime;

    uint32_t branchId;
    uint32_t intFlags;
    uint32_t epoch;
    uint32_t refreshGen;



    int32_t hits;
    uint16_t refCount;
    uint16_t resNameLen;
    uint16_t extDataLen;
    uint16_t nlinks;
    pal_ftypes_t ftype;
    pal_dev_t dev;
    pal_mutex_t rLock;
    pal_cond_t rCond;
    pal_rawFid_t rfid;
    pal_rawFid_t dir_rfid;
    kpc_resFlags_t rflags;
    char *bName;


    pal_vfs_val_t check_vfsp;
    struct fileRes *clink;
    struct fileRes *plink;




    char _lclSpace[27 + 1];
} fileRes_t;
typedef struct fresNode {
    fileRes_t *resp;
    struct fresNode *next;
} fresNode_t;


typedef struct fresList {
    pal_rawFid_t *rFidp;
    pal_rawFid_t *parFidp;
    pal_fattr_t *fap;
    char *nameHint;
    char *bName;
    int16_t frlFlags;
    int16_t bNameLen;
    int count;
    int frlError;
    fresNode_t node;
} fresList_t;
typedef struct _fhq {
    pal_mutex_t hlock;

    uint32_t genNo;

    uint32_t resCount;
    fileRes_t *lastHitDir;

    pal_time_t leastRefreshTime;

    kutil_q_t dfQ[8];
} dirfidHash_t;
extern kpcFileStats_t kpcFileStats;
extern pal_mutex_t fileDbLock;
extern kutil_q_t kpcf_refreshQ;
extern pal_time_t kpcf_refreshQOldest;
extern kpcf_pfcStats_t kpcf_pfcStatInfo;
extern int32_t kpcf_changeGen;
extern int32_t kpcf_adminGen;






extern char *getBaseName(fileRes_t *);
extern fileRes_t *getFileResource(void);
extern void freeFileResource(fileRes_t *);
extern void releFileResource(fileRes_t *);
extern void holdFileResource(fileRes_t *);
extern void fresListAdd(fresList_t *, fileRes_t *);
extern void fresListClean(fresList_t *);
extern fileRes_t *kpcGetUnixRes(void);
extern void kpcInitUnixRes(void);
extern void kpcSetUnixRes(kpc_resFlags_t);
extern void kpcClearUnixRes(void);
extern int kpcfNameHash(char *);
extern int kpcfDirFidHash(pal_rawFid_t *);
extern int kpcfDirFidQueueHash(pal_rawFid_t *);
extern void kpcfSetFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfCheckFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfGenResFids(fileRes_t *, pal_rawFid_t *,
                          pal_rawFid_t *, pal_fattr_t *, int, int *);
extern void kpcfMarkResourceStale(fileRes_t *);
extern void kpcfSetupKpcInfo(kenv_envHandle_t, fileRes_t *, int, char *);
extern void kpcfMarkDhashStale(int);
extern void kazn_kpcfExpandTrappedPath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kpcf_ufileSetActive(int);
extern void kpcf_ufileInit(void);
extern void kpcf_ufileShutdown(void);
extern void kpcf_ufileStats(int);

extern uint32_t kpcf_getFileEpoch(void);

extern void kpcf_pfcAdd(pal_rawFid_t *, fileRes_t *, uint32_t);
extern int kpcf_pfcCheck(pal_rawFid_t *, fileRes_t **);
extern int kpcf_pfcCheckNoAcl(pal_rawFid_t *);
extern int kpcf_pfcFlush(pal_rawFid_t *);
extern void kpcf_pfcFlushProtResp(fileRes_t *);
extern void kpcf_pfcSetActive(int);
extern int kpcf_pfcGetActive(void);
extern void kpcf_pfcStats(int);

extern void kpcf_pfcInit(void);
extern void kpcf_pfcShutdown(void);

extern int kpcf_addResourcesToKPCInfo(fresList_t *,
                                      kenv_envHandle_t, int, int, int);
extern uint32_t kpcf_getNextRefreshGen(void);
extern uint32_t kpcf_getCurRefreshGen(void);
extern int kpcf_checkRefreshGenWrap(uint32_t, uint32_t);
extern void kpcf_refreshQInsertResource(fileRes_t *, int);
extern void kpcf_refreshQRemoveResource(fileRes_t *);
extern int kpcf_findResByResName(char *, fileRes_t **, int *);
extern void kpcf_nameHashInsert(fileRes_t *, int);
extern void kpcf_nameHashRemove(fileRes_t *);
extern fileRes_t *kpcf_nameHashSearch(char *, int);
extern int kpcf_findFidByFidOnly(fresList_t *);
extern int kpcf_dumpResources(kpc_fdumpRec_t *, int *, int *);
extern int kpcf_getResInfoByResName(kpc_record_t *);
extern void kpcf_checkForFidAliases(kutil_q_t *, fileRes_t *);
extern int kpcf_negCacheCheck(pal_rawFid_t *);
extern void kpcf_negCacheAdd(pal_rawFid_t *);
extern pal_time_t kpcf_negCacheFlush(pal_rawFid_t *);
extern void kpcf_negCacheFlushAll(void);
extern void kazn_kpcfSuspendFileLkups(int);
extern void kazn_kpcfResumeFileLkups(void);

extern void kpcf_subrInit(void);
extern void kpcf_subrShutdown(void);
typedef struct kpcf_asyncLU_datum {
    fileRes_t *fresp;
    char *path;
    int inFlags, rc;
    pal_rawFid_t *rfid, *dir_rfid;
    pal_fattr_t *fap;
    int *retFlags;
    pal_pid_t pid;
} kpcf_asyncLU_datum_t;

typedef struct kpcf_asyncLU {
    kutil_q_t q;
    pal_cond_t cvReq, cvSvc;
    pal_mutex_t mutex;
    int32_t flags;
    int32_t serial;
    kpcf_asyncLU_datum_t datum;
} kpcf_asyncLU_t;
typedef struct kpcf_asyncState
{
    kutil_q_t q;
    uint32_t state;
    int32_t count,serial;
    pal_cond_t cv;
    pal_mutex_t mutex;
} kpcf_asyncState_t;




int
kpcf_asyncLUReq(fileRes_t *fresp,pal_rawFid_t *rfid,pal_rawFid_t *dir_rfid,
                pal_fattr_t *fap,int lkupFlags,int *lkupRetFlags);
void kpcf_asyncLUInit(void);
void kpcf_asyncLUFini(void);
int kpcf_asyncRunLookup(void);


extern int kpcf_asyncDebug;
extern kpcf_asyncState_t kpcf_asyncLU;
kpcFileStats_t kpcFileStats = {0};
pal_mutex_t fileDbLock;






int32_t kpcf_changeGen = 1;







int32_t kpcf_adminGen = 1;





kutil_q_t kpcf_refreshQ;



pal_time_t kpcf_refreshQOldest = 0;
char *
getBaseName(fileRes_t *frp)
{
    char *bname = frp->bName, *lname;
    int len, lnameLen;


    bname = frp->bName;
    if (!bname) {
        lnameLen = frp->resNameLen + 1;
        lname = pal_alloc(lnameLen);
        if (lname) {
            strcpy(lname, frp->resName);
            kutil_pathBaseName(lname);
            len = strlen(lname);
            bname = pal_alloc(len + 1);
            if (bname) {
                strcpy(bname, lname);
                frp->bName = bname;
            }
            pal_free(lname, lnameLen);
        }
    }
    return((bname)? bname: "");
}
fileRes_t *
getFileResource(void)
{
    fileRes_t *fp;


    if (fp = (fileRes_t *)pal_alloc(sizeof(*fp))) {
        memset((char *)fp,0,sizeof(*fp));
        ((&fp->refreshQ)->next = (&fp->refreshQ)->prev = (&fp->refreshQ));
        ((&fp->nameHashQ)->next = (&fp->nameHashQ)->prev = (&fp->nameHashQ));
        ((&fp->dirFidHashQ)->next = (&fp->dirFidHashQ)->prev = (&fp->dirFidHashQ));
        ((&fp->excQ)->next = (&fp->excQ)->prev = (&fp->excQ));
        (kail_mutex_init(&fp->rLock));
        (kail_cond_init(&fp->rCond));
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.allocedResources));
    }
    return fp;
}
void
freeFileResource(fileRes_t *frp)
{




    if (frp->resName && (frp->resName != frp->_lclSpace)) {
        kutil_freeStringWithLocal(frp->resName,
                                  frp->_lclSpace, frp->resNameLen);
    }

    if (frp->bName) {
        pal_free(frp->bName, strlen(frp->bName) + 1);
    }

    if (frp->extData && frp->extDataLen) {
        pal_free(frp->extData, frp->extDataLen);
    }

    if (((frp)->intFlags & 0x400)) {
        kail_atomic_add((int)(-1),(void *)(&kpcFileStats.errorResources));
    }

    ((frp)->intFlags |= 0x4000);

    ;
    (kail_mutex_destroy(&frp->rLock));
    pal_free(frp, sizeof(*frp));
    kail_atomic_add((int)(-1),(void *)(&kpcFileStats.allocedResources));
}
void
releFileResource(fileRes_t *frp)
{
    int doFree = 0;

    (kail_mutex_lock(&(frp)->rLock));
    ;
    frp->refCount--;
    if ((frp->intFlags & 0x100) && (frp->refCount == 0)) {
        doFree = 1;
    }
    (kail_mutex_unlock(&(frp)->rLock));

    if (doFree) {



        freeFileResource(frp);
    }
}
void
holdFileResource(fileRes_t *frp)
{
    (kail_mutex_lock(&(frp)->rLock));
    frp->refCount++;




    (kail_mutex_unlock(&(frp)->rLock));
}
void
kpcfSetFidInfo(
    fileRes_t *frp,
    pal_rawFid_t *rfid,
    pal_rawFid_t *dir_rfid,
    pal_fattr_t *fap)
{
    if (rfid) {
        frp->rfid = *rfid;
        frp->ftype = fap->ftype;
        frp->nlinks = fap->links;
        frp->dev = fap->dev;
        ((frp)->intFlags |= 0x1);
    } else if (((frp)->intFlags & 0x1)) {
        ((frp)->intFlags &= ~0x1);
    }

    if (dir_rfid) {
        if (!((frp)->intFlags & 0x2) ||
            !(((((!memcmp((&(((&frp->dir_rfid)))->fid),(&(((dir_rfid)))->fid),((&(((&frp->dir_rfid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&frp->dir_rfid)))->fsid)->val[0] == (&(((dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            frp->firstDirTime = (pal_time_t)((dir_rfid)->ctime);
        }
        ((frp)->intFlags |= 0x2);
        frp->dir_rfid = *dir_rfid;
    } else if (((frp)->intFlags & 0x2)) {
        ((frp)->intFlags &= ~0x2);
        frp->firstDirTime = 0;
    }
}
int
kpcfCheckFidInfo(
    fileRes_t *frp,
    pal_rawFid_t *rfid,
    pal_rawFid_t *dir_rfid,
    pal_fattr_t *fap)
{
    int retFlags = 0;

    if (rfid) {
        if (!((frp)->intFlags & 0x1) ||
            (frp->nlinks != fap->links) ||
            !(((((!memcmp((&(((&frp->rfid)))->fid),(&(((rfid)))->fid),((&(((&frp->rfid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&frp->rfid)))->fsid)->val[0] == (&(((rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            retFlags |= 0x1;
        }
    } else if (((frp)->intFlags & 0x1)) {
        retFlags |= 0x1;
    }

    if (dir_rfid) {
        if (!((frp)->intFlags & 0x2) ||
            !(((((!memcmp((&(((&frp->dir_rfid)))->fid),(&(((dir_rfid)))->fid),((&(((&frp->dir_rfid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&frp->dir_rfid)))->fsid)->val[0] == (&(((dir_rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            retFlags |= 0x2;
        }
    } else if (((frp)->intFlags & 0x2)) {
        retFlags |= 0x2;
    }

    if (((frp)->intFlags & 0x20)) {
        retFlags |= 0x4;
    }

    if (!(((frp)->intFlags & 0x400))) {

        if (((frp)->intFlags & 0x20000)) {
            ((frp)->intFlags &= ~0x20000);
        }
        if (((frp)->intFlags & 0x40000)) {
            ((frp)->intFlags &= ~0x40000);
        }
    }



    if (fap->attrFlags & 0x4) {
        ((frp)->intFlags |= 0x8000);
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_RFID_FL_VFSP, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)(frp), (long)frp->intFlags, (long)(*((void **)&(frp->check_vfsp)))),0) : 0);


    }

    return retFlags;
}


static pal_cond_t kpcf_fileLkup_cv;
static pal_mutex_t kpcf_fileLkupLock;

int kpcf_activeFileLkups = 0;
int kpcf_suspendFileLkups = 0;
void
kazn_kpcfInitFileLkupControl(void)
{
    (kail_cond_init(&kpcf_fileLkup_cv));
    (kail_mutex_init(&kpcf_fileLkupLock));
}
void
kazn_kpcfSuspendFileLkups(int maxWait)
{
    int loops = 0;


    if (maxWait < 0) {
        maxWait = 1;
    }

    (kail_mutex_lock(&kpcf_fileLkupLock));
    kpcf_suspendFileLkups++;
    while (kpcf_activeFileLkups && (loops < maxWait)) {
        loops++;
        (void)(kail_condTimedWait(&kpcf_fileLkup_cv,&kpcf_fileLkupLock,1,0));

    }
    (kail_mutex_unlock(&kpcf_fileLkupLock));
}
void
kazn_kpcfResumeFileLkups(void)
{
    (kail_mutex_lock(&kpcf_fileLkupLock));
    ;
    kpcf_suspendFileLkups--;
    (kail_mutex_unlock(&kpcf_fileLkupLock));
    (kail_wake_up(&kpcf_fileLkup_cv));
}
static void
kazn_kpcfStartFileLkup(int maxWait)
{
    int loops = 0;


    if (maxWait < 0) {
        maxWait = 1;
    }

    (kail_mutex_lock(&kpcf_fileLkupLock));
    while (kpcf_suspendFileLkups && (loops < maxWait)) {
        loops++;
        (void)(kail_condTimedWait(&kpcf_fileLkup_cv,&kpcf_fileLkupLock,1,0));

    }
    kpcf_activeFileLkups++;
    (kail_mutex_unlock(&kpcf_fileLkupLock));
}
static void
kazn_kpcfEndFileLkup(void)
{
    int doSignal = 0;


    (kail_mutex_lock(&kpcf_fileLkupLock));
    ;
    kpcf_activeFileLkups--;
    if ((kpcf_activeFileLkups == 0) && kpcf_suspendFileLkups) {
        doSignal = 1;
    }
    (kail_mutex_unlock(&kpcf_fileLkupLock));

    if (doSignal) {
        (kail_wake_up(&kpcf_fileLkup_cv));
    }
}
int
kpcfGenResFids(fileRes_t *fresp,
               pal_rawFid_t *rfid,
               pal_rawFid_t *dir_rfid,
               pal_fattr_t *fap,
               int inFlags,
               int *outFlags)
{
    int rc, retFlags = 0, retCode = 0;
    int lkupRetFlags = 0;
    int lkupFlags = (0x8 | 0x10);


    if (inFlags & 0x1) {
        lkupFlags &= ~0x8;
    }


    if (inFlags & 0x2) {
        lkupFlags |= 0x40;
    }

    kazn_kpcfStartFileLkup(5);
    rc = kpcf_asyncLUReq(fresp, rfid, dir_rfid, fap, lkupFlags, &lkupRetFlags);
    kazn_kpcfEndFileLkup();

    if (rc == 0) {
        if (lkupRetFlags & 0x1) {
            retFlags |= 0x1;
        }
        if (lkupRetFlags & 0x2) {
            retFlags |= 0x2;
        }
    } else if (rc != ENOENT) {







        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_GENFID_ERR, (((1)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(fresp->resName), (long)rc),0) : 0);

        retFlags |= 0x4;
        if (rc != EACCES) {
            retCode = rc;
        }
    }

    *outFlags = retFlags;
    return retCode;
}
void
fresListAdd(fresList_t *frl, fileRes_t *res)
{
    fresNode_t *np;
    kpc_resFlags_t rf;
    int16_t checkFlags = 0;

    frl->count++;
    rf = res->rflags;
    if (rf.hasAcl)
        frl->frlFlags |= 0x1;
    if (rf.hasPop)
        frl->frlFlags |= 0x10;
    if (rf.hasAuthz)
        frl->frlFlags |= 0x40;
    if (rf.hasViaPgm)
        frl->frlFlags |= 0x20;

    if (rf.isWC)
        frl->frlFlags |= 0x2;

    if (rf.isRootDir)
        frl->frlFlags |= 0x8;

    if (frl->count == 1) {
        frl->node.resp = res;
    } else {
        if (frl->count == 2) kail_atomic_add((int)(1),(void *)(&kpcFileStats.multiHits));
        np = (fresNode_t *)pal_alloc(sizeof(*np));
        if (np) {
            np->resp = res;
            np->next = frl->node.next;
            frl->node.next = np;
        } else {
            frl->frlFlags |= 0x4;
            frl->count--;
            return;
        }
    }
    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_KPCF_ADD_RES, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(res), (long)frl->count, (long)(int)(frl->frlFlags)),0) : 0);


    holdFileResource(res);
}
void
fresListClean(fresList_t *frl)
{
    int doFree = 0;
    fresNode_t *np, *next;

    if (frl->bName) {
        pal_free(frl->bName, frl->bNameLen + 1);
        frl->bName = NULL;
    }

    if (frl->count == 0) {
        return;
    }

    np = &frl->node;
    while (np) {
        next = np->next;
        releFileResource(np->resp);
        if (!doFree) {
            doFree = 1;
        } else {
            pal_free(np, sizeof(*np));
        }
        np = next;
    }
    frl->count = frl->frlFlags = 0;
    frl->node.next = NULL;
}
static fileRes_t unixRes;
fileRes_t *
kpcGetUnixRes(void)
{
    if (unixRes.rflags.hasAcl) {
        holdFileResource(&unixRes);
        return &unixRes;
    } else {
        return NULL;
    }
}
void
kpcInitUnixRes(void)
{
    fileRes_t *ures = &unixRes;

    memset((char *)ures,0,sizeof(*ures));
    ((&ures->refreshQ)->next = (&ures->refreshQ)->prev = (&ures->refreshQ));
    ((&ures->dirFidHashQ)->next = (&ures->dirFidHashQ)->prev = (&ures->dirFidHashQ));
    ((&ures->nameHashQ)->next = (&ures->nameHashQ)->prev = (&ures->nameHashQ));
    ((&ures->excQ)->next = (&ures->excQ)->prev = (&ures->excQ));
    (kail_mutex_init(&ures->rLock));
    ures->refCount = 1;
    ures->resName = "/unix";
}
void
kpcSetUnixRes(kpc_resFlags_t rflags)
{
    ;
    unixRes.rflags = rflags;
}
void
kpcClearUnixRes(void)
{
    ;
    (*((int *)&unixRes.rflags) = 0);
}
int
kpcfDirFidHash(pal_rawFid_t *dfidp)
{
    int idx = 0;

    if (dfidp) {
        idx = (((uint)((((pal_fid_t *)(&dfidp->fid))->fid_ino) + (((pal_fid_t *)(&dfidp->fid))->fid_gen & 0x0ffff)))) % 907;
    }
    return idx;
}
int
kpcfDirFidQueueHash(pal_rawFid_t *fidp)
{
    int idx = 0;

    if (fidp) {
        idx = (((uint)((((pal_fid_t *)(&fidp->fid))->fid_ino) + (((pal_fid_t *)(&fidp->fid))->fid_gen & 0x0ffff)))) & (8 - 1);
    }
    return idx;
}
void
kpcfMarkResourceStale(fileRes_t *frp)
{
    int dhIndex, doDhashStale = 0;
    pal_rawFid_t *fidp;


    (kail_mutex_lock(&fileDbLock));
    (kail_mutex_lock(&(frp)->rLock));
    frp->lastRefresh = 0;
    frp->refreshGen = 0;
    if (!((frp)->intFlags & 0x20)) {
        fidp = ((frp)->intFlags & 0x2)? &frp->dir_rfid: NULL;
        dhIndex = kpcfDirFidHash(fidp);
        doDhashStale = 1;
        do { (frp)->intFlags |= 0x20; (frp)->intFlags &= ~0x1; } while ( 0);
    }
    (kail_mutex_unlock(&(frp)->rLock));

    if (doDhashStale) {
        kpcfMarkDhashStale(dhIndex);
    }




    kpcf_refreshQRemoveResource((frp));
    kpcf_refreshQInsertResource((frp), 0);

    (kail_mutex_unlock(&fileDbLock));
}
void
kpcfSetupKpcInfo(
    kenv_envHandle_t accEnv,
    fileRes_t *resp,
    int kpcFlags,
    char *ignored)
{
    int rc, l;
    kenv_kpcInfo_t ki;
    char *tn;


    (kail_mutex_lock(&(resp)->rLock));

    ki.resName = resp->resName;
    ki.resNameLen = resp->resNameLen;
    ki.branchId = resp->branchId;
    ki.resFlags = resp->rflags;
    ki.kpcFlags = kpcFlags;
    ki.kpcFlags |= 0x01000000;
    if (resp->rflags.hasAcl) {
        ki.kpcFlags |= 0x80;
    }
    if (resp->rflags.hasPop) {
        ki.kpcFlags |= 0x4000;
    }
    if (resp->rflags.hasAuthz) {
        ki.kpcFlags |= 0x10000;
    }
    if (resp->rflags.hasViaPgm) {
        ki.kpcFlags |= 0x8000;
    }
    if (resp->clink) {
        ki.kpcFlags |= 0x8;
    }
    if (resp->rflags.isRootDir) {
        ki.kpcFlags |= 0x2000;
    }






    if (((resp)->intFlags & 0x800)) {
        ki.kpcFlags |= 0x20000;
    }

    ki.extDataLen = resp->extDataLen;
    ki.extData = resp->extData;

    ki.resData.f.poFtype = resp->ftype;
    ki.resData.f.kpcFileAddGen = kpcf_adminGen;
    if (((resp)->intFlags & 0x1)) {
        ki.resData.f.poFid = &resp->rfid;
    } else {
        ki.resData.f.poFid = NULL;
    }

    if (resp->rflags.isWC &&
        (kpcFlags & 0x2) &&
        (tn = kenv_envGetTrappedName(accEnv, &l))) {
        ki.kpcFlags |= 0x1000;
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.wildCardHits));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_HIT_WC, (((1)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(resp->resName), (long)resp->extDataLen),0) : 0);


    }

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KPCF_KPCI_ADD_PO, (((1)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ki.resName), (long)ki.kpcFlags, (long)*((int *)&ki.resFlags), (long)ki.extDataLen),0) : 0);





    kenv_envSetKPCInfo(accEnv, &ki);

    (kail_mutex_unlock(&(resp)->rLock));
}
int
kpcf_addResourcesToKPCInfo(
    fresList_t *frlp,
    kenv_envHandle_t accEnv,
    int kpcFlags,
    int action,
    int eflags)
{
    int kpcFlagsFinal, markStale;
    int16_t frlFlags;
    fresNode_t *rn;


    markStale = 0;
    if (action & 0x10000) {
        markStale = 1;
    }
    if ((frlp->count > 1) && (action & 0x8000)) {





        markStale = 1;
    }

    kpcFlagsFinal = kpcFlags;
    frlFlags = frlp->frlFlags;
    if (frlFlags & 0x1) {
        kpcFlagsFinal |= 0x80;
    }
    if (frlFlags & 0x2) {
        kpcFlagsFinal |= 0x1000;
    }
    if (frlFlags & 0x10) {
        kpcFlagsFinal |= 0x4000;
    }
    if (frlFlags & 0x40) {
        kpcFlagsFinal |= 0x10000;
    }
    if (frlFlags & 0x20) {
        kpcFlagsFinal |= 0x8000;
    }

    if (frlFlags & 0x8) {
        kpcFlagsFinal |= 0x2000;
    }

    for (rn = &((frlp)->node); rn; rn = rn->next) {
        kail_atomic_add((int)(1),(void *)(&rn->resp->hits));
        kpcfSetupKpcInfo(accEnv, rn->resp, kpcFlags, NULL);
        if (markStale) {
            kpcfMarkResourceStale(rn->resp);
        }
    }

    return kpcFlagsFinal;
}
void
kazn_kpcfExpandTrappedPath(
    kenv_envHandle_t envH,
    kenv_kpcInfo_t *kip,
    int action,
    pal_pathBuf_t *pbp)
{
    int rc, f, needExpand = 1;
    uint32_t kpcFlags;
    char *tname;


    if ((tname = kenv_envGetTrappedName(envH, &f)) == NULL) {
        return;
    }

    kpcFlags = (kip)? kip->kpcFlags: 0;





    if (!(kpcFlags & 0x1000)) {
        if (*tname == '/') {
            needExpand = 0;
        } else if ((kpcFlags & 0x100) && !(kpcFlags &
                (0x4 | 0x8 | 0x10))) {
            needExpand = 0;
            kip->kpcFlags |= 0x200;
            kpcFlags = kip->kpcFlags;
        }
    }

    if (needExpand == 0) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KAZN_EXPAND_PATH_SKIP, (((1)<<28) + ((1)<<24) + ((2)<<20) + ((0)<<16)), (long)(tname), (long)((kip)? kip->resName: "N/A"), (long)kpcFlags),0) : 0);



        return;
    }

    f = 0;
    if ((((kenv_env_t *)(envH))->flags & 0x00001000)) {
        f = 0x8;
    }
    if (action & 0x8000) {
        f |= 0x20;
    }


    if ((((kenv_env_t *)(envH))->tgt.fs.f.tgt_nd)) {
        rc = pal_pathToFullPath((char *)((((kenv_env_t *)(envH))->tgt.fs.f.tgt_nd)), f, pbp);
    }
    else
    rc = pal_pathToFullPath(tname, f, pbp);



    if ((rc == 0) && pbp->path) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_EXPAND_PATH, (((1)<<28) + ((1)<<24) + ((0)<<20) + ((0)<<16)), (long)(tname), (long)pbp->path),0) : 0);



        if (kpcFlags & 0x1000) {
            kenv_envResetKPCInfoResName(envH, kip, pbp->path, pbp->pathLen);
        }

        kenv_envSetFullSrnRef(envH, pbp);
    } else {
        if (kpcFlags & 0x1000) {
            kip->kpcFlags &= ~0x1000;
        }
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_EXPAND_PATH_ERR, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((0)<<20) + ((0)<<16)), (long)(rc), (long)pbp->path),0) : 0);

        kt_intError(6, 1, 1172, rc);
    }
}
static uint kpcfRefreshGen = 1;
static pal_icLock_t kpcf_refreshGenLock;
uint32_t
kpcf_getNextRefreshGen(void)
{
    uint32_t nextGen;

    (kail_iclock_lock(&kpcf_refreshGenLock));
    nextGen = ++kpcfRefreshGen;
    (kail_iclock_unlock(&kpcf_refreshGenLock));
    return nextGen;
}
uint32_t
kpcf_getCurRefreshGen(void)
{
    uint32_t gen;

    (kail_iclock_lock(&kpcf_refreshGenLock));
    gen = kpcfRefreshGen;
    (kail_iclock_unlock(&kpcf_refreshGenLock));
    return gen;
}
int
kpcf_checkRefreshGenWrap(uint32_t genHi, uint32_t genLo)
{
    int wrapped = 0;

    ;
    if ((genHi - genLo) > 0x7fffffff) {
        wrapped = 1;
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.refreshGenWrapped));
    }
    return wrapped;
}
void
kpcf_refreshQInsertResource(fileRes_t *resp, int addHead)
{
    kutil_q_t *qp = &resp->refreshQ;


    ;
    if (addHead) {
        ((qp)->next = (((kutil_q_t *)&kpcf_refreshQ)->next), (qp)->prev = (&kpcf_refreshQ), (((kutil_q_t *)&kpcf_refreshQ)->next)->prev = (qp), (&kpcf_refreshQ)->next = (qp));
    } else {
        ((qp)->next = (&kpcf_refreshQ), (qp)->prev = (((kutil_q_t *)&kpcf_refreshQ)->prev), (((kutil_q_t *)&kpcf_refreshQ)->prev)->next = (qp), (&kpcf_refreshQ)->prev = (qp));
    }

    if (qp == (((kutil_q_t *)&kpcf_refreshQ)->prev)) {
        kpcf_refreshQOldest = resp->lastRefresh;
    }
}
void
kpcf_refreshQRemoveResource(fileRes_t *resp)
{
    kutil_q_t *qp;
    fileRes_t *lastResp;


    qp = &resp->refreshQ;
    if (!((((kutil_q_t *)qp)->next) == (kutil_q_t *)qp)) {
        (((qp)->next)->prev = ((qp)->prev), ((qp)->prev)->next = ((qp)->next));
        qp = (((kutil_q_t *)&kpcf_refreshQ)->prev);
        if (((qp) != &kpcf_refreshQ)) {
            lastResp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, refreshQ)));
            kpcf_refreshQOldest = lastResp->lastRefresh;
        } else {
            kpcf_refreshQOldest = 0;
        }
    }
}
typedef struct _negEntry {
    kutil_q_t hq;
    kutil_q_t lruq;
    pal_time_t cmpTime;
    pal_time_t expTime;
    uint32_t hashIndex;
    uint32_t key;
    uint32_t hits;
    pal_rawFid_t rfid;
} negEntry_t;
typedef struct _negHashLock {

    pal_icLock_t hlock;



    uint32_t uses;
    uint32_t compares;
    uint32_t found;
    uint32_t pad[4];
} negEntryHLock_t;
static kutil_q_t negCacheHashQ[4096];
static kutil_q_t negCacheLruQ;
static negEntry_t *negCacheEntries[8] = {0};
static int negCacheSize = 0;
static int negCacheAllocSize = 0;

static pal_icLock_t negCacheLock;




static negEntryHLock_t negcHashLocks[64];

negEntryHLock_t *negcHashLocksRef = negcHashLocks;
static void
negCacheFlushAll(void)
{
    int i, lidx, flushed = 0;
    negEntry_t *nep;
    kutil_q_t *qp, *hashqp, *nextqp;




    for(i = 0; i < 4096; i++) {
        hashqp = &negCacheHashQ[i];
        lidx = ((i) & (64 - 1));
        (kail_iclock_lock(&negcHashLocks[lidx].hlock)); negcHashLocks[lidx].uses++;

        for (qp = (((kutil_q_t *)hashqp)->next); qp != hashqp; qp = nextqp) {
            nextqp = ((qp)->next);
            nep = (negEntry_t *)qp;
            (((&nep->hq)->next)->prev = ((&nep->hq)->prev), ((&nep->hq)->prev)->next = ((&nep->hq)->next));
            ((&nep->hq)->next = (&nep->hq)->prev = (&nep->hq));
            nep->hashIndex = -1;
            flushed++;
        }

        (kail_iclock_unlock(&negcHashLocks[lidx].hlock));
    }



}
static negEntry_t *
negCacheFind(pal_rawFid_t *drfp, int hash, int lockHash, uint32_t key)
{
    negEntry_t *nep;
    kutil_q_t *qp, *hqp, *qpNext;
    negEntryHLock_t *hashLock;
    int misses;


    hqp = &negCacheHashQ[hash];
    hashLock = &negcHashLocks[lockHash];

    for (qp = ((hqp)->next), misses = 0;
        qp != hqp; qp = qpNext, misses++) {
        qpNext = ((qp)->next);
        nep = (negEntry_t *)qp;
        hashLock->compares++;
        if((key == nep->key) && (((((!memcmp((&(((drfp)))->fid),(&(((&nep->rfid)))->fid),((&(((drfp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((drfp)))->fsid)->val[0] == (&(((&nep->rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {
            if (nep->expTime < ((pal_time_t)(kail_xtime->tv_sec))) {



                (((&nep->hq)->next)->prev = ((&nep->hq)->prev), ((&nep->hq)->prev)->next = ((&nep->hq)->next));
                nep->hashIndex = -1;
                qpNext = ((hqp)->next);
                continue;
            }
            nep->hits++;
            hashLock->found++;
            if (misses && !(nep->hits & 15)) {

                (((&nep->hq)->next)->prev = ((&nep->hq)->prev), ((&nep->hq)->prev)->next = ((&nep->hq)->next));
                ((&nep->hq)->next = (((kutil_q_t *)hqp)->next), (&nep->hq)->prev = (hqp), (((kutil_q_t *)hqp)->next)->prev = (&nep->hq), (hqp)->next = (&nep->hq));
            }
            return nep;
        }
    }
    return NULL;
}
int
kpcf_negCacheCheck(pal_rawFid_t *drfp)
{
    int h, lhash, hits, found;
    uint32_t key;
    negEntry_t *nep;

    kail_atomic_add((int)(1),(void *)(&kpcFileStats.ncChecks));
    h = (((&((drfp))->fsid)->val[0] + ((uint)((((pal_fid_t *)(&(drfp)->fid))->fid_ino) + (((pal_fid_t *)(&(drfp)->fid))->fid_gen & 0x0ffff)))) & (4096 - 1));
    lhash = ((h) & (64 - 1));
    key = ((uint)((((pal_fid_t *)(&drfp->fid))->fid_ino) + (((pal_fid_t *)(&drfp->fid))->fid_gen & 0x0ffff)));

    (kail_iclock_lock(&negcHashLocks[lhash].hlock)); negcHashLocks[lhash].uses++;
    if (nep = negCacheFind(drfp, h, lhash, key)) {
        hits = nep->hits;
    }
    (kail_iclock_unlock(&negcHashLocks[lhash].hlock));

    if (nep) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.ncHits));
        found = 1;

        if (!(hits & 255)) {

            (kail_iclock_lock(&negCacheLock));
            (((&nep->lruq)->next)->prev = ((&nep->lruq)->prev), ((&nep->lruq)->prev)->next = ((&nep->lruq)->next));
            ((&nep->lruq)->next = (((kutil_q_t *)&negCacheLruQ)->next), (&nep->lruq)->prev = (&negCacheLruQ), (((kutil_q_t *)&negCacheLruQ)->next)->prev = (&nep->lruq), (&negCacheLruQ)->next = (&nep->lruq));
            (kail_iclock_unlock(&negCacheLock));
        }

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KPCF_NCHIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((&(drfp)->fsid)->val[0]), (long)*((int *)(&(&(drfp)->fid)->fid_ino)), (long)h, (long)hits),0) : 0);




    } else {
        found = 0;
    }

    return found;
}
void
kpcf_negCacheAdd(pal_rawFid_t *negFid)
{
    int nhash, lhash, lhash_old, doAdd;
    uint32_t key;
    negEntry_t *nep, *searchp;
    kutil_q_t *qp;
    pal_time_t now;

    doAdd = 0;
    now = ((pal_time_t)(kail_xtime->tv_sec));
    nhash = (((&((negFid))->fsid)->val[0] + ((uint)((((pal_fid_t *)(&(negFid)->fid))->fid_ino) + (((pal_fid_t *)(&(negFid)->fid))->fid_gen & 0x0ffff)))) & (4096 - 1));
    lhash = ((nhash) & (64 - 1));
    key = ((uint)((((pal_fid_t *)(&negFid->fid))->fid_ino) + (((pal_fid_t *)(&negFid->fid))->fid_gen & 0x0ffff)));


    (kail_iclock_lock(&negCacheLock));
    if ((qp = (((kutil_q_t *)&negCacheLruQ)->prev)) != &negCacheLruQ) {
        nep = (negEntry_t *)((char *)qp - (offsetof(negEntry_t, lruq)));
        if (nep->hashIndex != -1) {

            lhash_old = ((nep->hashIndex) & (64 - 1));
            (kail_iclock_lock(&negcHashLocks[lhash_old].hlock)); negcHashLocks[lhash_old].uses++;
            (((&nep->hq)->next)->prev = ((&nep->hq)->prev), ((&nep->hq)->prev)->next = ((&nep->hq)->next));
            ((&nep->hq)->next = (&nep->hq)->prev = (&nep->hq));
            (kail_iclock_unlock(&negcHashLocks[lhash_old].hlock));
        }


        nep->hashIndex = -1;
        nep->hits = 0;
        nep->rfid = *negFid;
        nep->key = ((uint)((((pal_fid_t *)(&negFid->fid))->fid_ino) + (((pal_fid_t *)(&negFid->fid))->fid_gen & 0x0ffff)));
        nep->cmpTime = (pal_time_t)((negFid)->ctime);
        if (now < nep->cmpTime) {
            nep->cmpTime = now;
        }
        if (!((negFid)->fid.fid_flags & (0x1))) {
            nep->expTime = now + (24 * 3600);
        } else {
            nep->expTime = now + 300;
        }


        (kail_iclock_lock(&negcHashLocks[lhash].hlock)); negcHashLocks[lhash].uses++;
        searchp = negCacheFind(negFid, nhash, lhash, key);
        if (searchp == NULL) {
            doAdd = 1;
            (((&nep->lruq)->next)->prev = ((&nep->lruq)->prev), ((&nep->lruq)->prev)->next = ((&nep->lruq)->next));
            ((&nep->lruq)->next = (((kutil_q_t *)&negCacheLruQ)->next), (&nep->lruq)->prev = (&negCacheLruQ), (((kutil_q_t *)&negCacheLruQ)->next)->prev = (&nep->lruq), (&negCacheLruQ)->next = (&nep->lruq));
            nep->hashIndex = nhash;
            ((&nep->hq)->next = (((kutil_q_t *)&negCacheHashQ[nhash])->next), (&nep->hq)->prev = (&negCacheHashQ[nhash]), (((kutil_q_t *)&negCacheHashQ[nhash])->next)->prev = (&nep->hq), (&negCacheHashQ[nhash])->next = (&nep->hq));
        }
        (kail_iclock_unlock(&negcHashLocks[lhash].hlock));
    }
    (kail_iclock_unlock(&negCacheLock));

    if (doAdd) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.ncAdds));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KPCF_NCADD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((&(negFid)->fsid)->val[0]), (long)*((int *)(&(&(negFid)->fid)->fid_ino)), (long)nhash, (long)kpcFileStats.ncAdds),0) : 0);




    }
}
pal_time_t
kpcf_negCacheFlush(pal_rawFid_t *drfp)
{
    int h, lhash;
    uint32_t key;
    pal_time_t cmpTime = 0;
    negEntry_t *nep;

    h = (((&((drfp))->fsid)->val[0] + ((uint)((((pal_fid_t *)(&(drfp)->fid))->fid_ino) + (((pal_fid_t *)(&(drfp)->fid))->fid_gen & 0x0ffff)))) & (4096 - 1));
    lhash = ((h) & (64 - 1));
    key = ((uint)((((pal_fid_t *)(&drfp->fid))->fid_ino) + (((pal_fid_t *)(&drfp->fid))->fid_gen & 0x0ffff)));

    (kail_iclock_lock(&negCacheLock));
    (kail_iclock_lock(&negcHashLocks[lhash].hlock)); negcHashLocks[lhash].uses++;
    if (nep = negCacheFind(drfp, h, lhash, key)) {
        (((&nep->hq)->next)->prev = ((&nep->hq)->prev), ((&nep->hq)->prev)->next = ((&nep->hq)->next));
    }
    (kail_iclock_unlock(&negcHashLocks[lhash].hlock));

    if (nep) {
        ((&nep->hq)->next = (&nep->hq)->prev = (&nep->hq));
        nep->hashIndex = -1;
        (((&nep->lruq)->next)->prev = ((&nep->lruq)->prev), ((&nep->lruq)->prev)->next = ((&nep->lruq)->next));
        ((&nep->lruq)->next = (&negCacheLruQ), (&nep->lruq)->prev = (((kutil_q_t *)&negCacheLruQ)->prev), (((kutil_q_t *)&negCacheLruQ)->prev)->next = (&nep->lruq), (&negCacheLruQ)->prev = (&nep->lruq));
        cmpTime = nep->cmpTime;
    }
    (kail_iclock_unlock(&negCacheLock));

    if (nep) {
        kail_atomic_add((int)(1),(void *)(&kpcFileStats.ncFlushes));
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KPCF_NCFLUSH, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((&(drfp)->fsid)->val[0]), (long)*((int *)(&(&(drfp)->fid)->fid_ino))),0) : 0);


    }
    return cmpTime;
}
void
kazn_kpcfFlushNegCache(void)
{
    (kail_iclock_lock(&negCacheLock));
    negCacheFlushAll();
    (kail_iclock_unlock(&negCacheLock));
}
static void
negCacheInit(void)
{
    int i, j, flags, rc;
    int memMB, calcSize, allocSize, cacheMem;
    negEntry_t *ncp;
    pal_rawFid_t rf, df;
    pal_fattr_t fattr;
    char **np;

    static char *negCacheSeeds[] = {

    "/tmp", "/dev", "/var", "/etc", "/var/tmp",
    "/usr/tmp", "/proc", "/home",
    "/var/pdos/umsg", "/var/pdos/watch",
    "/var/pdos/cred", "/var/pdos/azn",
    "/var/pdos/uuid", "/opt/pdos/kernel",
    "/opt/pdos/lib",
    NULL
    };


    ((&negCacheLruQ)->next = (&negCacheLruQ)->prev = (&negCacheLruQ));
    (kail_iclock_init(&negCacheLock));;
    for (i = 0; i < 4096; i++) {
        ((&negCacheHashQ[i])->next = (&negCacheHashQ[i])->prev = (&negCacheHashQ[i]));
    }

    for (i = 0; i < 64; i++) {
        (kail_iclock_init(&negcHashLocks[i].hlock));;
        negcHashLocks[i].uses = 0;
        negcHashLocks[i].compares = 0;
        negcHashLocks[i].found = 0;
        memset(&negcHashLocks[i].pad,0,sizeof(negcHashLocks[i].pad));
    }


    memMB = pal_sysMemMB;
    calcSize = (1024 + (24 * memMB));
    if (calcSize > 20480) {
        calcSize = 20480;
    }





    allocSize = calcSize / 8;
    cacheMem = 0;
    memset((char *)negCacheEntries,0,sizeof(negCacheEntries));
    for (i = 0; i < 8; i++) {
        ncp = (negEntry_t *)pal_alloc(allocSize * sizeof(*ncp));
        if ((ncp == NULL) && (i == 0)) {

            allocSize = 1024 / 8;
            ncp = (negEntry_t *)pal_alloc(sizeof(*ncp) * allocSize);
        }

        if (ncp) {
            negCacheSize += allocSize;
            cacheMem += (allocSize * sizeof(*ncp));
            negCacheEntries[i] = ncp;




            memset((char *)ncp,0,sizeof(*ncp) * allocSize);
            for (j = 0; j < allocSize; j++, ncp++) {
                ((&ncp->hq)->next = (&ncp->hq)->prev = (&ncp->hq));
                ncp->hashIndex = -1;
                ((&ncp->lruq)->next = (((kutil_q_t *)&negCacheLruQ)->next), (&ncp->lruq)->prev = (&negCacheLruQ), (((kutil_q_t *)&negCacheLruQ)->next)->prev = (&ncp->lruq), (&negCacheLruQ)->next = (&ncp->lruq));
            }
        } else {
            break;
        }
    }

    negCacheAllocSize = allocSize;
    kpcFileStats.ncSize = negCacheSize;
    for (np = negCacheSeeds; np && *np; np++) {
        flags = 0;
        rc = pal_LookupFidAndDir(*np, 0x1,
                                 &rf, NULL, &fattr, &flags);
        if ((rc == 0) && (flags & 0x1)) {
            kpcf_negCacheAdd(&rf);
        }
    }
}
static void
negCacheShutdown(void)
{
    int i;

    (kail_iclock_lock(&negCacheLock));
    negCacheFlushAll();
    ((&negCacheLruQ)->next = (&negCacheLruQ)->prev = (&negCacheLruQ));
    (kail_iclock_unlock(&negCacheLock));

    for (i = 0; i < 8; i++) {
        if (negCacheEntries[i] != NULL) {
            pal_free(negCacheEntries[i],
                     negCacheAllocSize * sizeof(negEntry_t));
        }
    }
}
typedef struct _nhq {
    kutil_q_t q;
    int count;
} nameHash_t;




static nameHash_t nameHashQ[829];
void
kpcf_nameHashInsert(fileRes_t *fresp, int idx)
{
    nameHash_t *hp;


    ;
    hp = &nameHashQ[idx];
    ((&fresp->nameHashQ)->next = (((kutil_q_t *)&hp->q)->next), (&fresp->nameHashQ)->prev = (&hp->q), (((kutil_q_t *)&hp->q)->next)->prev = (&fresp->nameHashQ), (&hp->q)->next = (&fresp->nameHashQ));
    hp->count++;




}
void
kpcf_nameHashRemove(fileRes_t *fresp)
{
    if (!((((kutil_q_t *)&fresp->nameHashQ)->next) == (kutil_q_t *)&fresp->nameHashQ)) {
        (((&fresp->nameHashQ)->next)->prev = ((&fresp->nameHashQ)->prev), ((&fresp->nameHashQ)->prev)->next = ((&fresp->nameHashQ)->next));
    }
}
fileRes_t *
kpcf_nameHashSearch(char *name, int idx)
{
    int nlen;
    fileRes_t *fresp;
    nameHash_t *hp;
    kutil_q_t *qp;


    ;
    hp = &nameHashQ[idx];
    nlen = strlen(name);

    for (qp = (((kutil_q_t *)&hp->q)->next);
         qp != &hp->q; qp = ((qp)->next)) {
        fresp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, nameHashQ)));
        if ((nlen == fresp->resNameLen) &&
            strcmp(name, fresp->resName) == 0) {
            return fresp;
        }
    }
    return NULL;
}
static int
doNameHash(char *name)
{
    unsigned int h = 0;
    int len = strlen(name);

    if (len) {
        h = (len + (*name << 8) + name[len - 1]);
        if (len > 6)
            h += (name[1] + (name[3] << 12) + name[5] + name[6]);
        h %= 829;
    }
    return h;
}
int
kpcf_findResByResName(char *resName, fileRes_t **retResp, int *hashValue)
{

    int nh, rc, strLen = 0;
    char nameBuf[60], *bName;


    ;
    *retResp = NULL;
    rc = kutil_setStringWithLocal(resName, &strLen,
                                  nameBuf, sizeof(nameBuf), &bName);
    if (rc == 0) {
        kutil_pathBaseName(bName);
        nh = doNameHash(bName);
        *hashValue = nh;
        *retResp = kpcf_nameHashSearch(resName, nh);
        kutil_freeStringWithLocal(bName, nameBuf, strLen);
    }

    return rc;
}
int
kpcf_findFidByFidOnly(fresList_t *frlp)
{
    pal_rawFid_t *rfidp = frlp->rFidp;
    fileRes_t *rp, *found;
    kutil_q_t *qp;


    (kail_mutex_lock(&fileDbLock));
    for (qp = (((kutil_q_t *)&kpcf_refreshQ)->next); ((qp) != &kpcf_refreshQ); qp = ((qp)->next)) {
        rp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, refreshQ)));
        if (((rp)->intFlags & 0x1) && (((((!memcmp((&(((&rp->rfid)))->fid),(&(((rfidp)))->fid),((&(((&rp->rfid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&rp->rfid)))->fsid)->val[0] == (&(((rfidp)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            found = rp;




            if (((found)->intFlags & 0x200) && found->plink) {
                found = found->plink;
            }
            if (!((found)->intFlags & 0x20)) {
                fresListAdd(frlp, found);
            }
        }
    }
    (kail_mutex_unlock(&fileDbLock));

    return frlp->count;
}
int
kpcf_dumpResources(kpc_fdumpRec_t *records, int *numFound, int *retCookie)
{
    int i = 0, rc = 0, count = 0, cookie = 0, size=0;
    int lastHashCount = 0, isFull = 0;
    int nlen, doPrefix;
    kutil_q_t *qp;
    fileRes_t *fp;
    char *namep,*ptrval;
    char *prefix = "....";
    kpc_fdumpRec_t *recp = records;


    if ((*retCookie < 0) || (*retCookie >= 829)) {
        return EINVAL;
    }

    if (*retCookie) {
        i = *retCookie;
    }

    size = sizeof(void *);
    (kail_mutex_lock(&fileDbLock));
    for (; (i < 829) && !isFull && !rc;i++) {
        for (qp = (((kutil_q_t *)&nameHashQ[i].q)->next);
            qp != &nameHashQ[i].q; qp = ((qp)->next)) {
            fp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, nameHashQ)));
            rc = pal_copyout((char *)&fp->rflags,
                             (char *)&recp->resFlags, sizeof(uint32_t));
            if (rc == 0) {
                rc = pal_copyout((char *)&fp->intFlags,
                                 (char *)&recp->intResFlags, sizeof(uint32_t));
            }
            if (rc == 0) {
                rc = pal_copyout((char *)&fp->branchId,
                                 (char *)&recp->branchId, sizeof(uint32_t));
            }
            if (rc == 0) {
                rc = pal_copyout((char *)&(size),
                                 (char *)&recp->pointerSize,sizeof(uint32_t));
            }
            if (rc == 0) {


                if (size == 4) {
                    rc = pal_copyout((char *)&fp,
                                     (char *)&(recp->resPtr.low), size);
                    if (rc == 0) {
                        ptrval = (char *)&(fp->rfid);
                        rc = pal_copyout((char *)&ptrval,
                                         (char *)&(recp->rfidPtr.low), size);
                    }
                    if (rc == 0) {
                        ptrval = (char *)&(fp->dir_rfid);
                        rc = pal_copyout((char *)&ptrval,
                                         (char *)&(recp->dfidPtr.low), size);
                    }
                } else {
                    rc = pal_copyout((char *)&fp,
                                     (char *)&(recp->resPtr), size);
                    if (rc == 0) {
                        ptrval = (char *)&(fp->rfid);
                        rc = pal_copyout((char *)&ptrval,
                                         (char *)&(recp->rfidPtr), size);
                    }
                    if (rc == 0) {
                        ptrval = (char *)&(fp->dir_rfid);
                        rc = pal_copyout((char *)&ptrval,
                                         (char *)&(recp->dfidPtr), size);
                    }
                }
            }
            if (rc == 0) {
                doPrefix = 0;
                namep = fp->resName;
                nlen = fp->resNameLen + 1;
                if (nlen > 156) {
                    namep += (nlen - 156);
                    nlen = 156;
                    doPrefix = 1;
                }
                rc = pal_copyout(namep, recp->resName, nlen);

                if (doPrefix && (rc == 0)) {
                    rc = pal_copyout(prefix, recp->resName, strlen(prefix));
                }
            }

            if (rc) {
                break;
            } else {
                recp++;
                count++;
                if (count >= 3072) {
                    isFull = 1;
                    cookie = i;
                    count = lastHashCount;
                    if (cookie == 0) {
                        rc = E2BIG;
                    }
                    break;
                }
            }
        }
        lastHashCount = count;
    }
    (kail_mutex_unlock(&fileDbLock));

    *retCookie = cookie;
    *numFound = count;
    return rc;
}
int
kpcf_getResInfoByResName(kpc_record_t *recp)
{
    fileRes_t *frp;
    int rc, t, found = 0;


    (kail_mutex_lock(&fileDbLock));
    rc = kpcf_findResByResName(recp->kpon, &frp, &t);
    if (frp && (rc == 0)) {
        found = 1;
        recp->flags = frp->rflags;
        recp->branchId = frp->branchId;
        recp->howFound = 0x1000;
        if ((t = recp->extDataLen = frp->extDataLen)) {
            if (t > 6144) {
                t = 6144;
            }
            memcpy(recp->extData,frp->extData,t);
        }
    }
    (kail_mutex_unlock(&fileDbLock));

    return found;
}


int noSyms(char *path, int length)
{
  char *copy;
  char *insert;
  pal_rawFid_t rf;
  pal_fattr_t fattr;
  int flags;

  if (!path) {
    return 1;
  }

  if (*path == '\0') {
    return 1;
  }

  copy = pal_alloc(length+1);
  if (copy) {
    strcpy(copy,path);
  } else {
    return 1;
  }

  while (pal_LookupFidAndDir(copy, (0x2|0x8),
                             &rf, NULL, &fattr, &flags)
         ) {

    insert = strrchr(copy,'/');
    *insert = '\0';
    if (*copy == '\0') {
      pal_free(copy,length+1);
      return 1;
    }
  }

  pal_free(copy,length+1);
  return 0;
}
void
kpcf_checkForFidAliases(kutil_q_t *searchQ, fileRes_t *resp)
{
    int foundAlias = 0;
    fileRes_t *rp;
    kutil_q_t *qp;
    pal_rawFid_t *nFidp = &resp->rfid;


    for (qp = (((kutil_q_t *)searchQ)->next); qp != searchQ; qp = ((qp)->next)) {
        rp = (fileRes_t *)((char *)qp - (offsetof(fileRes_t, dirFidHashQ)));
        if(((rp)->intFlags & 0x1) && (((((!memcmp((&(((nFidp)))->fid),(&(((&rp->rfid)))->fid),((&(((nFidp)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((nFidp)))->fsid)->val[0] == (&(((&rp->rfid)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {
            foundAlias++;
            if ((rp->nlinks == 1) && (noSyms(rp->resName,rp->resNameLen))) {
              (kail_mutex_lock(&(rp)->rLock));
              ((rp)->intFlags |= 0x800);
              ((rp)->intFlags |= 0x1000);
              (kail_mutex_unlock(&(rp)->rLock));
            } else {

              (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_SET_ALIAS, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)(rp), (long)resp, (long)qp),0) : 0);


              (kail_mutex_lock(&(rp)->rLock));
              ((rp)->intFlags |= 0x800);
              (kail_mutex_unlock(&(rp)->rLock));
            }
        }
    }

    if (foundAlias) {
      if ((resp->nlinks == 1) && (noSyms(resp->resName, resp->resNameLen))) {
        (kail_mutex_lock(&(resp)->rLock));
        ((resp)->intFlags |= 0x800);
        ((resp)->intFlags |= 0x1000);
        (kail_mutex_unlock(&(resp)->rLock));
      } else {

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[4])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[4], KT_TRACE_KAZN_HAS_ALIAS, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)(resp), (long)foundAlias, (long)qp),0) : 0);


        (kail_mutex_lock(&(resp)->rLock));
        ((resp)->intFlags |= 0x800);
        (kail_mutex_unlock(&(resp)->rLock));
      }
    }
}
void
kpcf_subrInit(void)
{
    int i;


    kazn_kpcfInitFileLkupControl();
    (kail_mutex_init(&fileDbLock));

    kpcFileStats.padB =
        kpcFileStats.padC = kpcFileStats.padD = 0xffffffff;

    kpcf_pfcInit();

    ((&kpcf_refreshQ)->next = (&kpcf_refreshQ)->prev = (&kpcf_refreshQ));
    (kail_iclock_init(&kpcf_refreshGenLock));

    for (i = 0; i < 829; i++) {
        ((&nameHashQ[i].q)->next = (&nameHashQ[i].q)->prev = (&nameHashQ[i].q));
        nameHashQ[i].count = 0;
    }

    negCacheInit();
}
void
kpcf_subrShutdown(void)
{
    kpcf_pfcShutdown();
    negCacheShutdown();
}
