
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)49	1.4.1.20  src/oss/kazn/kenv/kenv_path.c, oss.kazn.src, oss600, 051207a  12/2/05  15:59:44";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
int kenv_pathDebug = 0 ;

static char zeros[128] = { 0 };

typedef struct kenv_pathMemStats {
    uint32_t waits;
    uint32_t longWaits;
    uint32_t maxWaitCount;
    uint32_t curWaitCount;
    pal_time_t timeCheck;
} kenv_pathMemStats_t;
kenv_pathMemStats_t memStats = { 0 };
typedef struct kenv_pathReq {
    kutil_q_t q;
    pal_mutex_t mutex;
    pal_cond_t cond;

    uint32_t tag, shmOffset;

    pal_pid_t pid;
    char *path;
    int len;
    uint16_t flags;
    uint16_t state;
    pal_time_t tstamp;
} kenv_pathReq_t;
uint32_t kenv_pathMemSerial=0,kenv_pathMemServiceId=0;
typedef struct kenv_pathMem {
    pal_mutex_t workMutex, freeMutex, reclaimMutex;
    pal_cond_t workCond, freeCond;
    kenv_pathReq_t *pool;
    kutil_q_t freeQ,workQ,reclaimQ;
    pal_time_t checkTime,waitTime;
    int id;
    uint32_t memp;
    uint16_t flags;
    uint16_t buckets;
    uint32_t bucketSize;
    uint32_t size;
    uint16_t waiters;
    uint16_t used;


    uint16_t use2;
    uint16_t helpers;
} kenv_pathMem_t;

kenv_pathMem_t kenv_pathMemState = { 0 };

typedef struct kenv_pathMemOldPool {
    kutil_q_t q;
    uint32_t used, poolSize;
    kenv_pathReq_t *pool;
} kenv_pathMemOldPool_t;
kutil_q_t kenv_pathMemOldPools;
pal_mutex_t kenv_pathMemOldPoolsMutex;







int
kenv_pathGetShmid()
{
    if (kenv_pathMemState.flags & 0x0002) {
        return(kenv_pathMemState.id);
    } else {
        return(-1);
    }
}






uint32_t
kenv_pathGetMemSerial()
{
    return(kenv_pathMemSerial);
}
int
kenv_pathMemCurrent(uint32_t serial)
{
    if (serial == kenv_pathMemSerial) {
        return(1);
    } else {
        return(0);
    }
}
pal_time_t nextPoolScanTime=0;
int
kenv_pathMemPoolScan(void)
{
    int found=0, i;
    pal_time_t now;
    kenv_pathReq_t *pReqNode = (kenv_pathReq_t *)NULL;

    now = ((pal_time_t)(kail_xtime->tv_sec));
    if (nextPoolScanTime) {

        if (now < nextPoolScanTime) {

            ;

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 4) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMREQ_SCAN_DELAY, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)now), (long)(int)nextPoolScanTime),0) : 0);


            return(found);
        }
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMREQ_SCAN_NOW, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)now), (long)(int)nextPoolScanTime),0) : 0);

    ;







    (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

    for (i=0; i<kenv_pathMemState.buckets; i++) {
        int reclaimElem = 0;

        pReqNode = &(kenv_pathMemState.pool[i]);
        if (pReqNode->state == 0x0002) {
            if (!kail_check_pid((int)(pReqNode->pid))) {

                reclaimElem = kenv_procClearExecData(pReqNode->pid);
                ;

                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMREQ_REC_NOPID, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(i), (long)(int)pReqNode->pid),0) : 0);


            } else if (now > (pReqNode->tstamp + 10)) {

                ;


                reclaimElem = kenv_procClearExecData(pReqNode->pid);
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMREQ_REC_EXP, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(i), (long)(int)pReqNode->pid, (long)(now - pReqNode->tstamp)),0) : 0);



            }

            if (reclaimElem) {
                (kail_mutex_lock(&(kenv_pathMemState.reclaimMutex)));
                ;

                pReqNode->state = 0x0008;
                pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
                ((&(pReqNode->q))->next = (&(kenv_pathMemState.reclaimQ)), (&(pReqNode->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->prev)->next = (&(pReqNode->q)), (&(kenv_pathMemState.reclaimQ))->prev = (&(pReqNode->q)));
                found++;
                (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));
            }
        }
    }

    if (found) {



        (kail_wake_up(&(kenv_pathMemState.workCond)));
        nextPoolScanTime = 0;
        ;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event1((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMREQ_SCAN_RET, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(found)),0) : 0);

    } else {



        nextPoolScanTime = now + 30;
    }


    (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));

    return(found);
}
void
kenv_pathMemServiceReqs(uint32_t flags, uint32_t id)
{
    kenv_pathReq_t *pReq;
    int rc;


    while (!(kenv_pathMemState.flags & (0x0004|0x0008))) {


        pal_time_t now;

        while(((((kutil_q_t *)&(kenv_pathMemState.workQ))->next) == (kutil_q_t *)&(kenv_pathMemState.workQ)) &&
              (((((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->next) == (kutil_q_t *)&(kenv_pathMemState.reclaimQ)) ||
               (kenv_pathMemState.flags & 0x0040)) &&
              !(kenv_pathMemState.flags & (0x0004|0x0008))) {
            ;
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 9) ? (kt_Event1((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_SHMEM_SRVT_WAIT, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(id)),0) : 0);




            (kail_cond_wait(&(kenv_pathMemState.workCond),&(kenv_pathMemState.workMutex)));

            if (flags & 0x0002) {
                now = ((pal_time_t)(kail_xtime->tv_sec));

                if (!(kenv_pathMemState.flags & 0x0020) &&
                    (now > (kenv_pathMemState.checkTime +
                            10))) {
                    ;

                    kenv_pathMemState.flags |= 0x0020;
                    kenv_pathMemState.checkTime = now;
                    return;
                }
            }
        }


        if (kenv_pathMemState.flags & (0x0004|0x0008)) break;


        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 9) ? (kt_Event1((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_SHMEM_SRVT_PROC, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(id)),0) : 0);

        ;
        while (!((((kutil_q_t *)&(kenv_pathMemState.workQ))->next) == (kutil_q_t *)&(kenv_pathMemState.workQ))) {
            pReq = (kenv_pathReq_t *)(((kutil_q_t *)&(kenv_pathMemState.workQ))->next);
            (((&(pReq->q))->next)->prev = ((&(pReq->q))->prev), ((&(pReq->q))->prev)->next = ((&(pReq->q))->next));
            ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));


            (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));

            if (pReq->state != 0x0001) {

                ;


                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_SHMEM_SRVT_INVNODE, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(pReq->tag), (long)pReq, (long)pReq->state),0) : 0);



                ;
                pReq->state = 0x0000;
                pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
                pReq->pid = -1;
                pReq->len = 0;
                pReq->path = (char *)NULL;
                ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));
                (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
                ((&(pReq->q))->next = (&(kenv_pathMemState.freeQ)), (&(pReq->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev)->next = (&(pReq->q)), (&(kenv_pathMemState.freeQ))->prev = (&(pReq->q)));





                if (pReq->flags & 0x0001) {
                    (kenv_pathMemState.use2)--;
                    pReq->flags &= ~(0x0001);
                }
                (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
                (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
                continue;
            }

            ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));

            rc = pal_copyout(pReq->path,
                             (char *)(kenv_pathMemState.memp+
                                      pReq->shmOffset),
                             pReq->len);
            (kail_mutex_lock(&(pReq->mutex)));
            if (rc) {
                ;

                pReq->state = 0x0004;
                pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_SHMEM_SRVT_ERRCOPY, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(rc), (long)pReq->tag, (long)pReq->shmOffset),0) : 0);



                rc = 5;
            } else {

                ;

                pReq->state = 0x0002;
                pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
                rc = 0;
            }
            (kail_mutex_unlock(&(pReq->mutex)));


            ;

            (kail_wake_up(&(pReq->cond)));




            (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
        }



        if (!(kenv_pathMemState.flags & 0x0040)) {
            kenv_pathMemState.flags |= 0x0040;

            (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));


            (kail_mutex_lock(&(kenv_pathMemState.reclaimMutex)));
            while (!((((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->next) == (kutil_q_t *)&(kenv_pathMemState.reclaimQ))) {
                pReq=(kenv_pathReq_t *)
                    (((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->next);
                ;


                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 9) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_SHMEM_SRVT_RECLAIM, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(id), (long)pReq->tag, (long)pReq->shmOffset),0) : 0);


                (((&(pReq->q))->next)->prev = ((&(pReq->q))->prev), ((&(pReq->q))->prev)->next = ((&(pReq->q))->next));
                ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));

                (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));

                ;

                rc = pal_copyout(zeros,
                                 (char *)
                                 (kenv_pathMemState.memp+pReq->shmOffset),
                                 128);
                if (rc != 0) {
                    ;

                }
                pReq->state = 0x0000;
                pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
                pReq->pid = -1;


                (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
                ;
                (kenv_pathMemState.used)--;



                if (pReq->flags & 0x0001) {
                    (kenv_pathMemState.use2)--;
                    pReq->flags &= ~(0x0001);
                }
                ((&(pReq->q))->next = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next), (&(pReq->q))->prev = (&(kenv_pathMemState.freeQ)), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next)->prev = (&(pReq->q)), (&(kenv_pathMemState.freeQ))->next = (&(pReq->q)));
                (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
                (kail_wake_up(&(kenv_pathMemState.freeCond)));


                (kail_mutex_lock(&(kenv_pathMemState.reclaimMutex)));
            }
            (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));


            (kail_mutex_lock(&(kenv_pathMemState.workMutex)));

            kenv_pathMemState.flags &= ~(0x0040);
        }


        if (flags & 0x0001) {
            int rc2=0;



            kenv_pathMemState.waitTime = ((pal_time_t)(kail_xtime->tv_sec));
            while ((kenv_pathMemState.flags & 0x0020) &&
                   (rc2 != 2)) {
                ;





                rc2 = (kail_condTimedWait(&(kenv_pathMemState.workCond),&(kenv_pathMemState.workMutex),3,0));
                if (!kenv_pathMemState.waitTime) {



                    break;
                }
                now = ((pal_time_t)(kail_xtime->tv_sec));


                if ((now - kenv_pathMemState.waitTime) >
                    3) {
                    break;
                }
            }
            if ((kenv_pathMemState.flags & 0x0020) &&
                kenv_pathMemState.waitTime) {



                kenv_pathMemState.flags |=
                    (0x0004|0x0080);
                ;


            }
        }

    }


}
int
kenv_pathMemService()
{
    kutil_q_t *iter, *next;
    int rc = 0, rc2, elem;





    if (!(kenv_pathMemState.flags & (0x0001|0x0008))) {
        return(3);
    }
    memset(zeros,0,128);

    (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
    if (kenv_pathMemState.flags & 0x0008) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_SRVT_START, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(kenv_pathMemState.flags), (long)kenv_pathMemSerial),0) : 0);



        kenv_pathMemState.flags &= ~(0x0008);
    } else {


        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_SRVT_START, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(kenv_pathMemState.flags), (long)kenv_pathMemSerial),0) : 0);


    }


    kenv_pathMemState.flags = 0x0002;
    kenv_pathMemServiceId = 1;


    kenv_pathMemServiceReqs(0x0001,kenv_pathMemServiceId);


    if ((kenv_pathMemState.flags & 0x0008) &&
        (rc == 0)) {
        (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));


        rc = 2;
        return(rc);
    }





    if (kenv_pathMemState.flags & 0x0080) {
        rc = 9;
    }


    ;

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event0((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_SRVT_STOP, (((0)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16))),0) : 0);


    kenv_pathMemState.flags &= ~(0x0002);
    for (iter=(((kutil_q_t *)&(kenv_pathMemState.workQ))->next);
         iter != &(kenv_pathMemState.workQ);
         iter = next) {

        kenv_pathReq_t *pReq = (kenv_pathReq_t *)iter;
        next = ((iter)->next);
        ;

        (((&(pReq->q))->next)->prev = ((&(pReq->q))->prev), ((&(pReq->q))->prev)->next = ((&(pReq->q))->next));
        ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));
        pReq->state = 0x0004;
        pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));


        (kail_wake_up(&(pReq->cond)));

    }
    (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));

    (kail_wake_up(&(kenv_pathMemState.workCond)));


    (kail_wake_up(&(kenv_pathMemState.freeCond)));




    (kail_mutex_lock(&(kenv_pathMemState.reclaimMutex)));
    for (iter=(((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->next);
         iter != &(kenv_pathMemState.reclaimQ); iter = next) {

        kenv_pathReq_t *pReq = (kenv_pathReq_t *)iter;
        next = ((iter)->next);
        ;

        (((&(pReq->q))->next)->prev = ((&(pReq->q))->prev), ((&(pReq->q))->prev)->next = ((&(pReq->q))->next));

        ;
        ((&(pReq->q))->next = (&(pReq->q))->prev = (&(pReq->q)));
        pReq->state = 0x0000;
        pReq->tstamp = ((pal_time_t)(kail_xtime->tv_sec));



        (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
        ((&(pReq->q))->next = (&(kenv_pathMemState.freeQ)), (&(pReq->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev)->next = (&(pReq->q)), (&(kenv_pathMemState.freeQ))->prev = (&(pReq->q)));
        ;
        (kenv_pathMemState.used)--;



        if (pReq->flags & 0x0001) {
            (kenv_pathMemState.use2)--;
            pReq->flags &= ~(0x0001);
        }
        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
    }
    (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));






    (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
    rc2 = 0;
    while ((kenv_pathMemState.used != 0) && (rc2 != 2)) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_SRVT_WAIT, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(kenv_pathMemState.used), (long)kenv_pathMemState.buckets),0) : 0);


        ;




        rc2 = (kail_condTimedWait(&(kenv_pathMemState.freeCond),&(kenv_pathMemState.freeMutex),10,0));
    }
    if (rc2 == 2) {
        ;

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event1((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_SRVT_WAITERR, (((2)<<28) + ((0)<<24) + ((0)<<20) + ((0)<<16)), (long)(kenv_pathMemState.used)),0) : 0);


        if (rc == 0) {
            rc = 6;
        }
    }

    (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

    return(rc);
}
int
kenv_pathMemHelper(int flags, uint32_t *pID)
{
    int rc = 0, rc2, elem;




    ;


    if (!(kenv_pathMemState.flags & (0x0002|0x0080))) {
      if (kenv_pathMemState.flags & 0x0010) {
        return(3);
      }
    }

    if (!(kenv_pathMemState.flags & 0x0002)) {
        ;

        pal_delay(1000);
        return(2);
    }

    (kail_mutex_lock(&(kenv_pathMemState.workMutex)));

    if (flags & 0x0002) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_HELPER_RESTART, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(*pID), (long)flags, (long)kenv_pathMemState.flags),0) : 0);



        while (kenv_pathMemState.flags&(0x0008)) {
            ;

            (kail_cond_wait(&(kenv_pathMemState.workCond),&(kenv_pathMemState.workMutex)));

        }
    } else {
        while (!(kenv_pathMemState.flags &
                 (0x0002|0x0004))) {
            ;

            (kail_cond_wait(&(kenv_pathMemState.workCond),&(kenv_pathMemState.workMutex)));

        }
    }

    if (kenv_pathMemState.flags & (0x0004|0x0008)) {
        ;

        (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));
        return(2);
    }

    if (flags & (0x0002|0x0004)) {

        if (kenv_pathMemState.flags & 0x0002) {
            if (flags & 0x0002) {
                ;

            } else {
                ;


                kenv_pathMemState.flags &= ~(0x0020);

                kenv_pathMemState.waitTime = 0;
                (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));
                (kail_wake_up(&(kenv_pathMemState.workCond)));
                (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
            }
        }
    } else {

        kenv_pathMemServiceId++;
        *pID = kenv_pathMemServiceId;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_HELPER_START, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(*pID), (long)flags, (long)kenv_pathMemState.flags),0) : 0);


        ;
    }


    kenv_pathMemState.checkTime = ((pal_time_t)(kail_xtime->tv_sec));

    (kenv_pathMemState.helpers)++;

    kenv_pathMemServiceReqs(0x0002,*pID);

    (kenv_pathMemState.helpers)--;

    if ((kenv_pathMemState.flags & 0x0008) &&
        (rc == 0)) {


        rc = 2;
    } else if (kenv_pathMemState.flags & 0x0020) {

        rc = 7;
    } else if (kenv_pathMemState.flags & 0x0004) {

        rc = 0;
    } else {
        rc = 8;
    }
    (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));
    if (rc == 7) {



        (kail_wake_up(&(kenv_pathMemState.workCond)));
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_DBG_SHMEM_HELPER_CHECK, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(*pID), (long)rc, (long)kenv_pathMemState.flags),0) : 0);


        ;

    } else {
        if (kenv_pathMemState.flags & 0x0004) {


            (kail_wake_up(&(kenv_pathMemState.workCond)));
        }
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_HELPER_RETURN, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(*pID), (long)rc, (long)kenv_pathMemState.flags),0) : 0);


    }

    return(rc);
}
void
kenv_pathMemStop(int shutdown)
{
    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_STOP, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(shutdown), (long)kenv_pathMemState.flags),0) : 0);


    if (!(kenv_pathMemState.flags & 0x0002)) {

        ;

        return;
    }


    (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
    if (shutdown) {
        kenv_pathMemState.flags |= 0x0004;
    } else {
        kenv_pathMemState.flags |= 0x0008;
    }

    (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));


    (kail_wake_up(&(kenv_pathMemState.workCond)));
    ;
}
void
kenv_pathMemCheckOldPools(kenv_pathReq_t *pReqNode)
{
    int found = 0;
    kutil_q_t *QIter, *QNext;
    kenv_pathMemOldPool_t *oldPoolP;

    ;


    (kail_mutex_lock(&(kenv_pathMemOldPoolsMutex)));





    for (QIter = (((kutil_q_t *)&(kenv_pathMemOldPools))->next);
         (QIter != &(kenv_pathMemOldPools) && (!found));
         QIter = QNext) {
        oldPoolP = (kenv_pathMemOldPool_t *)QIter;
        QNext = QIter->next;
        ;

        if ( &(oldPoolP->pool[pReqNode->tag]) == pReqNode ) {
            found = 1;
            ;

        }
    }

    if (found) {
        ;
        (oldPoolP->used)--;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= (oldPoolP->used ? 3: 1)) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_OLDPOOL_DEC, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((2)<<16)), (long)(pReqNode), (long)oldPoolP->pool, (long)oldPoolP, (long)oldPoolP->used),0) : 0);



        if (oldPoolP->used == 0) {
            ;

            (((&(oldPoolP->q))->next)->prev = ((&(oldPoolP->q))->prev), ((&(oldPoolP->q))->prev)->next = ((&(oldPoolP->q))->next));
            pal_free(oldPoolP->pool, oldPoolP->poolSize);
            pal_free(oldPoolP, sizeof(kenv_pathMemOldPool_t));
        }
    }


    (kail_mutex_unlock(&(kenv_pathMemOldPoolsMutex)));
}
int
kenv_pathMemCheckWaitIfUse2(uint16_t pathFlags)
{
    int waits = 0, rc = 0;

    if (pathFlags & 0x0001) {





        while (
               (((kenv_pathMemState.use2 + 1) >= kenv_pathMemState.buckets) ||
                (((((kutil_q_t *)&(kenv_pathMemState.freeQ))->next) == (kutil_q_t *)&(kenv_pathMemState.freeQ)))
               ) &&
               (kenv_pathMemState.flags & 0x0002)
              ) {



            ;


            (kail_cond_wait(&(kenv_pathMemState.freeCond),&(kenv_pathMemState.freeMutex)));

            waits++;
        }
        ;
        if (!(kenv_pathMemState.flags & 0x0002)) {
            rc = 1;
        }
    }
    return(rc);
}
int
kenv_pathMemGet(char *path, int len, kenv_pathMemInfo_t *pMemInfo)
{
    int waits = 0, rc = 0;
    kenv_pathReq_t *pReqNode = (kenv_pathReq_t *)NULL;
    pal_pid_t lpid=kail_pid_get_epid(kail_current_tid());

    pMemInfo->handle = (kenv_pathReqHandle_t)NULL;



    if (!(kenv_pathMemState.flags & 0x0002)) {

        ;




        pMemInfo->pathFlags = 0x0200;
        if (kenv_pathMemState.flags & 0x0080) {
            return -1;
        }
        return 0;
    }


    if (len > kenv_pathMemState.bucketSize) {
        pMemInfo->pathFlags = (0x0200|0x0800);
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_TOOBIG, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(len), (long)kenv_pathMemState.bucketSize),0) : 0);

        return -1;
    } else if (len == 0) {

        ;
        pMemInfo->pathFlags = 0x0200;
        return 0;
    }


    (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));

    if (kenv_pathMemState.used > kenv_pathMemState.buckets) {
        ;
    }




    while ((kenv_pathMemState.used == kenv_pathMemState.buckets) &&
           (kenv_pathMemState.flags & 0x0002)) {







        if (!(((((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->next) == (kutil_q_t *)&(kenv_pathMemState.reclaimQ)))) {
            (kail_wake_up(&(kenv_pathMemState.workCond)));
        } else {







            if (kenv_pathMemPoolScan()) {



                continue;
            }
        }


        (kenv_pathMemState.waiters)++;
        waits++;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_WAIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(len), (long)kenv_pathMemState.waiters, (long)waits),0) : 0);


        ;

        (kail_cond_wait(&(kenv_pathMemState.freeCond),&(kenv_pathMemState.freeMutex)));

        (kenv_pathMemState.waiters)--;
    }




    if (!(kenv_pathMemState.flags & 0x0002)) {

        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

        ;


        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_STOPPED, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(lpid), (long)kenv_pathMemState.flags),0) : 0);



        pMemInfo->pathFlags = 0x0200;
        return 0;
    }

    if (((((kutil_q_t *)&(kenv_pathMemState.freeQ))->next) == (kutil_q_t *)&(kenv_pathMemState.freeQ))) {
        ;

        pMemInfo->pathFlags = 0x0400;
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_NOFREE, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(lpid), (long)kenv_pathMemState.used),0) : 0);

        rc = -1;
    } else {
        rc = kenv_pathMemCheckWaitIfUse2(pMemInfo->pathFlags);
        if (rc) {

                (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
                return(rc);
        }


        pReqNode = (kenv_pathReq_t *)((((kutil_q_t *)&(kenv_pathMemState.freeQ))->next));
        (((&(pReqNode->q))->next)->prev = ((&(pReqNode->q))->prev), ((&(pReqNode->q))->prev)->next = ((&(pReqNode->q))->next));
        ((&(pReqNode->q))->next = (&(pReqNode->q))->prev = (&(pReqNode->q)));
        ;
        (kenv_pathMemState.used)++;




        if (pMemInfo->pathFlags & 0x0001) {
            (kenv_pathMemState.use2)++;
            pReqNode->flags |= 0x0001;
        }
        pMemInfo->memSerial = kenv_pathMemSerial;
    }


    (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

    ;

    if (pReqNode && ((pReqNode->state != 0x0000) ||
                     (pReqNode->pid != -1))) {
        ;

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_INVNODE, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(lpid), (long)pReqNode->tag, (long)pReqNode->state, (long)pReqNode->pid),0) : 0);


        ;

        (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
        ;
        (kenv_pathMemState.used)--;
        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
        pMemInfo->pathFlags = 0x0400;
        rc = -1;
    }

    if (rc == 0) {
        ;



        if (pMemInfo->pathFlags & 0x0100) {
            pReqNode->path = path;
            pReqNode->len = len;
        } else {
            pReqNode->path = (char *)pal_alloc(len);
            if (!pReqNode->path) {
                pMemInfo->pathFlags = 0x0200;
                rc = -1;
            } else {
                memcpy(pReqNode->path,path,len);
                pReqNode->len = len;
            }
        }

        if (rc == 0) {

            pReqNode->pid = lpid;
            pReqNode->state = 0x0001;
            pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));


            (kail_mutex_lock(&(kenv_pathMemState.workMutex)));


            if ((kenv_pathMemState.flags & 0x0002) &&
                (pMemInfo->memSerial == kenv_pathMemSerial)) {
                ((&(pReqNode->q))->next = (&(kenv_pathMemState.workQ)), (&(pReqNode->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.workQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.workQ))->prev)->next = (&(pReqNode->q)), (&(kenv_pathMemState.workQ))->prev = (&(pReqNode->q)));

                (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));

                (kail_wake_up(&(kenv_pathMemState.workCond)));
                pMemInfo->handle = (void *)pReqNode;




            } else {
                ;


                pMemInfo->pathFlags = 0x0200;
                if (kenv_pathMemSerial != pMemInfo->memSerial) {





                    kenv_pathMemCheckOldPools(pReqNode);
                    pReqNode = (kenv_pathReq_t *)NULL;
                    rc = -1;
                } else {
                    pReqNode->state = 0x0004;
                    pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));




                    if (kenv_pathMemState.flags & 0x0080) {
                        rc = -1;
                    }
                }
                (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));
            }
        }
    }

    if ((rc || (pMemInfo->pathFlags == 0x0200)) && pReqNode) {





        ;
        ;
        pReqNode->pid = -1;
        pReqNode->path = (char *)NULL;
        pReqNode->len = 0;
        pReqNode->state = 0x0000;
        pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
        (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
        ((&(pReqNode->q))->next = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next), (&(pReqNode->q))->prev = (&(kenv_pathMemState.freeQ)), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next)->prev = (&(pReqNode->q)), (&(kenv_pathMemState.freeQ))->next = (&(pReqNode->q)));
        ;
        (kenv_pathMemState.used)--;



        if (pReqNode->flags & 0x0001) {
            (kenv_pathMemState.use2)--;
            pReqNode->flags &= ~(0x0001);
        }
        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

        (kail_wake_up(&(kenv_pathMemState.freeCond)));
    }

    ;


    return(rc);
}
int
kenv_pathMemWaitReady(kenv_pathMemInfo_t *pMemInfo)
{
    kenv_pathReq_t *pReqNode = (kenv_pathReq_t *)pMemInfo->handle;
    int rc = 0;

    if (!pReqNode) return(-1);




    if (kenv_pathMemState.flags & (0x0010|0x0004)) {
        ;

        pMemInfo->pathFlags = 0x0200;
        return(0);
    }


    if (pMemInfo->memSerial != kenv_pathMemSerial) {
        ;

        pMemInfo->pathFlags = 0x0200;
        return(0);
    }


    (kail_mutex_lock(&(pReqNode->mutex)));
    while (pReqNode->state == 0x0001) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_RQWAIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(((int)kail_pid_get_epid(kail_current_tid()))), (long)pReqNode->tag, (long)pReqNode->len, (long)pReqNode->shmOffset),0) : 0);


        ;

        (kail_wake_up(&(kenv_pathMemState.workCond)));
        (kail_cond_wait(&(pReqNode->cond),&(pReqNode->mutex)));
    }


    if (pReqNode->state & (0x0002)) {
        if (pMemInfo->pathFlags & 0x1000) {
            ;


        } else {
            ;

        }
    } else if (pReqNode->state & 0x0004) {
        ;
        if (kenv_pathMemState.flags & 0x0080) {
            rc = -1;
        } else {
            rc = 0;
        }
        pMemInfo->pathFlags = 0x0200;
    } else {
        ;


        rc = -1;
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 9) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_RQDONE, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(((int)kail_pid_get_epid(kail_current_tid()))), (long)pReqNode->tag, (long)pReqNode->state, (long)pReqNode->shmOffset),0) : 0);



    if (!(pMemInfo->pathFlags & 0x0200) &&
        !(pMemInfo->pathFlags & 0x0100) && pReqNode->path) {
        pal_free(pReqNode->path, pReqNode->len);
        pReqNode->path = NULL;
    }

    (kail_mutex_unlock(&(pReqNode->mutex)));

    if (rc || (pMemInfo->pathFlags == 0x0200)) {


        pReqNode->pid = -1;
        pReqNode->path = (char *)NULL;
        pReqNode->len = 0;
        pReqNode->state = 0x0000;
        pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
        (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
        ((&(pReqNode->q))->next = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next), (&(pReqNode->q))->prev = (&(kenv_pathMemState.freeQ)), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->next)->prev = (&(pReqNode->q)), (&(kenv_pathMemState.freeQ))->next = (&(pReqNode->q)));
        ;
        (kenv_pathMemState.used)--;



        if (pReqNode->flags & 0x0001) {
            (kenv_pathMemState.use2)--;
            pReqNode->flags &= ~(0x0001);
        }
        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

        (kail_wake_up(&(kenv_pathMemState.freeCond)));


        pMemInfo->handle = NULL;
    }

    return(rc);
}
uint32_t
kenv_pathMemOffset(kenv_pathReqHandle_t handle)
{
    kenv_pathReq_t *pReqNode = (kenv_pathReq_t *)handle;

    if (pReqNode) {
        return(pReqNode->shmOffset);
    } else {
        return((uint32_t)-1);
    }
}
int
kenv_pathMemPut(void *ptr, kenv_pathMemInfo_t *pMemInfo)
{
    int rc;
    kenv_pathReq_t *pReqNode = (kenv_pathReq_t *)NULL;

    if (!pMemInfo) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_PUTERR, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)((int)kail_pid_get_epid(kail_current_tid())), (long)pMemInfo, (long)pMemInfo),0) : 0);


        ;
        return(-1);
    }


    if (kenv_pathMemState.flags & 0x0010) {
        return(-1);
    }


    if (pMemInfo->memSerial != kenv_pathMemSerial) {
        ;
        return(-1);
    }

    pReqNode = (kenv_pathReq_t *)pMemInfo->handle;
    if (!pReqNode) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_PUTERR, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((0)<<16)), (long)((int)kail_pid_get_epid(kail_current_tid())), (long)pMemInfo, (long)pReqNode),0) : 0);


        ;

        return(-1);
    }

    ;

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 9) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_PUT, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)pReqNode->pid), (long)pReqNode->shmOffset),0) : 0);



    (kail_mutex_lock(&(pReqNode->mutex)));
    while (pReqNode->state == 0x0001) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_SHMEM_RQWAIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(((int)kail_pid_get_epid(kail_current_tid()))), (long)pReqNode->tag, (long)pReqNode->len, (long)pReqNode->shmOffset),0) : 0);


        ;

        (kail_cond_wait(&(pReqNode->cond),&(pReqNode->mutex)));
    }

    if (!(pMemInfo->pathFlags & 0x0200) &&
        !(pMemInfo->pathFlags & 0x0100) && pReqNode->path) {
        pal_free(pReqNode->path, pReqNode->len);
        pReqNode->path = NULL;
    }
    (kail_mutex_unlock(&(pReqNode->mutex)));

    (kail_mutex_lock(&(kenv_pathMemState.reclaimMutex)));






    if (!(kenv_pathMemState.flags & 0x0002)) {

        (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));
        (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
        ;
        (kenv_pathMemState.used)--;



        if (pReqNode->flags & 0x0001) {
            (kenv_pathMemState.use2)--;
            pReqNode->flags &= ~(0x0001);
        }
        pReqNode->state = 0x0000;
        pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
        pReqNode->pid = -1;

        ((&(pReqNode->q))->next = (&(kenv_pathMemState.freeQ)), (&(pReqNode->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev)->next = (&(pReqNode->q)), (&(kenv_pathMemState.freeQ))->prev = (&(pReqNode->q)));
        (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));
        (kail_wake_up(&(kenv_pathMemState.freeCond)));
        ;

        rc = 0;
    } else {
        ;

        ;


        ;


        pReqNode->state = 0x0008;
        pReqNode->tstamp = ((pal_time_t)(kail_xtime->tv_sec));
        ((&(pReqNode->q))->next = (&(kenv_pathMemState.reclaimQ)), (&(pReqNode->q))->prev = (((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.reclaimQ))->prev)->next = (&(pReqNode->q)), (&(kenv_pathMemState.reclaimQ))->prev = (&(pReqNode->q)));
        rc = 0;
        (kail_mutex_unlock(&(kenv_pathMemState.reclaimMutex)));
        if ((rc == 0) && kenv_pathMemState.waiters) {

            (kail_wake_up(&(kenv_pathMemState.workCond)));
        }
    }

    return(rc);
}
int
kenv_pathMemInit(int memId, uint32_t memp, uint32_t size)
{
    int rc = 0, i, fullInit=1;
    uint16_t buckets = 0,bucketSize=PATH_MAX;
    size_t allocSize;

    if (kenv_pathMemState.flags & (0x0002|0x0008)) {


        if ((memId == kenv_pathMemState.id) &&
            (memp == kenv_pathMemState.memp) &&
            (size == kenv_pathMemState.size)) {
            ;

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_REINIT, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(memId), (long)memp, (long)size),0) : 0);


            return(0);
        } else {
            ;



            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event4((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_REINITERR, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(&kenv_pathMemState), (long)memId, (long)memp, (long)size),0) : 0);




            fullInit = 0;
        }
    } else if (kenv_pathMemState.flags & 0x0080) {
        ;


        fullInit = 0;
    }

    if (kenv_pathMemSerial == 0) {

        (kail_mutex_init(&(kenv_pathMemOldPoolsMutex)));
        ((&(kenv_pathMemOldPools))->next = (&(kenv_pathMemOldPools))->prev = (&(kenv_pathMemOldPools)));
    }

    for (;bucketSize % sizeof(char *);bucketSize++);
    ;

    buckets = (size/bucketSize);
    allocSize = buckets * sizeof(kenv_pathReq_t);
    ;


    if (fullInit) {
        memset(&kenv_pathMemState,0,sizeof(kenv_pathMem_t));
    } else {
        kenv_pathMemState.flags = 0;
    }



    kenv_pathMemState.flags |= 0x0001;





    kenv_pathMemState.pool = (kenv_pathReq_t *)pal_alloc(allocSize);
    if (kenv_pathMemState.pool) {
        int node;

        memset(kenv_pathMemState.pool,0,allocSize);
        if (fullInit) {
            (kail_mutex_init(&(kenv_pathMemState.workMutex)));
            (kail_mutex_init(&(kenv_pathMemState.freeMutex)));
            (kail_mutex_init(&(kenv_pathMemState.reclaimMutex)));
            (kail_cond_init(&(kenv_pathMemState.workCond)));
            (kail_cond_init(&(kenv_pathMemState.freeCond)));
            (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
        } else {
            (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
            kenv_pathMemState.used = 0;
            kenv_pathMemState.use2 = 0;
            kenv_pathMemState.waiters = 0;
            kenv_pathMemState.helpers = 0;
        }


        kenv_pathMemSerial++;
        ;


        kenv_pathMemState.id = memId;
        kenv_pathMemState.memp = memp;
        kenv_pathMemState.bucketSize = bucketSize;
        kenv_pathMemState.buckets = buckets;
        kenv_pathMemState.size = size;

        ((&(kenv_pathMemState.freeQ))->next = (&(kenv_pathMemState.freeQ))->prev = (&(kenv_pathMemState.freeQ)));
        ((&(kenv_pathMemState.workQ))->next = (&(kenv_pathMemState.workQ))->prev = (&(kenv_pathMemState.workQ)));
        ((&(kenv_pathMemState.reclaimQ))->next = (&(kenv_pathMemState.reclaimQ))->prev = (&(kenv_pathMemState.reclaimQ)));
        for (i=0; i<buckets; i++) {
            ((&(kenv_pathMemState.pool[i].q))->next = (&(kenv_pathMemState.pool[i].q))->prev = (&(kenv_pathMemState.pool[i].q)));
            kenv_pathMemState.pool[i].tag = i;
            kenv_pathMemState.pool[i].shmOffset = (i * bucketSize);
            kenv_pathMemState.pool[i].state = 0x0000;
            kenv_pathMemState.pool[i].flags = 0x0000;
            kenv_pathMemState.pool[i].pid = -1;

            (kail_mutex_init(&(kenv_pathMemState.pool[i].mutex)));
            (kail_cond_init(&(kenv_pathMemState.pool[i].cond)));
            ((&(kenv_pathMemState.pool[i].q))->next = (&(kenv_pathMemState.freeQ)), (&(kenv_pathMemState.pool[i].q))->prev = (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev), (((kutil_q_t *)&(kenv_pathMemState.freeQ))->prev)->next = (&(kenv_pathMemState.pool[i].q)), (&(kenv_pathMemState.freeQ))->prev = (&(kenv_pathMemState.pool[i].q)));

        }
        kenv_pathMemState.checkTime = ((pal_time_t)(kail_xtime->tv_sec));
        (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));
        ;

        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event5((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_INIT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16) + ((2)<<12) + ((0)<<8)), (long)(&kenv_pathMemState), (long)memId, (long)memp, (long)size ,(long)buckets),0) : 0);





        pal_pinMem(&kenv_pathMemState,sizeof(kenv_pathMem_t));
        pal_pinMem(kenv_pathMemState.pool, allocSize);
    } else {
        ;

        rc = -1;
    }

    return(rc);
}
int
kenv_pathMemFini()
{
    int rc = 0, waits = 0, last_waiters=0, i;




    ;
    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_FINI_ENT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(&kenv_pathMemState), (long)kenv_pathMemState.flags),0) : 0);



    if (kenv_pathMemState.flags == 0 ||
        (kenv_pathMemState.flags & 0x0010)) {

        ;

        return(0);
    }


    (kail_mutex_lock(&(kenv_pathMemState.workMutex)));
    if (kenv_pathMemState.flags & 0x0002) {

        ;

        return(-1);
    }


    if (!(kenv_pathMemState.flags & (0x0004|0x0008))) {
        kenv_pathMemState.flags = 0x0004;
    }

    if (kenv_pathMemState.helpers) {

        (kail_wake_up(&(kenv_pathMemState.workCond)));
        while (kenv_pathMemState.helpers) {
            (kail_cond_wait(&(kenv_pathMemState.workCond),&(kenv_pathMemState.workMutex)));

        }
    }

    (kail_mutex_unlock(&(kenv_pathMemState.workMutex)));

    (kail_mutex_lock(&(kenv_pathMemState.freeMutex)));
    while (kenv_pathMemState.used && (rc != 2)) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_FINI_WAITUSED, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(&kenv_pathMemState), (long)kenv_pathMemState.used),0) : 0);


        ;


        rc = (kail_condTimedWait(&(kenv_pathMemState.freeCond),&(kenv_pathMemState.freeMutex),10,0));
    }

    ;


    if (kenv_pathMemState.used) {
        ;


        if (((((kutil_q_t *)&(kenv_pathMemState.workQ))->next) == (kutil_q_t *)&(kenv_pathMemState.workQ))) {
            ;







            for (i=0; i<kenv_pathMemState.buckets; i++) {
                if (kenv_pathMemState.pool[i].state == 0x0002) {
                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_NODE_RECLAIM, (((2)<<28) + ((((sizeof(char *) == 4) ? 2 : 4))<<24) + ((2)<<20) + ((0)<<16)), (long)(i), (long)&(kenv_pathMemState.pool[i]), (long)(int)(kenv_pathMemState.pool[i].pid)),0) : 0);





                    kenv_procClearExecData(kenv_pathMemState.pool[i].pid);
                    ;
                    kenv_pathMemState.used--;
                    ;

                }
            }
            if (kenv_pathMemState.used) {
                rc = -1;
                ;

            } else {
                rc = 0;
            }
        } else {
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_FINI_FAILUSED, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(&kenv_pathMemState), (long)kenv_pathMemState.used),0) : 0);


            rc = -1;
        }
    }

    ;

    (kail_mutex_unlock(&(kenv_pathMemState.freeMutex)));

    if (rc == 0) {
        ;


        while (kenv_pathMemState.waiters && (rc != 2)) {
            if (!last_waiters) {
                last_waiters = kenv_pathMemState.waiters;
            } else {
                if (last_waiters == kenv_pathMemState.waiters) {

                    ;

                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[0])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[0], KT_TRACE_SHMEM_FINI_FAILWAITERS, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(&kenv_pathMemState), (long)kenv_pathMemState.waiters),0) : 0);



                    rc = -1;
                }
                break;
            }
            ;

            (kail_wake_up(&(kenv_pathMemState.freeCond)));

            pal_delay(1000);
        }
    }

    if (rc == 0) {
        size_t allocSize;
        int mapWords;

        ((&(kenv_pathMemState.freeQ))->next = (&(kenv_pathMemState.freeQ))->prev = (&(kenv_pathMemState.freeQ)));
        ((&(kenv_pathMemState.workQ))->next = (&(kenv_pathMemState.workQ))->prev = (&(kenv_pathMemState.workQ)));
        ((&(kenv_pathMemState.reclaimQ))->next = (&(kenv_pathMemState.reclaimQ))->prev = (&(kenv_pathMemState.reclaimQ)));
        kenv_pathMemState.flags |= 0x0010;

        allocSize = kenv_pathMemState.buckets * sizeof(kenv_pathReq_t);
        ;

        for (i=0; i<kenv_pathMemState.buckets; i++) {
            ((&(kenv_pathMemState.pool[i].q))->next = (&(kenv_pathMemState.pool[i].q))->prev = (&(kenv_pathMemState.pool[i].q)));

            (kail_mutex_destroy(&(kenv_pathMemState.pool[i].mutex)));
            (kail_cond_destroy(&(kenv_pathMemState.pool[i].cond)));
        }


        pal_unpinMem(kenv_pathMemState.pool, allocSize);
        pal_unpinMem(&kenv_pathMemState,sizeof(kenv_pathMem_t));

        pal_free(kenv_pathMemState.pool, allocSize);
        kenv_pathMemState.pool = (kenv_pathReq_t *)NULL;
        kenv_pathMemState.memp = 0;
        kenv_pathMemState.id = 0;
        kenv_pathMemState.buckets = 0;
        kenv_pathMemState.bucketSize = 0;
        kenv_pathMemState.waiters = 0;
        kenv_pathMemState.used = 0;
        kenv_pathMemState.use2 = 0;
    } else {
        kenv_pathMemOldPool_t *elem;

        ;



        elem = (kenv_pathMemOldPool_t *)
            pal_alloc(sizeof(kenv_pathMemOldPool_t));
        if (elem) {
            ((&(elem->q))->next = (&(elem->q))->prev = (&(elem->q)));
            elem->used = kenv_pathMemState.used;
            elem->pool = kenv_pathMemState.pool;
            elem->poolSize = kenv_pathMemState.buckets * sizeof(kenv_pathReq_t);

            (kail_mutex_lock(&(kenv_pathMemOldPoolsMutex)));
            ((&(elem->q))->next = (&(kenv_pathMemOldPools)), (&(elem->q))->prev = (((kutil_q_t *)&(kenv_pathMemOldPools))->prev), (((kutil_q_t *)&(kenv_pathMemOldPools))->prev)->next = (&(elem->q)), (&(kenv_pathMemOldPools))->prev = (&(elem->q)));
            (kail_mutex_unlock(&(kenv_pathMemOldPoolsMutex)));
        } else {
            ;
        }
    }

    if (kenv_pathMemState.flags & 0x0010) {
        (kail_cond_destroy(&(kenv_pathMemState.workCond)));
        (kail_cond_destroy(&(kenv_pathMemState.freeCond)));
        (kail_mutex_destroy(&(kenv_pathMemState.workMutex)));
        (kail_mutex_destroy(&(kenv_pathMemState.freeMutex)));
        (kail_mutex_destroy(&(kenv_pathMemState.reclaimMutex)));
    }

    return(rc);
}
