
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)02	1.126  src/oss/kazn/kenv/kenv_proc.c, oss.kazn.src, oss600, 070720c  8/9/07  13:52:54";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));
extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));


extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );

extern asmlinkage int kail_copy_exec_argv(void *, char *, int);


struct group_info;
extern gid_t * FASTCALL(kail_groups_blocks(struct group_info *,int));
extern int FASTCALL(kail_groups_ngroups(struct group_info *));
extern int FASTCALL(kail_groups_nblocks(struct group_info *));







struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;



        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

struct kail_lsmhooks {
        int lsmhook_index;
        sys_call_fn lsmhook_pre;
        sys_call_fn lsmhook_post;
};
extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *,struct kail_lsmhooks *);



extern asmlinkage void kail_restore_syscalls(void);

extern int change_KailPerm2ro(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#if defined(LINUX_RHEL4) || defined(LINUX_SLES10) || defined(LINUX_RHEL5)
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
struct sockaddr {
        unsigned short sa_family;
        char sa_data[14];
} ;
struct in_addr {
        uint s_addr;
};

struct sockaddr_in {
  unsigned short sin_family;
  unsigned short int sin_port;
  struct in_addr sin_addr;


  unsigned char __pad[16 - sizeof(short int) -
                        sizeof(unsigned short int) - sizeof(struct in_addr)];
};
struct in6_addr
{
        union
        {
                unsigned char u6_addr8[16];
                unsigned short u6_addr16[8];
                unsigned int u6_addr32[4];
        } in6_u;



};
struct sockaddr_in6 {
        unsigned short int sin6_family;
        unsigned short sin6_port;
        unsigned int sin6_flowinfo;
        struct in6_addr sin6_addr;
        unsigned int sin6_scope_id;
};


typedef struct sockaddr pal_sockaddr_t;
extern int pal_netSockFdToAddrInfo(int, int *, pal_nwAddr_t *, pal_nwAddr_t *);
extern int pal_netSaddrToNwAddr(pal_sockaddr_t *, pal_nwAddr_t *);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
typedef struct kutil_q {
    struct kutil_q *next;
    struct kutil_q *prev;
} kutil_q_t, kutil_qHead_t;
typedef void *kt_chanID_t;

typedef struct _kt_chan {
    uint32_t active;
    pal_mutex_t lock;
    char name[40];
} kt_channel_t;
extern kt_channel_t kt_defChannels[];

extern void kt_logString(int, char *);
extern void kt_Event0(kt_chanID_t, int, unsigned int);
extern void kt_Event1(kt_chanID_t, int, unsigned int, long);
extern void kt_Event2(kt_chanID_t, int, unsigned int, long, long);
extern void kt_Event3(kt_chanID_t, int, unsigned int, long, long, long);
extern void kt_Event4(kt_chanID_t, int, unsigned int, long, long, long, long);
extern void kt_Event5(kt_chanID_t, int, unsigned int,
                      long, long, long, long, long);
extern void kt_zeroLog(void);
extern void kt_setChannelActive(char *, int);
extern void kt_intError(int, int, int, int);
extern void kt_init(void);
extern void kt_shutdown(void);
enum kt_msgs {
    KT_TRACE_DUMMY = 1024,
    KT_TRACE_STR,
    KT_TRACE_INT,
    KT_TRACE_LKUPNAME,
    KT_TRACE_PROCESS_PATH,
    KT_TRACE_NOFID,
    KT_TRACE_TRACK_OPEN,
    KT_TRACE_KAZN_PATH_ACCESS,
    KT_TRACE_KAZN_PATH_ACCESS_RTN,
    KT_TRACE_KPC_NOTIFY,
    KT_TRACE_KPC_NOTIFY_RTN,
    KT_TRACE_KPC_GETATTR,
    KT_TRACE_KPC_GETATTR_RTN,
    KT_TRACE_KPC_SETVERSION,
    KT_TRACE_KPC_SETVERSION_RTN,
    KT_TRACE_KPC_SETEPOCH,
    KT_TRACE_KPC_SETEPOCH_RTN,
    KT_TRACE_KOSS_SYSCALL,
    KT_TRACE_KOSS_SYSCALL_RTN,
    KT_TRACE_KOSS_REGISTER,
    KT_TRACE_KOSS_REGISTER_RTN,
    KT_TRACE_KOSS_SET_PRIVID,
    KT_TRACE_KOSS_SET_PRIVPID,
    KT_TRACE_KOSS_ALLOC_FAIL,
    KT_TRACE_KOSS_INT_ERR,
    KT_TRACE_KAUD_SETLEVEL,
    KT_TRACE_KAUD_SETLEVEL_RTN,
    KT_TRACE_KAUD_AUD_SERVICE,
    KT_TRACE_KAUD_AUD_SERVICE_RTN,
    KT_TRACE_CSC_SETGROUPS,
    KT_TRACE_KOSS_PRIVCHECK,
    KT_TRACE_KOSS_PRIVCHECK_IDS,
    KT_TRACE_KOSS_PRIVCHECK_RTN,
    KT_TRACE_CSC_SUID,
    KT_TRACE_CSC_SUID2,
    KT_TRACE_CSC_SGID,
    KT_TRACE_CSC_SUID_BYPASS,
    KT_TRACE_CSC_SGID_BYPASS,
    KT_TRACE_KOSS_SET_ACTIVE,
    KT_TRACE_KOSS_SET_INACTIVE,
    KT_TRACE_KOSS_SET_STATE,
    KT_TRACE_NCT_OCREAT_CK_LINK_TGT,
    KT_TRACE_CSC_LOGIN_DIRECT_BP,
    KT_TRACE_KUTIL_GET_LOGIN_DATA,
    KT_TRACE_KUTIL_GET_LOGIN_DATA_EXIT,
    KT_TRACE_KAUD_LOG_USER_EVENT,
    KT_TRACE_KAUD_LOG_USER_EVENT_EXIT,
    KT_TRACE_KAUD_TRACE_EVENT,
    KT_TRACE_KAUD_TRACE_EVENT_EXIT,
    KT_TRACE_KAUD_LOGOUT_NOTERM,
    KT_TRACE_KAUD_LOGOUT_LOCTERM,
    KT_TRACE_KAUD_LOGOUT_REMTERM,
    KT_TRACE_KAUD_LOGOUT_EXIT,
    KT_TRACE_KAUD_TRACE_PID_EXEMPT,
    KT_TRACE_KAUD_TRACE_UID_EXEMPT,
    KT_TRACE_KOSS_INIT_PROC_RGY,
    KT_TRACE_KOSS_ASYNC_LU_START,
    KT_TRACE_KOSS_ASYNC_LU_STOP,
    KT_TRACE_KOSS_ASYNC_LU_TIMEOUT,
    KT_TRACE_KOSS_ASYNC_LU_STATE,
    KT_TRACE_KPCF_TRIG_REF,
    KT_TRACE_KPCF_SCAN_TIME,
    KT_TRACE_SHMEM_REINIT,
    KT_TRACE_SHMEM_REINITERR,
    KT_TRACE_SHMEM_INIT,
    KT_TRACE_SHMEM_FINI_ENT,
    KT_TRACE_SHMEM_FINI_WAITUSED,
    KT_TRACE_SHMEM_FINI_FAILUSED,
    KT_TRACE_SHMEM_FINI_FAILWAITERS,
    KT_TRACE_SHMEM_SRVT_START,
    KT_TRACE_SHMEM_SRVT_INVNODE,
    KT_TRACE_SHMEM_SRVT_ERRCOPY,
    KT_TRACE_SHMEM_SRVT_STOP,
    KT_TRACE_SHMEM_SRVT_WAIT,
    KT_TRACE_SHMEM_SRVT_WAITERR,
    KT_TRACE_SHMEM_STOP,
    KT_TRACE_GETMEM_NONE,
    KT_TRACE_SHBANG_TOOBIG,
    KT_TRACE_SHBANG_CHECK_READ,
    KT_TRACE_SHMEM_HELPER_START,
    KT_TRACE_SHMEM_HELPER_RESTART,
    KT_TRACE_SHMEM_HELPER_RETURN,
    KT_TRACE_SHMEM_CHECK_FAIL,
    KT_TRACE_SHMEM_NODE_RECLAIM,
    KT_TRACE_FDPATH_FAILURE,
    KT_TRACE_SHMEM_OLDPOOL_DEC
};
enum kt_kazn_msgs {
    KT_TRACE_KAZN_DUMMY = 2048,
    KT_TRACE_KAZN_ACC_ALLOWED_FI,
    KT_TRACE_KAZN_ACC_ALLOWED_ID,
    KT_TRACE_KAZN_ACC_ALLOWED_NW,
    KT_TRACE_KAZN_CFR,
    KT_TRACE_KAZN_CFR_HIT,
    KT_TRACE_KAZN_CFR_MISS,
    KT_TRACE_KAZN_KPCF_ADD,
    KT_TRACE_KAZN_KPCF_UPDATE,
    KT_TRACE_KAZN_KPCF_DEL,
    KT_TRACE_KPCF_DINS,
    KT_TRACE_KPCF_REFRES,
    KT_TRACE_KPCF_REFRES_RTN,
    KT_TRACE_KPCF_REF_FR,
    KT_TRACE_KPCF_NCADD,
    KT_TRACE_KPCF_NCHIT,
    KT_TRACE_KPCF_NCFLUSH,
    KT_TRACE_KPCF_DIR_NOTIFY,
    KT_TRACE_KPCF_EPOCH_DEL,
    KT_TRACE_KPCF_HIT_WC,
    KT_TRACE_KAZN_LOGIN_SUSKIP,
    KT_TRACE_KAZN_SECPGM_SUSKIP,
    KT_TRACE_KAZN_PRIVPGM_PERMIT,
    KT_TRACE_KPCF_HIT_LOCALTERM,
    KT_TRACE_KAZN_ACC_ALLOWED_EFLAGS,
    KT_TRACE_KAZN_RES_NOAZN,
    KT_TRACE_KPCF_KPCI_ADD_PO,
    KT_TRACE_KAZN_CHECKACCESS,
    KT_TRACE_KAZN_CHECKACCESS_GRANT,
    KT_TRACE_KAZN_CHECKACCESS_DENY,
    KT_TRACE_KAZN_CHECKACCESS_DENY_MORE,
    KT_TRACE_KPCF_REFRESH_NOTIFY,
    KT_TRACE_KPCF_CHECKPATH,
    KT_TRACE_KPCF_CKPATH_RTN,
    KT_TRACE_KPCF_CKPATH_FAST_RTN,
    KT_TRACE_KPCF_REF_DHASH,
    KT_TRACE_KPCF_REF_DHASH_RTN,
    KT_TRACE_RCF_ADD_GRANT,
    KT_TRACE_RCF_ADD_GRANT_RES,
    KT_TRACE_RCF_CHECK,
    KT_TRACE_RCF_CHECK_GRANT,
    KT_TRACE_RCF_CHECK_NOGRANT,
    KT_TRACE_RCF_FLUSH,
    KT_TRACE_RCF_COND_INFO,
    KT_TRACE_KAZN_DAEMON_EBUSY,
    KT_TRACE_KPCF_BKG_SLEEP,
    KT_TRACE_KPCF_BKG_RUN,
    KT_TRACE_KPCF_EPOCH_NOT,
    KT_TRACE_KPCF_EPOCH_NOT_COMMIT,
    KT_TRACE_KAZN_RES_NOTIFY,
    KT_TRACE_KPC_GET_NEWEPOCH,
    KT_TRACE_KPC_COMMIT_EPOCH,
    KT_TRACE_CSC_OPEN,
    KT_TRACE_CSC_KILL_ERR,
    KT_TRACE_KPCF_GENFID_ERR,
    KT_TRACE_KPCF_NOFID_REFRESH,
    KT_TRACE_KPCF_ADD_IMMUNE,
    KT_TRACE_KPCF_UPDATE_IMMUNE,
    KT_TRACE_KAZN_ERR_GRANT,
    KT_TRACE_KAZN_FIND_PGM_KPON,
    KT_TRACE_KAZN_FIND_PGM_KPON_FOUND,
    KT_TRACE_KAZN_FIND_PGM_KPON_NONE,
    KT_TRACE_KAZN_FIND_PGM_KPON_AMBIG,
    KT_TRACE_KAZN_KPC_QFILE,
    KT_TRACE_KAZN_KPC_QFILE_RTN,
    KT_TRACE_KAZN_KPC_QPGM,
    KT_TRACE_KAZN_KPC_QPGM_RTN,
    KT_TRACE_KAZN_KPC_DHASHFID_EXIT,
    KT_TRACE_KAZN_KPC_DHASHNAME_EXIT,
    KT_TRACE_KAZN_KPC_CREATE_NOTIFY,
    KT_TRACE_RCID_ADD_GRANT,
    KT_TRACE_RCID_ADD_GRANT_RES,
    KT_TRACE_RCID_CHECK,
    KT_TRACE_RCID_CHECK_GRANT,
    KT_TRACE_RCID_CHECK_NOGRANT,
    KT_TRACE_RCID_FLUSH,
    KT_TRACE_KAZN_AZNCALL_REMAP_TO,
    KT_TRACE_KPCF_EXCEPTION_ADD,
    KT_TRACE_KAZN_AZND_TOUT,
    KT_TRACE_KAZN_EXPAND_PATH,
    KT_TRACE_KAZN_EXPAND_PATH_ERR,
    KT_TRACE_KAZN_EXPAND_PATH_SKIP,
    KT_TRACE_KAZN_UFILE_HIT,
    KT_TRACE_KAZN_UFILE_ADD,
    KT_TRACE_KAZN_UFILE_MISS,
    KT_TRACE_KAZN_UFILE_FLUSH,
    KT_TRACE_KPCF_REF_DH_BYFID,
    KT_TRACE_KPCF_REF_DH_BYFID_END,
    KT_TRACE_EXEC_SETUSER,
    KT_TRACE_EXEC_SETGROUP,
    KT_TRACE_KAZN_CHECK_FID_ONLY,
    KT_TRACE_KAZN_EXEMPT_PID_PERMIT,
    KT_TRACE_KAZN_PFC_HIT,
    KT_TRACE_KAZN_PFC_ADD,
    KT_TRACE_KAZN_PFC_MISS,
    KT_TRACE_KAZN_PFC_FLUSH,
    KT_TRACE_KAZN_PFC_FLUSHBYRES,
    KT_TRACE_KAZN_PFC_PROTRES_RELE,
    KT_TRACE_KAZN_ACC_ALLOWED_PERMIT,
    KT_TRACE_KAZN_ACC_ALLOWED_DENY,

    KT_TRACE_KAZN_AUTOFS_NOREF,

    KT_TRACE_KAZN_NW_ADDR_BADFAM,
    KT_TRACE_KAZN_RES_TRY_AGAIN,
    KT_TRACE_KAZN_KPC_QNW,
    KT_TRACE_KAZN_KPC_QNW_RTN,
    KT_TRACE_KAZN_IMSURPGM_SUSKIP,
    KT_TRACE_KAZN_USER_AUDIT_LOGOUT,
    KT_TRACE_KAZN_ALWAYS_SET_KPON,
    KT_TRACE_KAZN_FILTER_RES,
    KT_TRACE_KAZN_KPCFT_DELAY,
    KT_TRACE_KAZN_IPV6_ADDR,
    KT_TRACE_KAZN_DHANAL_FRL_CLR,
    KT_TRACE_KAZN_SET_ALIAS,
    KT_TRACE_KAZN_HAS_ALIAS,
    KT_TRACE_KAZN_RES_WAIT,
    KT_TRACE_KAZN_RES_REFD,
    KT_TRACE_KAZN_RES_BROADCAST,
    KT_TRACE_KAZN_DHASH_REF_LOOP,
    KT_TRACE_KAZN_USE_COPY,
    KT_TRACE_KAZN_NO_COPY,
    KT_TRACE_KAZN_DENY_SHMCTL_OP,
    KT_TRACE_KAZN_DHASH_SEARCH_STALE
};







enum kt_kmsg_msgs {
    KT_TRACE_KMSG_DUMMY = 3072,
    KT_TRACE_KMSG_INIT,
    KT_TRACE_KMSG_FINISH,
    KT_TRACE_KMSG_OPEN,
    KT_TRACE_KMSG_CLOSE,
    KT_TRACE_KMSG_IOCTL,
    KT_TRACE_KMSG_READ_ENTRY,
    KT_TRACE_KMSG_READ_EXIT,
    KT_TRACE_KMSG_READ_WAIT,
    KT_TRACE_KMSG_READ_WORK,
    KT_TRACE_KMSG_WRITE_ENTRY,
    KT_TRACE_KMSG_WRITE_EXIT,
    KT_TRACE_KMSG_WRITE_ID,
    KT_TRACE_KMSG_WRITE_LEN,
    KT_TRACE_KMSG_SEND_REQ,
    KT_TRACE_KMSG_GET_RESP,
    KT_TRACE_KMSG_RECV_RESP,
    KT_TRACE_KMSG_GET_HAND,
    KT_TRACE_KMSG_FREE_HAND,
    KT_TRACE_KMSG_WAIT_MSG,

    KT_TRACE_KMSG_BADTRANID,
    KT_TRACE_KMSG_BADSIZE,
    KT_TRACE_KMSG_TOOBIG,
    KT_TRACE_KMSG_CHANCLOSED,
    KT_TRACE_KMSG_ERR_GET_HAND,
    KT_TRACE_KMSG_GET_RESP_ERR,
    KT_TRACE_KMSG_CHAN_DOWN,
    KT_TRACE_KMSG_CHAN_RETRY,
    KT_TRACE_KMSG_WAIT_TO,
    KT_TRACE_KMSG_HARD_TO,
    KT_TRACE_KMSG_TO_RETRY,
    KT_TRACE_KMSG_DOWN_TO_TOUT
};







enum kt_kenv_msgs {
    KT_TRACE_KENV_DUMMY = 4096,
    KT_TRACE_KENV_NEW_PROC_INFO,
    KT_TRACE_KENV_PR_ADD_FD,
    KT_TRACE_KENV_PR_CLOSE_FD,
    KT_TRACE_KENV_PR_RET_FDINFO,
    KT_TRACE_KENV_PR_GROW_FDTABLE,
    KT_TRACE_KENV_PR_ADD_FLAGS,
    KT_TRACE_KENV_PR_DEL_FLAGS,
    KT_TRACE_KENV_PR_SET_IMP_ID,
    KT_TRACE_KENV_E_NW_TERM,
    KT_TRACE_KENV_E_DEV_TERM,
    KT_TRACE_KENV_E_NO_TERM,
    KT_TRACE_KENV_PR_ADD_FLAGS_BNAME,
    KT_TRACE_KENV_PTP_E2BIG,
    KT_TRACE_KENV_PTP_E2BIG_RETRY,
    KT_TRACE_KENV_PR_GET_TRUE_ACCID,
    KT_TRACE_KENV_PR_SET_ACC_ID,
    KT_TRACE_KENV_PR_ADD_NO_FORK,
    KT_TRACE_KENV_PR_ADD_REMT_TERM,
    KT_TRACE_KENV_PR_GET_REMT_TERM,
    KT_TRACE_KENV_BUMP_STREAM_COUNT,
    KT_TRACE_KENV_DELAY_PROC_DEL,
    KT_TRACE_KENV_PROC_INFO_NOTPAR,
    KT_TRACE_KENV_E_NW_TERM_IPV6,
    KT_TRACE_KENV_IPV6_ADDR,
    KT_TRACE_KENV_PR_NOSET_REMT,
    KT_TRACE_KENV_SHMEM_TOOBIG,
    KT_TRACE_KENV_SHMEM_WAIT,
    KT_TRACE_KENV_SHMEM_STOPPED,
    KT_TRACE_KENV_SHMEM_NOFREE,
    KT_TRACE_KENV_SHMEM_INVNODE,
    KT_TRACE_KENV_SHMEM_RQWAIT,
    KT_TRACE_KENV_SHMEM_RQDONE,
    KT_TRACE_KENV_SHMEM_PUTERR,
    KT_TRACE_KENV_SHMEM_PUT,
    KT_TRACE_KENV_GETMEM_REL,
    KT_TRACE_KENV_GETMEM_NEVER,
    KT_TRACE_KENV_GETMEM_OK,
    KT_TRACE_KENV_GETMEM_OFF,
    KT_TRACE_KENV_GETMEM_ERR,
    KT_TRACE_KENV_PUTMEM,
    KT_TRACE_KENV_SHMAT_RESET,
    KT_TRACE_KENV_SHMREQ_SCAN_DELAY,
    KT_TRACE_KENV_SHMREQ_SCAN_NOW,
    KT_TRACE_KENV_SHMREQ_REC_NOPID,
    KT_TRACE_KENV_SHMREQ_REC_EXP,
    KT_TRACE_KENV_SHMREQ_SCAN_RET,
    KT_TRACE_KENV_SHMEM_RESET_EXEC,
    KT_TRACE_KENV_PROC_FORK_CHILD,
    KT_TRACE_KENV_PROC_FORK_PAR,
    KT_TRACE_KENV_PROC_ALREADY,
    KT_TRACE_KENV_PROC_CONDADD,
    KT_TRACE_KENV_PROC_EXISTS,
    KT_TRACE_KENV_PR_ADD_NO_PAR,
    KT_TRACE_KENV_PROC_ADD,
    KT_TRACE_KENV_PROC_ADD_PPID,
    KT_TRACE_KENV_PROC_TERM,
    KT_TRACE_KENV_PROC_USE_DEAD
};







enum kt_dbg_msgs {
    KT_TRACE_DBG_DUMMY = 8192,
    KT_TRACE_DBG_NCT_Q_AREQ,
    KT_TRACE_DBG_NCT_START_AREQ,
    KT_TRACE_DBG_NCT_END_AREQ,
    KT_TRACE_DBG_PAL_NO_FID,
    KT_TRACE_DBG_PAL_LKUP_ERR,
    KT_TRACE_DBG_PAL_DCOMP_ERR,
    KT_TRACE_DBG_PAL_LU_FID_DIR,
    KT_TRACE_DBG_TLI_SVC_PRIM_PEND,
    KT_TRACE_DBG_TLI_SVC_PRIM_NOPEND,
    KT_TRACE_DBG_NCT_PATH_OP_RESULT,
    KT_TRACE_DBG_NCT_FD_OP_RESULT,
    KT_TRACE_DBG_NCT_KILL_COMMON,
    KT_TRACE_DBG_NCT_KILL_TRAP,
    KT_TRACE_DBG_NCT_KILL_FILTER_PGRP,
    KT_TRACE_DBG_NCT_KILL_FILTER_USER,

    KT_TRACE_DBG_PAL_FILE_COUNT,
    KT_TRACE_DBG_PAL_FILE_LOOKUP22,
    KT_TRACE_DBG_PAL_FILE_LOOKUP24,

    KT_TRACE_DBG_KAZN_AUTOFS_NOVFSP,
    KT_TRACE_DBG_RFID_FL_VFSP,
    KT_TRACE_DBG_AUTO_FS_MOUNTED,
    KT_TRACE_DBG_DEFER_UMOUNT,
    KT_TRACE_DBG_CHECK_VFS_MOUNTED,
    KT_TRACE_DBG_MOUNTED_YES,
    KT_TRACE_DBG_MOUNTED_NO,
    KT_TRACE_DBG_VFS_DATA_SET,
    KT_TRACE_DBG_FURTHER_LKUP_REQ,
    KT_TRACE_DBG_NEXT_LOOKUP,
    KT_TRACE_DBG_GEN_RES_FIDS,
    KT_TRACE_DBG_CHECK_FID_PATH,

    KT_TRACE_DBG_RESET_VFS_DATA,
    KT_TRACE_DBG_FAILED_VFS_SEARCH,
    KT_TRACE_DBG_ASYNC_LU_START,
    KT_TRACE_DBG_DEFER_UNAVAIL,
    KT_TRACE_DBG_REFRESH_FSID_EQ,
    KT_TRACE_DBG_REFRESH_FSID_NOFID,
    KT_TRACE_DBG_REFRESH_EPOCH,

    KT_TRACE_DBG_KPCF_ADD_RES,
    KT_TRACE_DBG_KPCF_AZN_FLAGS,
    KT_TRACE_DBG_NCT_FORK_TRAP,
    KT_TRACE_DBG_EXIT_CHECK_LEAF,

    KT_TRACE_DBG_SHMEM_SRVT_WAIT,
    KT_TRACE_DBG_SHMEM_SRVT_PROC,
    KT_TRACE_DBG_SHMEM_SRVT_RECLAIM,
    KT_TRACE_DBG_SHBANG_EXEC,
    KT_TRACE_DBG_SHMEM_HELPER_CHECK,
    KT_TRACE_DBG_FDPATH_BUILT,
    KT_TRACE_DBG_BYPASS_ENTRY1,
    KT_TRACE_DBG_BYPASS_ENTRY2,
    KT_TRACE_DBG_BYPASS_EXIT
};
enum kt_ffdc_msgs {
    KT_TRACE_FFDC_DUMMY = 5120,
    KT_TRACE_FFDC_STR,
    KT_TRACE_FFDC_AZNCALL_FILE,
    KT_TRACE_FFDC_AZNCALL_IDSET,
    KT_TRACE_FFDC_AZNCALL_NWOUT,
    KT_TRACE_FFDC_AZNCALL_NWIN,
    KT_TRACE_FFDC_AZNCALL_RACC_ADDR,
    KT_TRACE_FFDC_AZNCALL_CONT,
    KT_TRACE_FFDC_AZNCALL_RES_PERMIT,
    KT_TRACE_FFDC_AZNCALL_RES_DENY,
    KT_TRACE_FFDC_ERR_GRANT,
    KT_TRACE_FFDC_AZNCALL_SLOW,
    KT_TRACE_FFDC_CSC_LOGIN,
    KT_TRACE_FFDC_CKLOGIN,
    KT_TRACE_FFDC_CKLOGIN_EXIT,
    KT_TRACE_FFDC_CKLOGIN_DOAZN,
    KT_TRACE_FFDC_EXEC_PGM,
    KT_TRACE_FFDC_EXEC_PGM_LINK,
    KT_TRACE_FFDC_EXEC_SUPGM,
    KT_TRACE_FFDC_EXEC_SGPGM,
    KT_TRACE_FFDC_EXEC_SUGPGM,
    KT_TRACE_FFDC_EXEC_DENIED,
    KT_TRACE_FFDC_EXEC_ALLOWED,
    KT_TRACE_FFDC_LOGOUT_LOC,
    KT_TRACE_FFDC_LOGOUT_REM,
    KT_TRACE_FFDC_PROC_ADD,
    KT_TRACE_FFDC_PROC_ADD_PPID,
    KT_TRACE_FFDC_PROC_TERM,
    KT_TRACE_FFDC_NPC_FREE,
    KT_TRACE_FFDC_HOST_RULE_BAD,
    KT_TRACE_FFDC_CSC_V6TERM,
    KT_TRACE_FFDC_IPV6_ADDR
};




enum kt_knpc_msgs {
    KT_TRACE_KNPC_DUMMY = 6144,
    KT_TRACE_KNPC_STR,
    KT_TRACE_KNPC_SEARCH_SERVICE,
    KT_TRACE_KNPC_SEARCH_HOSTIP,
    KT_TRACE_KNPC_SEARCH_HOSTNAME,
    KT_TRACE_KNPC_SEARCH_PROTOCOL,
    KT_TRACE_KNPC_NET_UPD_ENTRY,
    KT_TRACE_KNPC_NET_UPD_ENTRY2,
    KT_TRACE_KNPC_KPCRES_ATTACH,
    KT_TRACE_KNPC_NET_ALREADY,
    KT_TRACE_KNPC_NETIN_ADD_NODE,
    KT_TRACE_KNPC_NETIN_DEL_ERR,
    KT_TRACE_KNPC_NETIN_DEL,
    KT_TRACE_KNPC_NETOUT_ADD_NODE,
    KT_TRACE_KNPC_NETOUT_DEL_ERR,
    KT_TRACE_KNPC_NETOUT_DEL,
    KT_TRACE_KNPC_NETIN_MATCH,
    KT_TRACE_KNPC_NETOUT_MATCH,
    KT_TRACE_KNPC_DUMP_HEADER,
    KT_TRACE_KNPC_DUMP_ELEM,
    KT_TRACE_KNPC_CUR_INIT,
    KT_TRACE_KNPC_CUR_FINI,
    KT_TRACE_KNPC_CHECK_RES,

    KT_TRACE_KNPCD_SERV_NODE_ALLOC,
    KT_TRACE_KNPCD_SERV_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_SERV_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIP_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_ALLOC,
    KT_TRACE_KNPCD_HOST_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_HOSTIP_NODE_FREE,
    KT_TRACE_KNPCD_HOST_NODE_FREE,
    KT_TRACE_KNPCD_PROT_NODE_ALLOC,
    KT_TRACE_KNPCD_PROT_NODE_FREE_NONEMPTY,
    KT_TRACE_KNPCD_PROT_NODE_FREE,
    KT_TRACE_KNPCD_MATCH_SERVICE,
    KT_TRACE_KNPCD_MATCH_HOSTIP,
    KT_TRACE_KNPCD_MATCH_PROTOCOL,
    KT_TRACE_KNPCD_KPON_FREE,
    KT_TRACE_KNPCD_WAIT_LOCK,
    KT_TRACE_KNPCD_SEARCH_SERV_ENTRY,
    KT_TRACE_KNPCD_SEARCH_NODE_CMP,
    KT_TRACE_KNPCD_FREE_NODE_REF,
    KT_TRACE_KNPCD_MATCH_HOSTNAME,
    KT_TRACE_KNPC_NETIN_SETRES,
    KT_TRACE_KNPC_NETOUT_SETRES,
    KT_TRACE_KNPC_ENV_SETRES,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_ALLOC,
    KT_TRACE_KNPCD_HOSTIPV6_ADDR,
    KT_TRACE_KNPCD_HOSTIPV6_MASK,
    KT_TRACE_KNPCD_HOSTIPV6_NODE_FREE,
    KT_TRACE_KNPCD_HOSTIPV6_HIT_V4,
    KT_TRACE_KNPCD_HOSTIPV6_CMP,
    KT_TRACE_KNPC_SEARCH_HOSTIPV6,
    KT_TRACE_KNPCD_SEARCH_HOSTIPV6_QELEM,
    KT_TRACE_KNPCD_MATCH_HOSTIPV6,
    KT_TRACE_KNPC_BRANCH_CHANGE
};



enum kt_knrc_msgs {
    KT_TRACE_KNRC_DUMMY = 7168,
    KT_TRACE_KNRC_STR,
    KT_TRACE_KNRC_INIT_ERR,
    KT_TRACE_KNRC_INIT_CACHE,
    KT_TRACE_KNRC_FINI_FREE,
    KT_TRACE_KNRC_CHECK_GROW,
    KT_TRACE_KNRC_RECYCLE_ELEM,
    KT_TRACE_KNRC_NEW_POOL_ALLOC,
    KT_TRACE_KNRC_FLUSH,
    KT_TRACE_KNRC_ADD_EXACT,
    KT_TRACE_KNRC_ADD_GRANT_EXACT,
    KT_TRACE_KNRC_ADD_AMBIG,
    KT_TRACE_KNRC_AMBIG_HASH,
    KT_TRACE_KNRC_ADD_GRANT_AMBIG,
    KT_TRACE_KNRC_HAS_VIA,
    KT_TRACE_KNRC_ADD_STATS,
    KT_TRACE_KNRC_CHECK_EXACT,
    KT_TRACE_KNRC_RECLAIM_EXACT,
    KT_TRACE_KNRC_FID_NOMATCH,
    KT_TRACE_KNRC_HIT_EXACT,
    KT_TRACE_KNRC_NOMATCH_EXACT,
    KT_TRACE_KNRC_CHECK_STATS,
    KT_TRACE_KNRC_CHECK_AMBIG,
    KT_TRACE_KNRC_CHECK_HASHQ,
    KT_TRACE_KNRC_RECLAIM_AMBIG,
    KT_TRACE_KNRC_HIT_AMBIG,
    KT_TRACE_KNRC_NOMATCH_AMBIG,
    KT_TRACE_KNRC_RECLAIM,
    KT_TRACE_KNRC_RECLAIM_ELEM
};
typedef void * kenv_pathReqHandle_t;







typedef struct kenv_pathMemInfo {
    kenv_pathReqHandle_t handle;
    uint16_t pathFlags, palFlags;
    uint32_t memSerial;
    pal_pathMemInfo_t palInfo;
} kenv_pathMemInfo_t;

extern int kenv_pathMemInit(int, uint32_t, uint32_t);
extern int kenv_pathMemFini(void);

extern uint32_t kenv_pathGetMemSerial(void);
extern int kenv_pathMemCurrent(uint32_t serial);
extern int kenv_pathMemService(void);
extern int kenv_pathMemHelper(int, uint32_t *);
extern void kenv_pathMemStop(int shutdown);

extern int kenv_pathMemGet(char *, int, kenv_pathMemInfo_t *);
extern int kenv_pathMemWaitReady(kenv_pathMemInfo_t *);
extern void kenv_pathMemCancel(kenv_pathReqHandle_t);
extern int kenv_pathMemPut(void *, kenv_pathMemInfo_t *);
extern uint32_t kenv_pathMemOffset(kenv_pathReqHandle_t);


extern int kenv_pathGetShmid(void);



extern int kenv_pathDebug;
typedef uint32_t kenv_procFlags_t;
typedef struct kenv_procPidList {
    pal_pid_t *pids;
    int listAllocSize;
} kenv_procPidList_t;

typedef struct procStats {
    uint32_t procAdds;
    uint32_t activeProcs;
    uint32_t fdTableGrows;
    uint32_t hashBoosts;
} kenv_procStats_t;



extern kenv_procStats_t kenv_procStats;

extern void kenv_procAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procConditionalAdd(pal_pid_t, pal_pid_t, int);
extern int kenv_procDelete(pal_pid_t);
extern int kenv_procSetProgramData(pal_pid_t, pal_rawFid_t *, pal_rawFid_t *,
                                   pal_fattr_t *, char *, kenv_procFlags_t *,
                                   int);
extern int kenv_procGetProgramInfo(pal_pid_t, char *,
                                   int *, pal_rawFid_t *,
                                   pal_fattr_t *,
                                   pal_rawFid_t *, int *);
extern int kenv_procRegisterPid(pal_pid_t);
extern int kenv_procIsPrivPid(pal_pid_t);
extern int kenv_procGetInfo(pal_pid_t, kenv_procFlags_t *,
                            pal_idList_t *, pal_rawFid_t *);
extern int kenv_procGetInfoExt(pal_pid_t, kenv_procFlags_t *,
                               pal_idList_t *, void **);
extern int kenv_procGetProcPPid(pal_pid_t, pal_pid_t *);
extern int kenv_procGetInfoNotPar(pal_pid_t, void *, kenv_procFlags_t *,
                                  pal_idList_t *, pal_rawFid_t *);
extern pal_pid_t kenv_procGetFlagsAndIds(kenv_procFlags_t *, pal_idList_t *);
extern pal_pid_t kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *, pal_idList_t *,
                                            void **);
extern int kenv_procGetProgramFid(pal_pid_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_fattr_t *);
extern int kenv_procAddProcFlags(pal_pid_t, kenv_procFlags_t *);
extern int kenv_procDelProcFlags(pal_pid_t, kenv_procFlags_t, int);
extern int kenv_procSetImpId(pal_pid_t, pal_authID_t);
extern int kenv_procAddFd(pal_pid_t, int, void *);
extern void kenv_procCloseFd(pal_pid_t, int);
extern void kenv_procLazyCloseFd(pal_pid_t, int);
extern pal_vnodeH_t kenv_procGetFdDirVnode(pal_pid_t, int);
extern void kenv_procCloseAllFdesc(pal_pid_t, int);
extern void kenv_procSetFdFlags(pal_pid_t, int, int);
extern void kenv_procDupFd(pal_pid_t, int, int);
extern int kenv_procGetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckSetRterm(pal_pid_t, pal_nwAddr_t *);
extern int kenv_procCheckGetRterm(pal_pid_t, pal_nwAddr_t *);
extern void kenv_procPurgeStale(int);
extern void kenv_procUpdateAccId(pal_pid_t, pal_authID_t);

extern int kenv_procAddProcFlagsByName(char *, pal_rawFid_t *,
                                       kenv_procFlags_t, int);
extern int kenv_procGetRegisteredCount(void);
extern void kenv_procFdCloseAll(void);
extern int32_t kenv_procGetLoginState(pal_pid_t);
extern void kenv_procSetLoginState(pal_pid_t, int32_t);
extern void kenv_procSetDirectLoginID(pal_pid_t, pal_authID_t);
extern int kenv_procGetDirectLoginID(pal_pid_t, pal_authID_t *);
extern int kenv_procSetLocalTerm(pal_pid_t, char *, int);
extern int kenv_procGetTrueAccId(pal_pid_t, pal_authID_t *);
extern int kenv_procGetPidList(kenv_procPidList_t **, kenv_procFlags_t);
extern void kenv_procFreePidList(kenv_procPidList_t *);
extern void kenv_procFreeAllLazyCloses(void);
extern int kenv_procIncStreamCount(pal_pid_t);
extern int kenv_procDecStreamCount(pal_pid_t, void *);




extern int kenv_procClearExecData(pal_pid_t);
extern void kenv_procClearExecMem(void *);
extern void kenv_procSavePutMemInfo(kenv_pathMemInfo_t *);
extern void kenv_procResetSharedMem(pal_pid_t);
extern sharedMemPtr_t kenv_procGetPathMem(char *,int,kenv_pathMemInfo_t *,
                                          int *);
extern void kenv_procPutPathMem(void *, kenv_pathMemInfo_t *);
extern int kenv_procCheckShmat(void *, kenv_pathMemInfo_t *);
extern int kenv_procIsCopyShmid(int);

extern void kenv_procInit(void);
extern void kenv_procShutdown(void);
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef void (*kpc_res_rele_func_t)(void *);
typedef struct kpcInfo {
    struct kpcInfo *next;
    struct kpcInfo *prev;
    char *resName;
    kpc_resFlags_t resFlags;
    uint32_t kpcFlags;
    uint32_t branchId;
    byte_t *extData;
    uint16_t resNameLen;
    uint16_t extDataLen;
    union {
        struct __f {
            pal_rawFid_t *poFid;
            pal_ftypes_t poFtype;
            int32_t kpcFileAddGen;
            pal_rawFid_t __poFid;
        } f;
        struct __nw {
            int64_t policyVersion;
            pal_ptr32_t pUserRes;
            void *pRes;
            kpc_res_rele_func_t relef;
        } nw;
    } resData;

    char __resName[48];
} kenv_kpcInfo_t;
typedef struct filetgt {
    char *trappedNameRef;
    char *baseName;
    pal_pathBuf_t *fullSrnRef;
    pal_rawFid_t *dir_rfidp;
    pal_rawFid_t *pathFids;
    pal_vnodeH_t dir_vnh;
    pal_vnodeH_t vnh;
    struct filetgt *auxFile;
    int tnLen;
    int pathFidsCount;
    int pathFidsAlloced;
    pal_rawFid_t rfid;
    pal_fattr_t fattrs;
    pal_pid_t killPid;


    void *tgt_nd;
    void *aux_tgt_nd;


    pal_rawFid_t _fids[5];
} kenv_fileTgt_t;






typedef struct pgmInfo {
    kenv_procFlags_t procFlags;
    char *pgmSRN;
    char *pgmKPON;
    pal_rawFid_t pgmFid;
    pal_rawFid_t pgmDFid;
    pal_fattr_t pgmFattrs;
    struct pgmInfo *saveArea;
    int16_t __srnLen;
    int16_t __kponLen;
    char __srn[32];
    char __kpon[32];
} pgmInfo_t;
typedef void * kenv_envHandle_t;

typedef struct kenv_env {
    int magic;
    uint32_t flags;
    pal_pid_t pid;
    int envError;



    union {



        struct {
            kenv_fileTgt_t f;
            pal_idSet_t idSet;
            pal_dev_t termDev;
            char *localTermName;
            pal_nwAddr_t nwTermAddr;
            byte_t *termExtData;
            int termExtDataLen;
        } fs;



        struct {
            pal_nwAddr_t addrRemote;
            pal_nwAddr_t addrLocal;
        } nw;
    } tgt;




    pal_idList_t idList;




    pgmInfo_t accPgm;




    int kpcInfoCount;
    kenv_kpcInfo_t *kpcInfoHead;
    kenv_kpcInfo_t *curKPCInfo;
    kenv_kpcInfo_t _kpcInfo;



    void *auxDatap1;
} kenv_env_t;
extern pal_authID_t kenv_envGetAuthID(kenv_envHandle_t);
extern pal_idList_t *kenv_envGetIdListRef(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetPathFids(kenv_envHandle_t, int *);
extern void kenv_envSetPathFids(kenv_envHandle_t, int, pal_rawFid_t *);
extern void kenv_envSetRfid(kenv_envHandle_t, pal_rawFid_t *, pal_fattr_t *);
extern void kenv_envSetFattr(kenv_envHandle_t, pal_fattr_t *);
extern pal_fattr_t *kenv_envGetFattr(kenv_envHandle_t);
extern void kenv_envSetKPCInfo(kenv_envHandle_t , kenv_kpcInfo_t *);
extern kenv_kpcInfo_t * kenv_envGetKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfo(kenv_envHandle_t);
extern void kenv_envSetNextKPCInfo(kenv_envHandle_t);
extern void kenv_envSetFirstKPCInfo(kenv_envHandle_t);
extern void kenv_envResetKPCInfoResName(kenv_envHandle_t,
                                        kenv_kpcInfo_t *, char *, int);
extern char * kenv_envGetProgram(kenv_envHandle_t);
extern pal_rawFid_t *
        kenv_envGetPgmFidAndDirFid(kenv_envHandle_t,
                                   pal_rawFid_t **, pal_fattr_t **);
extern char *kenv_envSetPgmResource(kenv_envHandle_t, char *, int);
extern char *kenv_envGetPgmResource(kenv_envHandle_t);
extern void kenv_envSetAuxFileActive(kenv_envHandle_t, int);
extern char *kenv_envGetTrappedName(kenv_envHandle_t, int *);
extern char *kenv_envGetBaseName(kenv_envHandle_t);
extern void kenv_envSetImpProcAccId(kenv_envHandle_t, pal_authID_t);
extern void kenv_envProgramExecUpdate(kenv_envHandle_t);
extern void kenv_envSaveProgramState(kenv_envHandle_t);
extern void kenv_envRestoreProgramState(kenv_envHandle_t);
extern void kenv_envTrackOpenFd(kenv_envHandle_t, int, int);
extern int kenv_envGetFdInfo(kenv_envHandle_t, int);
extern void kenv_envGetTerminals(kenv_envHandle_t,
                                 pal_dev_t **, pal_nwAddr_t **);
extern pal_dev_t *kenv_envGetTermDev(kenv_envHandle_t);
extern char *kenv_envSetLocalTermName(kenv_envHandle_t, char *);
extern byte_t *kenv_envSetTermExtData(kenv_envHandle_t, int, byte_t *);
extern byte_t *kenv_envGetTermExtData(kenv_envHandle_t, int *);
extern pal_nwAddr_t *kenv_envGetNWTerm(kenv_envHandle_t);
extern void kenv_envResetTargetData(kenv_envHandle_t, int);
extern char *kenv_envFdToBname(kenv_envHandle_t);
extern pal_pathBuf_t *kenv_envGetFullSrnRef(kenv_envHandle_t);
extern void kenv_envSetFullSrnRef(kenv_envHandle_t, pal_pathBuf_t *);
extern pal_rawFid_t *kenv_envBuildPathFids(kenv_envHandle_t, int *);
extern pal_rawFid_t *kenv_envGetDirRawFid(kenv_envHandle_t);
extern pal_rawFid_t *kenv_envGetFidsAndFattrs(kenv_envHandle_t,
                                              pal_rawFid_t **, pal_fattr_t **);

extern int kenv_envSetKPCCurrent(kenv_envHandle_t, char *);




extern void kenv_envSetTrappedNameRef(kenv_env_t *, char *, int);
extern void kenv_envInit(kenv_env_t *);
extern void kenv_envClean(kenv_env_t *);
extern int kenv_envProcessTrappedPath(kenv_env_t *, int);
extern int kenv_envProcessAuxPath(kenv_env_t *, char *, int, int);
extern void kenv_envUpdateACLInfo(kenv_env_t *);
extern void kenv_envInitialize(void);
extern void kenv_envShutdown(void);
extern kenv_env_t *kenv_envAllocEnv(void);
extern void kenv_envFreeEnv(kenv_env_t *);
extern int csc_open(kenv_envHandle_t, int);
extern int csc_chdir(kenv_envHandle_t);



extern int csc_exec(kenv_envHandle_t,int);
extern int csc_chdir(kenv_envHandle_t);
extern int csc_mkdir(kenv_envHandle_t);
extern int csc_kill(kenv_envHandle_t, pal_pid_t);
extern int csc_delete(kenv_envHandle_t);
extern int csc_chmod(kenv_envHandle_t);
extern int csc_chown(kenv_envHandle_t);
extern int csc_truncate(kenv_envHandle_t);
extern int csc_settime(kenv_envHandle_t);
extern int csc_reboot(kenv_envHandle_t);
extern int csc_mknod(kenv_envHandle_t);
extern int csc_hardLink(kenv_envHandle_t);
extern int csc_symLink(kenv_envHandle_t);
extern int csc_readSlink(kenv_envHandle_t);
extern int csc_rename(kenv_envHandle_t);
extern int csc_readattr(kenv_envHandle_t);

extern int csc_setUserIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupIds(kenv_envHandle_t, pal_idSet_t *, int);
extern int csc_setGroupSet(kenv_envHandle_t, int, pal_idSet_t *, int);

extern int csc_connect(kenv_envHandle_t);
extern int csc_accept(kenv_envHandle_t);
extern int csc_bind(kenv_envHandle_t);
typedef struct loginData {
    int32_t callerFlags;
    int32_t global_audit;
    int32_t loginLocType;
    int32_t activeLogins;



    int32_t activeLoginsOnTerm;




    char loginPgmKPON[256];
    union {
        char localTermKPON[128];
        oss_nwAddr_t nwTermAddr;
    } termInfo;
} kosseal_loginData_t;
extern int kutil_kossDebugFlag;
extern int kutil_kossActive;
extern int32_t kutil_optionalTraps;







extern int kutil_kossChecksum;




extern kutil_kconfig(pal_scall_parm_t, pal_scall_parm_t,
                       pal_scall_parm_t, pal_scall_parm_t, pal_scall_parm_t,
                       int *);
typedef struct kaznStats {
    int32_t accAllowedCalls;
    int32_t checkAccessCalls;
    int32_t totalGrants;
    int32_t totalDenies;
    int32_t rcGrants;
    int32_t privGrants;
    int32_t padA;
    int32_t loginIdSets;
    int32_t secIdSets;
    int32_t noTrustDenies;
    int32_t impSetId;
    int32_t padB;
    int32_t pdosdCalls;
    int32_t pdosdActiveCalls;
    int32_t pdosdFileCalls;
    int32_t pdosdIdCalls;
    int32_t pdosdNetCalls;
    int32_t pdosdLoginCalls;
    int32_t pdosdFail;
    int32_t pdosdGrantError;
    int32_t pdosdDenyError;
    int32_t pdosdGrantAudit;
    int32_t pdosdDenyAudit;
    int32_t pdosdSlowCalls;
    int32_t pdosdTimeOuts;
    int32_t pdosdBusy;
    int32_t pdosdInWarning;
} kaznStats_t;




extern kazn_expandSRN;
typedef int kazn_aznResult_t;
extern kaznStats_t kaznStats;
extern pal_mutex_t kazn_pathMutex;

extern char *kazn_grantStr;
extern char *kazn_denyStr;

extern int kazn_accessAllowed(kenv_envHandle_t, int, int, int);
extern kazn_aznResult_t kazn_checkAccess(kenv_envHandle_t, int, int, int);
extern void kazn_kpcUpdateLastNotify(void);
extern int kazn_setGrantSuserOnError(int);
extern void kazn_expandTrappedFilePath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kazn_init(void);
extern void kazn_shutdown(void);
typedef enum kpc_notifyOp {
    kpc_opAdd, kpc_opDelete
} kpc_notifyOp_t;

typedef enum kpc_objType {
    kpc_objFile,
    kpc_objNetwork,
    kpc_objIdset,
    kpc_objMyProgram

} kpc_objType_t;


typedef struct _addrType {
    int addrClassic:1;
    int addrV6:1;
    int noProto:1;
    int noServ:1;
    int noHostIP:1;
    int noHostName:1;
    int hostInline:1;
    int nwIn:1;
    int nwOut:1;
    int pad:23;
} kpc_nwAddrType_t;





typedef struct idInfo {
    int64_t idValue __attribute__ ((aligned (8)));
    int isGroupId:1;
} __attribute__ ((aligned (8))) kpc_idInfo_t;







typedef oss_nwAddr_t kpc_nwAddr_t;


typedef struct _portrange {
    uint16_t portLow;
    uint16_t portHigh;
} kpc_portrange_t;
typedef struct _nwdesc {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));



    pal_ptr32_t pHost;

    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        kpc_portrange_t *setp;
    } portRange;
    char *wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc_t;




typedef struct _resInfo {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        kpc_nwDesc_t *nwDesc;


    } resDesc;





    char *resourceName;


    byte_t *extData;


} kpc_resourceInfo_t;
typedef struct kpcRecord {
    kpc_resFlags_t flags;
    int32_t extDataLen;
    int32_t howFound;
    uint32_t branchId;
    int32_t reserved[4];
    char kpon[1024];
    byte_t extData[6144];
} kpc_record_t;
typedef struct _nwdesc32 {
    kpc_nwAddrType_t addrType;
    oss_nwIP_t ipaddr;
    oss_nwIP_t mask;
    uint16_t protocol;
    uint16_t hostDataLen;
    uint16_t significantBits;
    uint16_t numPortRanges;
    uint32_t totalPorts;
    int64_t policyVersion __attribute__ ((aligned (8)));
    pal_ptr32_t pHost;
    char wcHostInline[32];
    union {
        kpc_portrange_t one;
        pal_ptr32_t set;
    } portRange;
    pal_ptr32_t wcHostData;
} __attribute__ ((aligned (8))) kpc_nwDesc32_t;





typedef struct _resInfo32 {



    kpc_notifyOp_t op;
    kpc_objType_t objType;
    kpc_resFlags_t flags;
    int32_t extDataLen;
    uint32_t branchId;



    union {
        kpc_idInfo_t idInfo;
        pal_ptr32_t pnwDesc;


    } resDesc;





    pal_ptr32_t resourceName;


    pal_ptr32_t extData;


} kpc_resourceInfo32_t;



typedef struct kpcattr {
    int64_t kpcEpoch __attribute__ ((aligned (8)));

    int64_t lastNotify __attribute__ ((aligned (8)));
    int64_t policyVersion __attribute__ ((aligned (8)));
    int64_t policyEpoch __attribute__ ((aligned (8)));




    int32_t resourceCount;
} __attribute__ ((aligned (8))) kpc_attr_t;
typedef struct kpc_info {
    kpc_attr_t attrs;
    uint32_t resourceChecks;
    uint32_t doEvals;
    uint32_t resourceAdds;
    uint32_t resourceDeletes;
    uint32_t setVersionCalls;
    uint32_t startEpochCalls;
    uint32_t commitEpochCalls;
} kpc_info_t;

extern kpc_info_t kpcInfo;
typedef struct kpc_kptr
{
    uint32_t high;
    uint32_t low;
} kpc_kptr_t;

typedef struct kpc_fdumpRec {
    uint32_t resFlags;
    uint32_t intResFlags;
    uint32_t pointerSize;
    uint32_t branchId;
    kpc_kptr_t resPtr;
    kpc_kptr_t rfidPtr;
    kpc_kptr_t dfidPtr;
    char resName[156];
} kpc_fdumpRec_t;



typedef struct kpc_fdumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_fdumpRec_t frecs[3072];
} kpc_fdumpBlock_t;



typedef struct kpc_ndumpRec
{
    kpc_nwAddrType_t addrType;
    uint32_t pointerSize;
    uint32_t branchId;
    int64_t policyVersion __attribute__ ((aligned (8)));
    kpc_kptr_t protPtr;
    kpc_kptr_t servPtr;
    kpc_kptr_t hostPtr;
    char resName[156];
} __attribute__ ((aligned (8))) kpc_ndumpRec_t;



typedef struct kpc_ndumpBlock {
    int32_t count;
    uint32_t cookie;
    kpc_ndumpRec_t nrecs[128];
} kpc_ndumpBlock_t;




extern kpc_info_t kpcInfo;
extern void kazn_kpcNetSetActive(int);
extern int kazn_kpcNetGetActive(void);

extern void kazn_kpcInit(void);
extern int kazn_kpcCheckResource(kenv_envHandle_t, int, int, int);
extern int kazn_kpcFileCheckResource(kenv_envHandle_t, int, int);
extern int kazn_kpcNetCheckResource(kenv_envHandle_t, int, int);
extern char *kazn_kpcFileFindPgmResource(kenv_envHandle_t, kpc_resFlags_t *);
extern void kazn_kpcFileDirNotify(char *);
extern char *kazn_kpcFileFindTerminal(kenv_envHandle_t, int *, byte_t **);
extern void kazn_kpcFileInit(void);
extern void kazn_kpcFileShutdown(void);
extern void kazn_kpcFileEpochNotify(int64_t, int);
extern void kazn_kpcNetInit(void);
extern void kazn_kpcNetShutdown(void);
extern void kazn_kpcFileRefreshNotify(kenv_envHandle_t);
extern void kazn_kpcFileCreateNotify(kenv_envHandle_t);
extern int kazn_kpcfRunAsync(void);
extern void kpcf_asyncLUThread(void);
extern int kpcf_asyncStopLookup(void);




void kazn_kpcfTriggerAsyncRefresh(int);

extern void kazn_kpcfStopAsync(void);
extern int64_t kazn_kpcStartNewPolicyEpoch(void);
extern int kazn_kpcCommitPolicyEpoch(int64_t);
extern void kazn_kpcfFlushNegCache(void);


extern void kazn_kpcSetPolicyVersion(int64_t);
extern void kazn_kpcGetAttr(kpc_attr_t *);
extern int kazn_kpcAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcFileDelResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetAddResource(kpc_resourceInfo_t *);
extern int kazn_kpcNetDelResource(kpc_resourceInfo_t *);
extern void kazn_kpcNetSetResource(int, kenv_envHandle_t, char *);
typedef struct kpcfStats {
    int32_t resChecks;
    int32_t resCheckHits;
    int32_t directHits;
    int32_t inheritHits;
    int32_t exceptionHits;
    int32_t wildCardHits;
    int32_t multiHits;
    int32_t exceptionSearches;
    int32_t pfcHits;
    int32_t ncAdds;
    int32_t ncSize;
    int32_t ncChecks;
    int32_t ncHits;
    int32_t ncFlushes;
    int32_t padB;
    int32_t resAdds;
    int32_t resDeletes;
    int32_t resUpdates;
    int32_t excResources;
    int32_t allocedResources;
    int32_t padC;
    int32_t fileRefreshes;
    int32_t refreshAllCalls;
    int32_t refreshSkippedLock;
    int32_t refreshFastExit;
    int32_t dhashRefreshes;
    int32_t refreshGenWrapped;
    int32_t padD;
    int32_t mkdirNotifies;
    int32_t rmdirNotifies;
    int32_t epochRemoves;

    int32_t dhashRefRestarts;


    int32_t tooManyClinks;

    int32_t errorResources;



} kpcFileStats_t;
typedef struct dhashInfo {
    int32_t maxChainLen;
    int32_t avgChainLen;
    int32_t totEntries;
    int32_t numEmptyChains;
    int32_t dirs;
    int32_t nonDirs;
    int32_t oneDir;
} kpcFileDhashInfo_t;






typedef struct pfcStats {
    uint32_t cacheSize;
    uint32_t finds;
    uint32_t hits;
    uint32_t compares;
    uint32_t hashBoosts;
    uint32_t adds;
    uint32_t flushes;
    uint32_t hashPurges;
    uint32_t lruBoost;
} kpcf_pfcStats_t;
typedef struct fileRes {
    kutil_q_t refreshQ;
    kutil_q_t dirFidHashQ;
    kutil_q_t nameHashQ;
    kutil_q_t excQ;


    char *resName;
    void *extData;

    pal_time_t lastRefresh;
    pal_time_t firstDirTime;

    uint32_t branchId;
    uint32_t intFlags;
    uint32_t epoch;
    uint32_t refreshGen;



    int32_t hits;
    uint16_t refCount;
    uint16_t resNameLen;
    uint16_t extDataLen;
    uint16_t nlinks;
    pal_ftypes_t ftype;
    pal_dev_t dev;
    pal_mutex_t rLock;
    pal_cond_t rCond;
    pal_rawFid_t rfid;
    pal_rawFid_t dir_rfid;
    kpc_resFlags_t rflags;
    char *bName;


    pal_vfs_val_t check_vfsp;
    struct fileRes *clink;
    struct fileRes *plink;




    char _lclSpace[27 + 1];
} fileRes_t;
typedef struct fresNode {
    fileRes_t *resp;
    struct fresNode *next;
} fresNode_t;


typedef struct fresList {
    pal_rawFid_t *rFidp;
    pal_rawFid_t *parFidp;
    pal_fattr_t *fap;
    char *nameHint;
    char *bName;
    int16_t frlFlags;
    int16_t bNameLen;
    int count;
    int frlError;
    fresNode_t node;
} fresList_t;
typedef struct _fhq {
    pal_mutex_t hlock;

    uint32_t genNo;

    uint32_t resCount;
    fileRes_t *lastHitDir;

    pal_time_t leastRefreshTime;

    kutil_q_t dfQ[8];
} dirfidHash_t;
extern kpcFileStats_t kpcFileStats;
extern pal_mutex_t fileDbLock;
extern kutil_q_t kpcf_refreshQ;
extern pal_time_t kpcf_refreshQOldest;
extern kpcf_pfcStats_t kpcf_pfcStatInfo;
extern int32_t kpcf_changeGen;
extern int32_t kpcf_adminGen;






extern char *getBaseName(fileRes_t *);
extern fileRes_t *getFileResource(void);
extern void freeFileResource(fileRes_t *);
extern void releFileResource(fileRes_t *);
extern void holdFileResource(fileRes_t *);
extern void fresListAdd(fresList_t *, fileRes_t *);
extern void fresListClean(fresList_t *);
extern fileRes_t *kpcGetUnixRes(void);
extern void kpcInitUnixRes(void);
extern void kpcSetUnixRes(kpc_resFlags_t);
extern void kpcClearUnixRes(void);
extern int kpcfNameHash(char *);
extern int kpcfDirFidHash(pal_rawFid_t *);
extern int kpcfDirFidQueueHash(pal_rawFid_t *);
extern void kpcfSetFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfCheckFidInfo(fileRes_t *, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *);
extern int kpcfGenResFids(fileRes_t *, pal_rawFid_t *,
                          pal_rawFid_t *, pal_fattr_t *, int, int *);
extern void kpcfMarkResourceStale(fileRes_t *);
extern void kpcfSetupKpcInfo(kenv_envHandle_t, fileRes_t *, int, char *);
extern void kpcfMarkDhashStale(int);
extern void kazn_kpcfExpandTrappedPath(kenv_envHandle_t, kenv_kpcInfo_t *,
                                       int, pal_pathBuf_t *);
extern void kpcf_ufileSetActive(int);
extern void kpcf_ufileInit(void);
extern void kpcf_ufileShutdown(void);
extern void kpcf_ufileStats(int);

extern uint32_t kpcf_getFileEpoch(void);

extern void kpcf_pfcAdd(pal_rawFid_t *, fileRes_t *, uint32_t);
extern int kpcf_pfcCheck(pal_rawFid_t *, fileRes_t **);
extern int kpcf_pfcCheckNoAcl(pal_rawFid_t *);
extern int kpcf_pfcFlush(pal_rawFid_t *);
extern void kpcf_pfcFlushProtResp(fileRes_t *);
extern void kpcf_pfcSetActive(int);
extern int kpcf_pfcGetActive(void);
extern void kpcf_pfcStats(int);

extern void kpcf_pfcInit(void);
extern void kpcf_pfcShutdown(void);

extern int kpcf_addResourcesToKPCInfo(fresList_t *,
                                      kenv_envHandle_t, int, int, int);
extern uint32_t kpcf_getNextRefreshGen(void);
extern uint32_t kpcf_getCurRefreshGen(void);
extern int kpcf_checkRefreshGenWrap(uint32_t, uint32_t);
extern void kpcf_refreshQInsertResource(fileRes_t *, int);
extern void kpcf_refreshQRemoveResource(fileRes_t *);
extern int kpcf_findResByResName(char *, fileRes_t **, int *);
extern void kpcf_nameHashInsert(fileRes_t *, int);
extern void kpcf_nameHashRemove(fileRes_t *);
extern fileRes_t *kpcf_nameHashSearch(char *, int);
extern int kpcf_findFidByFidOnly(fresList_t *);
extern int kpcf_dumpResources(kpc_fdumpRec_t *, int *, int *);
extern int kpcf_getResInfoByResName(kpc_record_t *);
extern void kpcf_checkForFidAliases(kutil_q_t *, fileRes_t *);
extern int kpcf_negCacheCheck(pal_rawFid_t *);
extern void kpcf_negCacheAdd(pal_rawFid_t *);
extern pal_time_t kpcf_negCacheFlush(pal_rawFid_t *);
extern void kpcf_negCacheFlushAll(void);
extern void kazn_kpcfSuspendFileLkups(int);
extern void kazn_kpcfResumeFileLkups(void);

extern void kpcf_subrInit(void);
extern void kpcf_subrShutdown(void);
typedef struct nct_asyncNode {
    kutil_q_t q;
    int op;
    int aflags;
    int returnCode;
    pal_pid_t accPid;
    void *uniquifier;

    int reqSeqNum;
    pal_idList_t idList;
    void (*notify_func)(void *);
    void *notify_arg;
    int nwProto;
    char remAddrBuf[48];
    char locAddrBuf[48];
} nct_asyncNode_t;
typedef struct _cpath {
    char *path;
    int allocLen;




    char lclStr[80];
} cpPath_t;
extern int nct_asyncRequest(nct_asyncNode_t *);
extern void nct_asyncInit(void);
extern void nct_asyncShutdown(void);

extern int nct_addAuxPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_processPath(char *, cpPath_t *, int, int, kenv_env_t *);
extern int nct_callCsc(kenv_env_t *, int);
extern int nct_checkPathOp(kenv_env_t *, char *, cpPath_t *, int, int);
extern int nct_checkFdOp(kenv_env_t *, int, int);
extern int nct_openCommon(char *, cpPath_t *, int, kenv_env_t *, int *);
extern int nct_killCommon(pal_pid_t, int, int *);
extern int nct_mkdirCommon(char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_linkCommon(char *, char *,
                          cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_renameCommon(char *, char *,
                            cpPath_t *, cpPath_t *, kenv_env_t *, int *);
extern int nct_symlinkCommon(char *, char *, cpPath_t *, kenv_env_t *, int *);
extern int nct_mknodCommon(char *, pal_dev_t *,
                           pal_ftypes_t, cpPath_t *, kenv_env_t *, int *);
extern int nct_execCommon(char *, cpPath_t *, void *, kenv_env_t *, int *);
extern int nct_runAsync(void);
extern void nct_stopAsync(void);
extern void nct_postRenameCommon(kenv_env_t *);
extern void nct_postLinkCommon(kenv_env_t *);
extern void nct_postSymlinkCommon(kenv_env_t *);
extern void nct_postMknodCommon(kenv_env_t *);
extern void nct_postOpenCommon(kenv_env_t *, int, int);
extern void nct_postMkdirCommon(kenv_env_t *);
extern int nct_setuidCommon(kenv_env_t *, pal_idSet_t *,
                            pal_authID_t, int, int *);
extern int nct_setgidCommon(kenv_env_t *, pal_idSet_t *, int, int *);
typedef struct kaud_auditEventInfo {
    uint32_t flags;



    uint32_t kaud_magic;
    uint32_t event_id;
    uint32_t aud_fail_status;
    uint32_t aud_report_flags;
    uint32_t aud_qualifier;
    uint32_t aud_permissions;
    uint16_t aud_view;
    uint16_t aud_action;
    uint16_t aud_reason;
    uint16_t aud_outcome;
    uint16_t aud_resource_type;
    int64_t aud_accessor_uid __attribute__ ((aligned (8)));
    int64_t aud_target_id __attribute__ ((aligned (8)));
    int64_t aud_accessor_pid __attribute__ ((aligned (8)));
    int64_t aud_accessor_eff_id __attribute__ ((aligned (8)));
    int64_t aud_accessor_real_id __attribute__ ((aligned (8)));




    uint32_t aud_nw_flags;
    oss_nwAddr_t aud_local_conn;
    oss_nwAddr_t aud_remote_conn;
    oss_nwAddr_t aud_remote_login_term;



    char aud_target_pon[256];
    char aud_target_srn[256];
    char aud_branch_name[80];
    char aud_local_term[80];
    char aud_accessor_name[24];
    char aud_program_name[256];




} __attribute__ ((aligned (8))) kaud_auditEventInfo_t;
extern int kaud_syscall(pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, pal_scall_parm_t,
                        pal_scall_parm_t, int *);


extern int kaud_setAuditLevel(int32_t);




extern int kaud_intTraceFlags;
extern int kaud_checkTrace;
extern int kaud_doLogoutAudit;
extern int kaud_eucTraceUsers;
typedef struct kaud_auditServInfo {
   uint32_t event_id;
   uint32_t aud_view;
   uint64_t aud_action;
   uint32_t aud_reason;
   uint32_t aud_outcome;
   uint32_t aud_fail_status;
   uint32_t aud_resr_type;
   uint32_t pol_flags;
   uint64_t pol_epoch;
   uint64_t pol_version;
} kaud_auditServInfo_t;
extern int kaud_expandSRN;
extern int32_t kaud_audit_level;
extern int32_t kaud_warning_mode;

extern int kaud_auditService(kaud_auditServInfo_t*);
extern int kaud_logUserAuditEvent(kaud_auditEventInfo_t *);
extern int kaud_auditTraceEvent(kenv_envHandle_t, int, int, int);
extern int kaud_eucAdd(pal_authID_t uid, uint32_t states);
extern int kaud_eucDel(pal_authID_t uid);
extern int kaud_eucDump(pal_authID_t *, uint32_t *, int);
extern void kaud_auditLogout(pal_authID_t,pal_pid_t,int,char *,pal_nwAddr_t *);

extern void kaud_init(void);
extern void kaud_shutdown(void);





extern void eucReset(void);
int kenv_procDebug=0;
kenv_procStats_t kenv_procStats = {0};
pal_mutex_t procMainLock;
kutil_q_t procDeadQ;

int kenv_procCondAdds = 0;



static int procShuttingDown = 0;


typedef struct fdEntry {
    void *dvh;
    uint16_t flags;
    uint16_t fd;
} fdEntry_t;
typedef struct procCoreState {
    kenv_procFlags_t pflags;
    int32_t loginState;

    pal_authID_t accId;
    pal_authID_t impId;
    pal_authID_t directLoginId;
} procCoreState_t;


typedef struct precord {
    kutil_q_t q;
    pal_pid_t pid;
    pal_pid_t ppid;
    uint32_t hits;
    procCoreState_t cstate;
    union {
        uintptr_t local;
        oss_nwIP_t rmt;
    } termData;






    fdEntry_t *fdTable;
    uint16_t fdTableSize;
    uint16_t lastFdSlot;
    uint16_t fdActive;
    uint16_t inPort;
    uint32_t streamCount;
    void * uniquifier;
    int16_t pgmPathLen;
    int16_t links;
    int mode;
    uint32_t dirCt;
    char *pgmPath;
    pal_rawFid_t pgmFid;
    pal_fid_t dirFid;



    oss_nwIP_t remoteAddr;
    fdEntry_t lcl_fdTable[15];


    char __pgmPath[64];
} procRecord_t;
kutil_q_t procQueue[367];






typedef struct procHashLock {
    pal_mutex_t lock;





    int index;
    uint32_t cacheLinePad[16];
} procHashLock_t;

typedef procHashLock_t *proc_lhandle_t;


procHashLock_t procHashLocks[128];
int kenv_procRegisteredProcs = 0;
pal_mutex_t procRegisterLock;
static void
procAdjustRegisteredCount(int count)
{
    (kail_mutex_lock(&procRegisterLock));
    kenv_procRegisteredProcs += count;

    ;


    if (kenv_procRegisteredProcs < 0)
        kenv_procRegisteredProcs = 0;

    (kail_mutex_unlock(&procRegisterLock));
}
int
kenv_procGetRegisteredCount(void)
{
    int count;

    (kail_mutex_lock(&procRegisterLock));
    count = kenv_procRegisteredProcs;
    (kail_mutex_unlock(&procRegisterLock));
    return count;
}
static void
freePgmName(procRecord_t *pp)
{
    ;
    if (pp->pgmPath != pp->__pgmPath) {
        pal_free(pp->pgmPath, pp->pgmPathLen + 1);
    }
    pp->pgmPath = NULL;
}
static void
setPgmName(procRecord_t *pp, char *pname, int nlen)
{
    ;
    ;

    if (nlen == 0)
        nlen = strlen(pname);

    if (nlen >= 64) {
        pp->pgmPath = pal_alloc(nlen + 1);
    } else {
        pp->pgmPath = pp->__pgmPath;
    }

    if (pp->pgmPath) {
        memcpy(pp->pgmPath,pname,nlen + 1);
        pp->pgmPathLen = nlen;
    }
}
static procRecord_t *
getPrec(void)
{
    procRecord_t *pp;




    pp = (procRecord_t *)pal_alloc(sizeof(*pp));
    if (pp) {
        memset((char *)pp,0,sizeof(*pp));
        do { (pp)->fdTableSize = 15; (pp)->fdTable = (pp)->lcl_fdTable; (pp)->lastFdSlot = (pp)->fdActive = 0; } while ( 0);
        pp->cstate.accId = -2;

    }
    return pp;
}
static void
procLockForTwoPids(
    pid_t pid1,
    pid_t pid2,
    proc_lhandle_t *lhandle1,
    proc_lhandle_t *lhandle2)
{
    int phash1, phash2;
    proc_lhandle_t lh1, lh2;


    phash1 = (((uint32_t)(pid1)) % 367);
    phash2 = (((uint32_t)(pid2)) % 367);
    lh1 = &procHashLocks[((phash1) & (128 - 1))];
    lh2 = &procHashLocks[((phash2) & (128 - 1))];
    *lhandle1 = lh1;
    *lhandle2 = lh2;


    if (lh1 == lh2) {
        (kail_mutex_lock(&(lh1)->lock));
    } else if (lh1->index < lh2->index) {
        (kail_mutex_lock(&(lh1)->lock));
        (kail_mutex_lock(&(lh2)->lock));
    } else {
        (kail_mutex_lock(&(lh2)->lock));
        (kail_mutex_lock(&(lh1)->lock));
    }
}
static void
procUnlockTwoLhandles(proc_lhandle_t lh1, proc_lhandle_t lh2)
{
    if (lh1) {
        (kail_mutex_unlock(&(lh1)->lock));
    }
    if (lh2 && (lh2 != lh1)) {
        (kail_mutex_unlock(&(lh2)->lock));
    }
}
static procRecord_t *
procSearchDead(pal_pid_t pid, void *unique)
{
    procRecord_t *pp = (procRecord_t *)NULL;
    kutil_q_t *qp, *qpNext;




    (kail_mutex_lock(&procMainLock));;
    for (qp = ((&procDeadQ)->next); qp != &procDeadQ; qp = qpNext) {
        qpNext = ((qp)->next);
        if ( (pid == (((procRecord_t *)(qp))->pid)) &&
             ((((procRecord_t *)(qp))->uniquifier) == unique) ) {
            pp = (procRecord_t *)qp;
            break;
        }
    }
    if (!pp) {
        (kail_mutex_unlock(&procMainLock));;
    }



    return(pp);
}
static procRecord_t *
procSearchHash(pal_pid_t pid, int searchHash)
{
    kutil_q_t *qp;
    kutil_q_t * const hq = &procQueue[searchHash];
    procRecord_t *precp;
    int misses;

    for (qp = (((kutil_q_t *)hq)->next), misses = 0;
        qp != hq; qp = ((qp)->next), misses++) {
        precp = (procRecord_t *)qp;
        if (precp->pid == pid) {
            precp->hits++;
            if (misses && ((misses > 3) || !(precp->hits & 63))) {
                do { (kail_mutex_lock(&procMainLock));; (++kenv_procStats.hashBoosts); (kail_mutex_unlock(&procMainLock));; } while ( 0);
                (((&precp->q)->next)->prev = ((&precp->q)->prev), ((&precp->q)->prev)->next = ((&precp->q)->next));
                ((&precp->q)->next = (((kutil_q_t *)hq)->next), (&precp->q)->prev = (hq), (((kutil_q_t *)hq)->next)->prev = (&precp->q), (hq)->next = (&precp->q));
            }
            return precp;
        }
    }
    return NULL;
}
static procRecord_t *
procSearch(pal_pid_t pid, proc_lhandle_t *lockHandle)
{
    const int h = (((uint32_t)(pid)) % 367);
    procRecord_t *precp;
    proc_lhandle_t lhandle;

    lhandle = &procHashLocks[((h) & (128 - 1))];
    (kail_mutex_lock(&(lhandle)->lock));
    if (precp = procSearchHash(pid, h)) {
        *lockHandle = lhandle;
    } else {
        (kail_mutex_unlock(&(lhandle)->lock));
    }
    return precp;
}
static void
inheritFdTable(procRecord_t *childp, procRecord_t *parentp)
{
    const int lSlot = parentp->lastFdSlot;
    int i;
    fdEntry_t *ep, *par_ep;

    if (lSlot > 15) {
        childp->fdTable = (fdEntry_t *)pal_alloc(lSlot * sizeof(fdEntry_t));
        if (childp->fdTable) {
            memset(childp->fdTable,0,lSlot * sizeof(fdEntry_t));
            childp->fdTableSize = lSlot;
        }
    }

    if (childp->fdTable) {
        for (i = 0, ep = childp->fdTable, par_ep = parentp->fdTable;
            i < lSlot; i++, par_ep++) {
            if (((par_ep)->dvh && (((par_ep)->flags & (0x1 | 0x20)) == 0x1))) {
                ;
                do { int _fl = 0x1; (ep)->fd = (par_ep->fd); if (par_ep->dvh) { pal_holdVnode(par_ep->dvh); (ep)->dvh = (par_ep->dvh); _fl |= 0x2; (childp)->fdActive++; } (ep)->flags = _fl; } while ( 0);

                ep->flags |= par_ep->flags;
                ep++;
                childp->lastFdSlot++;
            }
        }



    }
}
void
kenv_procAdd(pal_pid_t pid, pal_pid_t parentPid, int addFlags)
{
    int setAccId = 1, phash, phashParent, traceId;
    proc_lhandle_t lhandle, lhandleParent;
    pal_pid_t tpid;
    pal_idList_t idl;
    kenv_procFlags_t child_pf;
    procRecord_t *pp, *parentp, *newProc;
    void *traceChan;
    if (((pid) == 1)) {
        return;
    }
    if (!(newProc = getPrec())) {
        return;
    }

    ;
    phash = (((uint32_t)(pid)) % 367);
    if (parentPid) {
        phashParent = (((uint32_t)(parentPid)) % 367);
        procLockForTwoPids(pid, parentPid, &lhandle, &lhandleParent);
    } else {
        lhandle = &procHashLocks[((phash) & (128 - 1))];
        (kail_mutex_lock(&(lhandle)->lock));
    }

    if (!(pp = procSearchHash(pid, phash))) {
        pp = newProc;
        newProc = NULL;

        pp->pid = pid;
        pp->uniquifier = pp;
        if (parentPid) {
            pp->ppid = parentPid;
            if (parentp = procSearchHash(parentPid, phashParent)) {
                pp->remoteAddr = parentp->remoteAddr;
                pp->links = parentp->links;
                pp->mode = parentp->mode;
                pp->cstate.accId = parentp->cstate.accId;
                child_pf = parentp->cstate.pflags;
                if ((parentp->cstate.pflags & 0x4) ||
                    (child_pf & 0x4)) {




                    pal_checkInheritLoginState(parentp->pgmPath,
                                               parentp->cstate.pflags,
                                               parentp->cstate.loginState,
                                               &(pp->cstate.loginState));
                }
                setAccId = 0;


                child_pf &= ~(0x1000 | 0x00400000 | 0x2000 | 0x80000 | 0x20000 | 0x00200000 | 0x01000000);

                if (parentp->pgmPath) {
                    setPgmName(pp, parentp->pgmPath, parentp->pgmPathLen);
                }

                if (child_pf & 0x100) {
                    pp->pgmFid = parentp->pgmFid;
                    pp->dirFid = parentp->dirFid;
                    pp->dirCt = parentp->dirCt;
                }

                if (child_pf & 0x200) {
                    pp->cstate.impId = parentp->cstate.impId;
                }

                if (child_pf & 0x1) {
                    if ((child_pf & 0x40)) {

                        child_pf &=
                            ~(0x1 | 0x40);
                    }
                }





                if (child_pf & 0x8000) {
                    memcpy(&(pp->termData.rmt),&(parentp->termData.rmt),sizeof(oss_nwIP_t));

                }

                inheritFdTable(pp, parentp);

                if (child_pf & 0x80) {
                    if (child_pf & 0x20) {




                        child_pf &= ~0x80;
                    } else {



                        procAdjustRegisteredCount(1);
                    }
                }




                pp->cstate.pflags = child_pf;
            }
        }

        if (!parentp) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_ADD_NO_PAR, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)pp->pid), (long)(int)parentPid),0) : 0);

        }

    noinherit:
        if (setAccId) {
            tpid = kail_pid_get_epid(kail_current_tid());
            pal_getREUids(&idl);
            if ((pid == tpid) || (parentPid == tpid)) {
                pp->cstate.accId = idl.realId;



            } else if (addFlags & 0x8) {
                pp->cstate.accId = idl.realId;
            } else if (addFlags & 0x4) {
                pp->cstate.accId = idl.effId;
            } else {
                pp->cstate.pflags = 0x20;




            }
        }

        ((&pp->q)->next = (((kutil_q_t *)&procQueue[phash])->next), (&pp->q)->prev = (&procQueue[phash]), (((kutil_q_t *)&procQueue[phash])->next)->prev = (&pp->q), (&procQueue[phash])->next = (&pp->q));
        (kail_mutex_lock(&procMainLock));;
        (++kenv_procStats.activeProcs);
        (++kenv_procStats.procAdds);
        (kail_mutex_unlock(&procMainLock));;

        traceChan = ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active))?
                (kt_chanID_t)&kt_defChannels[7]: (kt_chanID_t)&kt_defChannels[2];

        if (addFlags & 0x10) {
            traceId = ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active))?
                KT_TRACE_FFDC_PROC_ADD_PPID : KT_TRACE_KENV_PROC_ADD_PPID;
            ((((kt_channel_t *)traceChan)->active) ? (kt_Event5(traceChan, traceId, (((2)<<28) + ((2)<<24) + ((6)<<20) + ((2)<<16) + ((1)<<12) + ((0)<<8)), (long)(pid), (long)parentPid, (long)pp->cstate.pflags, (long)pp->cstate.accId ,(long)(pp->pgmPath? pp->pgmPath: "U/K")),0) : 0);



        } else {
            traceId = ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active))?
                KT_TRACE_FFDC_PROC_ADD : KT_TRACE_KENV_PROC_ADD;
            ((((kt_channel_t *)traceChan)->active) ? (kt_Event4(traceChan, traceId, (((2)<<28) + ((6)<<24) + ((2)<<20) + ((1)<<16)), (long)(pid), (long)pp->cstate.pflags, (long)pp->cstate.accId, (long)(pp->pgmPath? pp->pgmPath: "U/K")),0) : 0);


        }

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_NEW_PROC_INFO, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)((int)pp->cstate.impId), (long)pp->lastFdSlot, (long)pp->fdActive, (long)pp->fdTableSize),0) : 0);





    }
    else {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_EXISTS, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)((int)pid), (long)(int)parentPid, (long)(int)pp->ppid),0) : 0);


    }


    if (parentPid) {
        procUnlockTwoLhandles(lhandle, lhandleParent);
    } else {
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (newProc) {
        pal_free((newProc), sizeof(*(newProc)));
    }
}
int
kenv_procConditionalAdd(pal_pid_t pid, pal_pid_t ppid, int flags)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int didAdd = 0;


    if (pp = procSearch(pid, &lhandle)) {
        (kail_mutex_unlock(&(lhandle)->lock));



        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 6) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_ALREADY, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)((int)pid), (long)(int)pp->ppid),0) : 0);

        if ((flags & 0x20) && (ppid != pp->ppid)) {





            kenv_procDelete(pid);
            kenv_procAdd(pid,ppid,flags);
        }
    } else {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_CONDADD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)((int)pid), (long)(int)ppid, (long)flags),0) : 0);


        if ((flags == 0x1) || (ppid != 0)) {



            didAdd = 1;
            kenv_procAdd( pid, ppid, flags );
            kail_atomic_add((int)(1),(void *)(&kenv_procCondAdds));
            if (kenv_procCondAdds % 1000 == 0) {




                kenv_procPurgeStale(0);
            }
        }
    }

    return(didAdd);
}
static void
closeOpens(procRecord_t *pp, int fdLow, int onlyCoE)
{
    int i, cF = 0x10;
    const int lastSlot = pp->lastFdSlot;
    fdEntry_t *ep;

    if (onlyCoE) {

        cF = 0;
    }

    for (i = 0, ep = pp->fdTable;i < lastSlot; i++, ep++) {
        if (((ep)->flags == 0x0)) {
            continue;
        }
        if (onlyCoE && pal_unixDescIsCOE(ep->fd)) {
            ep->flags |= 0x10;
        }
        if ((ep->fd >= fdLow) && ((ep->flags & 0x10) | cF)) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KENV_PR_CLOSE_FD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ep->fd), (long)pp->pid, (long)ep->flags, (long)i),0) : 0);


            do { if ((ep)->dvh) { pal_releVnode((ep)->dvh); (ep)->dvh = NULL; (pp)->fdActive--; ; } (ep)->fd = 0; (ep)->flags = 0x0; } while ( 0);
        }
    }
}
static void
procAuditLogout(void *procp)
{
    procRecord_t *pp = (procRecord_t *)procp;
    nct_asyncNode_t *arp;
    char *ltermp = NULL;
    pal_nwAddr_t remTerm, *rtermp = NULL;
    int auditUser=0;

    ;

    arp = (nct_asyncNode_t *)pp->fdTable;
    pp->fdTable = NULL;
    pal_free(arp, sizeof(*arp));

    if ((pp->cstate.pflags & 0x20000) && pp->termData.local) {
        ltermp = (char *)(pp->termData.local);
    } else if (pp->cstate.pflags & 0x8000) {
        memset(&remTerm,0,sizeof(remTerm));
        rtermp = &remTerm;
        memcpy(&(remTerm.ip),&(pp->termData.rmt),sizeof(oss_nwIP_t));
    }

    if ((pp->cstate.pflags & 0x80000)) {



        auditUser = (pp->cstate.pflags & 0x01000000) ? 1 : 0;
        kaud_auditLogout(pp->cstate.accId, pp->pid, auditUser, ltermp, rtermp);
    }

    if (ltermp) {
        pal_free(ltermp, strlen((char *)ltermp) + 1);
        pp->termData.local = (uintptr_t) NULL;
    }

    pal_free((pp), sizeof(*(pp)));
}
static void
procDelete(procRecord_t *pp)
{
    nct_asyncNode_t *arp;
    int code, do_putPrec = 1;
    void *traceChan = (kt_chanID_t)&kt_defChannels[7];
    int traceId = KT_TRACE_FFDC_PROC_TERM;

    ;

    do { (kail_mutex_lock(&procMainLock));; (--kenv_procStats.activeProcs); (kail_mutex_unlock(&procMainLock));; } while ( 0);
    if (!((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active))) {
        traceChan = (kt_chanID_t)&kt_defChannels[2];
        traceId = KT_TRACE_KENV_PROC_TERM;
    }
    ((((kt_channel_t *)traceChan)->active) ? (kt_Event3(traceChan, traceId, (((2)<<28) + ((6)<<24) + ((2)<<20) + ((0)<<16)), (long)(pp->pid), (long)pp->cstate.pflags, (long)pp->lastFdSlot),0) : 0);


    if (pp->cstate.pflags & 0x80) {
        procAdjustRegisteredCount(-1);
    }
    if (pp->pgmPath) {
        freePgmName(pp);
    }

    closeOpens(pp, 0, 0);
    ;

    if (pp->fdTable != pp->lcl_fdTable) {




        pal_free(pp->fdTable, pp->fdTableSize * sizeof(fdEntry_t));
    }

    if ((pp->cstate.pflags & 0x80000) && !procShuttingDown) {
        if (pp->cstate.pflags & 0x8000) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_LOGOUT_REM, (((2)<<28) + ((2)<<24) + ((6)<<20) + ((0)<<16)), (long)((int)pp->cstate.accId), (long)ntohl(pp->termData.rmt.addr.addrClassic.addr), (long)(int)pp->cstate.pflags),0) : 0);




            if (pp->termData.rmt.ipV6) {
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_IPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(pp->termData.rmt.addr.a32[0])), (long)ntohl(pp->termData.rmt.addr.a32[1]), (long)ntohl(pp->termData.rmt.addr.a32[2]), (long)ntohl(pp->termData.rmt.addr.a32[3])),0) : 0);




            }
        } else if ((pp->cstate.pflags & 0x20000) &&
                   pp->termData.local) {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_LOGOUT_LOC, (((2)<<28) + ((1)<<24) + ((6)<<20) + ((0)<<16)), (long)((int)pp->cstate.accId), (long)(char *)(pp->termData.local), (long)(int)pp->cstate.pflags),0) : 0);



        } else {
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[7])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[7], KT_TRACE_FFDC_LOGOUT_LOC, (((2)<<28) + ((1)<<24) + ((6)<<20) + ((0)<<16)), (long)((int)pp->cstate.accId), (long)"U/K", (long)(int)pp->cstate.pflags),0) : 0);



        }
    }
    if ((pp->cstate.pflags & 0x80000) &&
        (pp->cstate.pflags & 0x00200000) && !procShuttingDown) {
        arp = (nct_asyncNode_t *)pal_alloc(sizeof(*arp));
        if (arp) {
            memset((char *)arp,0,sizeof(*arp));
            arp->op = 3;
            arp->notify_func = procAuditLogout;
            arp->notify_arg = (void *)pp;
            pp->fdTable = (fdEntry_t *)arp;
            code = nct_asyncRequest(arp);
            if (code == 0) {
                do_putPrec = 0;
            } else {
                pal_free(arp, sizeof(*arp));
                pp->fdTable = pp->lcl_fdTable;
            }
        }
    }

    if (do_putPrec) {
        if ((pp->cstate.pflags & 0x20000) && (pp->termData.local)) {
            pal_free((void *)(pp->termData.local),
                     strlen((char *)(pp->termData.local)) + 1);
            pp->termData.local = (uintptr_t) NULL;
        }
        pal_free((pp), sizeof(*(pp)));
    }
}
int
kenv_procDelete(pal_pid_t pid)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int rc = 0;

    if (pp = procSearch(pid, &lhandle)) {
        (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));




        kenv_procClearExecMem((void *)pp);

        if (!(pp->streamCount) || (pp->cstate.pflags & 0x80)) {
            procDelete(pp);
            rc = 1;
        } else {






            closeOpens(pp,0,0);
            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_DELAY_PROC_DEL, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pp), (long)(int)pid, (long)pp->streamCount),0) : 0);






            ((&(pp->q))->next = (&(pp->q))->prev = (&(pp->q)));




            (kail_mutex_lock(&procMainLock));;
            ((&(pp->q))->next = (&(procDeadQ)), (&(pp->q))->prev = (((kutil_q_t *)&(procDeadQ))->prev), (((kutil_q_t *)&(procDeadQ))->prev)->next = (&(pp->q)), (&(procDeadQ))->prev = (&(pp->q)));
            (kail_mutex_unlock(&procMainLock));;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
    return(rc);
}
int
kenv_procDelProcFlags(pal_pid_t pid, kenv_procFlags_t pflags, int isExec)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kenv_procFlags_t old_pf, pf = pflags;
    int didDel = 0;



    (!(!(pf & 0x80))? (*((char *)0) = 0) : 0);
    if (pf & (0x1 | 0x2)) {



        pf |= (0x1 |
               0x2 | 0x40);
    }

    if (pp = procSearch(pid, &lhandle)) {
        old_pf = pp->cstate.pflags;
        pp->cstate.pflags &= ~pf;
        if (isExec) {
            closeOpens(pp, 0, 1);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
        didDel = 1;
    }

    if (didDel) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KENV_PR_DEL_FLAGS, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pflags), (long)pid, (long)old_pf),0) : 0);



    }
    return didDel;
}
static int
addProcFlags(procRecord_t *pp, kenv_procFlags_t *flags)
{
    int didAdd = 0;
    kenv_procFlags_t nf = *flags;
    kenv_procFlags_t cf = pp->cstate.pflags;

    ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_ADD_FLAGS, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(nf), (long)pp->pid, (long)cf),0) : 0);




    nf &= ~cf;


    (!(!(nf & 0x80))? (*((char *)0) = 0) : 0);
    if (nf) {
        if (nf & 0x20) {

            cf &= ~(0x2 | 0x1);
        } else if (nf & (0x2 | 0x1)) {

            cf &= ~0x20;
        }

        if (nf & 0x4000) {
            if (!(cf & (0x4000 |0x40000))) {





                cf |= 0x80000;

                cf &= ~0x800;
            }
        }

        pp->cstate.pflags = cf | nf;
        didAdd = 1;
    }

    *flags = pp->cstate.pflags;
    return didAdd;
}
static int
procSetCoreState(pal_pid_t pid, int what, procCoreState_t *cstate)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kenv_procFlags_t pf;
    int didSetState=0;

    if (pp = procSearch(pid, &lhandle)) {
        if (what & 0x1) {
            pf = cstate->pflags;
            didSetState = addProcFlags(pp, &pf);
        }

        if (what & 0x4) {



            pp->cstate.impId = 0;
            pp->cstate.accId = cstate->accId;
            pp->cstate.pflags |= 0x400;
            pp->cstate.pflags &= ~0x200;
            didSetState = 1;
        }

        if (what & 0x8) {
            pp->cstate.impId = cstate->impId;
            pp->cstate.pflags |= 0x200;
            didSetState = 1;
        }

        if (what & 0x2) {
            pp->cstate.loginState = cstate->loginState;
            pp->cstate.pflags |= 0x800;
            didSetState = 1;
        }

        if (what & 0x10) {





            pp->cstate.directLoginId = cstate->directLoginId;
            pp->cstate.pflags |= (0x40000 | 0x80000 |
                             0x4000);
            didSetState = 1;
        }

        if (what & 0x1000) {
            *cstate = pp->cstate;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    } else {
        didSetState = -1;
    }

    return didSetState;
}
static int
kenv_procUpdateOnExec(pal_pid_t pid, pal_pid_t ppid,
                      kenv_procFlags_t clear_par_flags)
{
    int phash, phashParent, rc=0;
    proc_lhandle_t lhandle, lhandleParent;
    procRecord_t *pp, *parentp;
    kenv_procFlags_t old_pf;

    ;


    phash = (((uint32_t)(pid)) % 367);
    phashParent = (((uint32_t)(ppid)) % 367);
    procLockForTwoPids(pid, ppid, &lhandle, &lhandleParent);

    if (pp = procSearchHash(pid, phash)) {
        if (parentp = procSearchHash(ppid, phashParent)) {




            if (clear_par_flags & 0x20000) {
                pp->termData.local = parentp->termData.local;
                parentp->termData.local = (uintptr_t)NULL;
                ;

            }
            old_pf = parentp->cstate.pflags;
            parentp->cstate.pflags &= ~clear_par_flags;

            ;


            pal_loginOriginWasReset(&(parentp->cstate.loginState));

            rc = 1;
        } else {
            ;
        }
    } else {
        ;
    }

    procUnlockTwoLhandles(lhandle, lhandleParent);
    return(rc);
}
int
kenv_procSetProgramData(
    pal_pid_t pid,
    pal_rawFid_t *rfp,
    pal_rawFid_t *dir_rfp,
    pal_fattr_t *fap,
    char *pname,
    kenv_procFlags_t *pflags,
    int inFlags)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    pal_nwAddr_t nwa;
    int nlen, i, rc, didUpdate = 0, netTerm = 0, proto;
    kenv_procFlags_t newpf = *pflags, clear_flags=0;
    pal_pid_t ppid;

    if (inFlags & 0x2) {
        if (pal_netSockFdToAddrInfo(0, &proto, &nwa, NULL) == 0) {
            netTerm = 1;
        }
    }

    if (pp = procSearch(pid, &lhandle)) {
        kenv_procFlags_t savepf = pp->cstate.pflags;
        didUpdate = 1;
        if (inFlags & 0x1) {
            kenv_procFlags_t my_flags = pp->cstate.pflags;

            pp->cstate.pflags &= ~(0x2 | 0x4 | 0x8 | 0x10 | 0x00100000);

            if (inFlags & 0x4) {
                pal_execChecking(pname, &(pp->cstate.loginState),
                                 &(pp->cstate.pflags),
                                 &clear_flags);
                if (clear_flags) {

                    ppid = pp->ppid;
                }
            }






            if (newpf & 0x4) {
                if (my_flags & 0x4) {



                    pp->cstate.pflags &=
                        ~(0x1000 | 0x2000);
                } else {


                    pp->cstate.pflags &=
                        ~(0x4000 | 0x1000 |
                          0x2000 | 0x40000);
                }
            }
        }

        if (inFlags & 0x4) {
            closeOpens(pp, 0, 1);
            if ((pp->cstate.pflags & (0x20 | 0x80)) ==
                (0x20 | 0x80)) {




                pp->cstate.pflags &= ~0x80;
                procAdjustRegisteredCount(-1);
            }
        }

        if (pname) {
            if (pp->pgmPath) {
                freePgmName(pp);
            }
            setPgmName(pp, pname, 0);
        }

        if (rfp) {





            if (pp->cstate.pflags & 0x100) {
                if ((((((!memcmp((&(((&pp->pgmFid)))->fid),(&(((rfp)))->fid),((&(((&pp->pgmFid)))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&(((&pp->pgmFid)))->fsid)->val[0] == (&(((rfp)))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x100)) {
                    if (savepf & 0x2) {
                        pp->cstate.pflags |= 0x2;
                    }
                }
            }
            pp->pgmFid = *rfp;
            pp->cstate.pflags |= 0x100;
        }

        if (dir_rfp) {
            pp->dirFid = dir_rfp->fid;
            pp->dirCt = (pal_time_t)((dir_rfp)->ctime);
        }

        if (fap) {
            pp->mode = fap->mode;
            pp->links = fap->links;
        }

        if (newpf) {
            (void)addProcFlags(pp, &newpf);
        }

        if (netTerm && !(pp->cstate.pflags & 0x20000)) {
            memcpy(&(pp->termData.rmt),&(nwa.ip),sizeof(oss_nwIP_t));
            pp->cstate.pflags |= 0x8000;
            if (nwa.ip.ipV6) {
                pp->cstate.pflags |= 0x10000;
            }
        }
        newpf = pp->cstate.pflags;
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (clear_flags) {



        kenv_procUpdateOnExec(pid, ppid, clear_flags);
    }

    if (didUpdate) {
        *pflags = newpf;
    } else {
        *pflags = 0;
    }
    return didUpdate;
}
int
kenv_procClearExecData(pal_pid_t pid)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int rc=0;

    if (pp = procSearch(pid, &lhandle)) {
        if (pp->cstate.pflags & 0x02000000) {
            pp->cstate.pflags &= ~(0x02000000);
            (kail_mutex_unlock(&(lhandle)->lock));
            rc=1;
        } else {
            (kail_mutex_unlock(&(lhandle)->lock));
        }
    }

    return(rc);
}
void
kenv_procClearExecMem(void *_pp)
{
    procRecord_t *pp = (procRecord_t *)_pp;
    proc_lhandle_t lhandle;
    int rc;

    if (!pp) {
        pp = procSearch(kail_pid_get_epid(kail_current_tid()), &lhandle);
    }

    if (pp) {
        if (pp->cstate.pflags & 0x02000000) {
            pp->cstate.pflags &= ~(0x02000000);
            if (!_pp) {
                (kail_mutex_unlock(&(lhandle)->lock));
            }
        } else if (!_pp) {
            (kail_mutex_unlock(&(lhandle)->lock));
        }
    }
}
void
kenv_procSavePutMemInfo(kenv_pathMemInfo_t *pMemInfo)
{
}
void
kenv_procResetSharedMem(pal_pid_t pid)
{
}
int
kenv_procGetRterm(pal_pid_t pid , pal_nwAddr_t *nwa)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int found = 0;

    if (pp = procSearch(pid, &lhandle)) {
        if (pp->cstate.pflags & 0x8000) {
            memset((char *)nwa,0,sizeof(*nwa));
            memcpy(&(nwa->ip),&(pp->termData.rmt),sizeof(oss_nwIP_t));
            found = 1;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return found;
}
int
kenv_procCheckSetRterm(pal_pid_t pid, pal_nwAddr_t *nwa)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int found = 0;

    if (pp = procSearch(pid, &lhandle)) {
        if ((pp->cstate.pflags & 0x4) &&
            !(pp->cstate.pflags & 0x80000) ) {
            if (!(pp->cstate.pflags & 0x8000) ||
                ((pp->inPort == nwa->service.port) || !pp->inPort) ) {
                memcpy(&(pp->remoteAddr),&(nwa->ip),sizeof(oss_nwIP_t));
                pp->inPort = nwa->service.port;


                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_ADD_REMT_TERM, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pp), (long)pid, (long)pp->cstate.pflags, (long)ntohl(pp->remoteAddr.addr.addrClassic.addr)),0) : 0);





                if (pp->remoteAddr.ipV6) {
                    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_IPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(pp->remoteAddr.addr.a32[0])), (long)ntohl(pp->remoteAddr.addr.a32[1]), (long)ntohl(pp->remoteAddr.addr.a32[2]), (long)ntohl(pp->remoteAddr.addr.a32[3])),0) : 0);





                }

                (pp->cstate.pflags) |= 0x00800000;
                found = 1;
            } else {
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 8) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_NOSET_REMT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pp), (long)pid, (long)pp->cstate.pflags, (long)pp->inPort),0) : 0);



            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return found;
}
int
kenv_procCheckGetRterm(pal_pid_t pid, pal_nwAddr_t *nwa)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int found = 0;

    if (pp = procSearch(pid, &lhandle)) {
        if (pp->cstate.pflags & 0x00800000) {
            memcpy(&(nwa->ip),&(pp->remoteAddr),sizeof(oss_nwIP_t));

            (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_GET_REMT_TERM, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pp), (long)pid, (long)pp->cstate.pflags, (long)ntohl(nwa->ip.addr.addrClassic.addr)),0) : 0);



            if (pp->remoteAddr.ipV6) {
                (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 7) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_IPV6_ADDR, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(ntohl(pp->remoteAddr.addr.a32[0])), (long)ntohl(pp->remoteAddr.addr.a32[1]), (long)ntohl(pp->remoteAddr.addr.a32[2]), (long)ntohl(pp->remoteAddr.addr.a32[3])),0) : 0);




            }
            found = 1;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return found;
}
int
kenv_procSetLocalTerm(pal_pid_t pid , char *lterm, int ltermLen)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int set = 0;
    char *termName;

    ;

    if ((termName = pal_alloc(ltermLen + 1)) == NULL) {
        return set;
    }
    strcpy(termName, lterm);

    if (pp = procSearch(pid, &lhandle)) {
        if ((pp->cstate.pflags & 0x4) &&
            !(pp->cstate.pflags & (0x8000 |
                            0x20000 | 0x4000))
        ) {
            pp->termData.local = (uintptr_t)termName;
            pp->cstate.pflags |= 0x20000;
            set = 1;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (!set) {
        pal_free(termName, ltermLen + 1);
    }
    return set;
}
static kenv_procFlags_t
procGetExtendedInfo(
    pal_pid_t pid,
    procRecord_t *_pp,
    procCoreState_t *cstate,
    pal_rawFid_t *rfp,
    pal_rawFid_t *drfp,
    pal_fattr_t *fap)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    pal_authID_t impId, accId;
    kenv_procFlags_t pf;


    if (fap) {
        ((fap)->ftype = (fap)->mode = 0, (fap)->attrFlags = 0, (fap)->links = 0, (fap)->uid = -2);
    }





    if (_pp) {
        pp = _pp;
    } else {
        pp = procSearch(pid, &lhandle);
    }

    if (pp) {
        pf = pp->cstate.pflags;

        if (cstate) {
            *cstate = pp->cstate;
        }

        if (rfp && (pf & 0x100)) {
            *rfp = pp->pgmFid;
        }

        if (drfp && (pf & 0x100)) {
            drfp->fsid = pp->pgmFid.fsid;
            drfp->fid = pp->dirFid;
            ((drfp)->ctime = (uint32_t)(pp->dirCt));
        }

        if (fap) {
            fap->links = pp->links;
            fap->mode = pp->mode;
            fap->ftype = PAL_FTYPE_FILE;
        }

        if (!_pp) {
            (kail_mutex_unlock(&(lhandle)->lock));
        }
    } else {
        pf = 0x80000000;
        if (((pid) == 1)) {
            pf |= 0x1;
        }
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event3((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_INFO_NOTPAR, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((0)<<16)), (long)(pp), (long)pid, (long)pf),0) : 0);

    return pf;
}
int
kenv_procGetProgramFid(
    pal_pid_t pid,
    pal_rawFid_t *rfp,
    pal_rawFid_t *drfp,
    pal_fattr_t *fap)
{
    kenv_procFlags_t pf;


    pf = procGetExtendedInfo(pid, NULL, NULL, rfp, drfp, fap);
    return ((pf & 0x100)? 1: 0);
}
int
kenv_procGetProgramInfo(
    pal_pid_t pid,
    char *pgm,
    int *size,
    pal_rawFid_t *rfp,
    pal_fattr_t *fap,
    pal_rawFid_t *dir_rfp,
    int *hasFid)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kenv_procFlags_t pf = 0;
    int rc = 0, foundName = 0, plen;


    if (rfp)
        *hasFid = 0;

    if (pp = procSearch(pid, &lhandle)) {
        pf = pp->cstate.pflags;
        if (pgm && (pp->pgmPath)) {
            foundName = 1;
            plen = pp->pgmPathLen;
            if (plen < *size) {
                strcpy(pgm, pp->pgmPath);
                *size = plen;
            } else {
                rc = E2BIG;
                *size = plen;
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (!foundName && pgm) {
        *pgm = '\0';
        *size = 0;
    }

    if (rfp && (pf & 0x100) && (rc == 0)) {
        *hasFid = kenv_procGetProgramFid(pid, rfp, dir_rfp, fap);
    }

    return rc;
}
pal_pid_t
kenv_procGetFlagsAndIds(kenv_procFlags_t *pfOut, pal_idList_t *idList)
{
    pal_pid_t pid;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kenv_procFlags_t pf;
    pal_authID_t impId, accId;


    pid = kail_pid_get_epid(kail_current_tid());
    pal_getREUids(idList);

    if (pp = procSearch(pid, &lhandle)) {
        pf = pp->cstate.pflags;
        accId = pp->cstate.accId;
        impId = pp->cstate.impId;
        (kail_mutex_unlock(&(lhandle)->lock));
    } else {
        pf = 0x80000000;
        if (((pid) == 1)) {

            pf |= 0x1;
            idList->effId = idList->accId = idList->realId = 0;
        }
        accId = idList->realId;



    }

    if (pf & 0x200) {
        idList->accId = impId;
    } else {
        idList->accId = accId;
    }

    *pfOut = pf;
    return pid;
}
pal_pid_t
kenv_procGetFlagsAndIdsExt(kenv_procFlags_t *pfOut, pal_idList_t *idList,
                           void **uniquep)
{
    pal_pid_t pid;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kenv_procFlags_t pf;
    pal_authID_t impId, accId;

    pid = kail_pid_get_epid(kail_current_tid());
    pal_getREUids(idList);





    if (pp = procSearch(pid, &lhandle)) {
        *uniquep = pp->uniquifier;
        pf = pp->cstate.pflags;
        accId = pp->cstate.accId;
        impId = pp->cstate.impId;
        (kail_mutex_unlock(&(lhandle)->lock));
    } else {
        *uniquep = (void *)NULL;
        pf = 0x80000000;
        if (((pid) == 1)) {

            pf |= 0x1;
            idList->effId = idList->accId = idList->realId = 0;
        }
        accId = idList->realId;



    }

    if (pf & 0x200) {
        idList->accId = impId;
    } else {
        idList->accId = accId;
    }

    *pfOut = pf;
    return pid;
}
static fdEntry_t *
growFdTable(procRecord_t *pp)
{





    int nsize = (pp->fdTableSize*2)+1;
    fdEntry_t *ntbl, *fdE = NULL;


    if (nsize <= 65535 ) {
        ntbl = (fdEntry_t *)pal_alloc(nsize * sizeof(*ntbl));
        if (ntbl) {
            memset((char *)ntbl,0,nsize * sizeof(*ntbl));
            memcpy(ntbl,(char *)pp->fdTable,pp->fdTableSize * sizeof(*ntbl));
            if (pp->fdTable != pp->lcl_fdTable) {
                pal_free(pp->fdTable, pp->fdTableSize * sizeof(*ntbl));
            }

            fdE = &ntbl[pp->fdTableSize];
            pp->fdTable = ntbl;
            pp->fdTableSize = nsize;
            do { (kail_mutex_lock(&procMainLock));; (++kenv_procStats.fdTableGrows); (kail_mutex_unlock(&procMainLock));; } while ( 0);
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_GROW_FDTABLE, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pp->pid), (long)nsize),0) : 0);


        }
    }
    return fdE;
}
static int
addFd(procRecord_t *pp, int fd, void *dvH)
{
    int i, freeIdx, lazyIdx, didAdd, reuseDvh, foundFd;
    const int lastSlot = pp->fdTableSize;
    fdEntry_t *ep, *freeE, *lazyE;

    freeE = lazyE = NULL;
    foundFd = 0;

    for (i = 0, ep = pp->fdTable; i < lastSlot; i++, ep++) {
        if ((ep->fd == fd) && !(((ep)->flags == 0x0))) {
            freeE = ep;
            freeIdx = i;
            foundFd = 1;
            break;
        } else if (!freeE && ((ep)->flags == 0x0)) {
            freeE = ep;
            freeIdx = i;
        } else if (((ep)->flags & 0x20)) {
            lazyE = ep;
            lazyIdx = i;
        }
    }

    if (!foundFd && lazyE && (!freeE || (freeIdx > lazyIdx))) {

        freeE = lazyE;
        freeIdx = lazyIdx;
        lazyE = NULL;
    }

    if (!freeE && (freeE = growFdTable(pp))) {
        freeIdx = lastSlot;
    }

    if (freeE) {
        didAdd = 1;
        reuseDvh = 0;

        if (freeIdx >= pp->lastFdSlot) {
            pp->lastFdSlot = freeIdx + 1;
        }

        if (!foundFd) {



            do { fdEntry_t *hot_ep = &((pp)->fdTable[0]); fdEntry_t *freep = (freeE); fdEntry_t save; if (hot_ep != freep) { save = *freep; *freep = *hot_ep; *hot_ep = save; (freeE) = hot_ep; (freeIdx) = 0; } } while ( 0);
        }

        if (freeE->dvh) {

            if (freeE->dvh != dvH) {
                do { if ((freeE)->dvh) { pal_releVnode((freeE)->dvh); (freeE)->dvh = NULL; (pp)->fdActive--; ; } (freeE)->fd = 0; (freeE)->flags = 0x0; } while ( 0);
            } else {



                reuseDvh = 1;
            }
        }

        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KENV_PR_ADD_FD, (((2)<<28) + ((2)<<24) + ((((sizeof(char *) == 4) ? 2 : 4))<<20) + ((2)<<16)), (long)(fd), (long)pp->pid, (long)dvH, (long)freeIdx),0) : 0);





        if (reuseDvh) {
            do { (freeE)->fd = (fd); (freeE)->flags = (0x1|0x2); } while ( 0);
        } else {
            do { int _fl = 0x1; (freeE)->fd = (fd); if (dvH) { pal_holdVnode(dvH); (freeE)->dvh = (dvH); _fl |= 0x2; (pp)->fdActive++; } (freeE)->flags = _fl; } while ( 0);
        }
    } else {
        didAdd = 0;
    }

    if (lazyE && (lazyIdx |= 0) &&
        ((lazyE)->flags & 0x20) && (pp->fdActive >= 4)) {




        do { if ((lazyE)->dvh) { pal_releVnode((lazyE)->dvh); (lazyE)->dvh = NULL; (pp)->fdActive--; ; } (lazyE)->fd = 0; (lazyE)->flags = 0x0; } while ( 0);
    }

    return didAdd;
}
void
kenv_procCloseFd(pal_pid_t pid, int fd)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    fdEntry_t *ep;
    pal_vnodeH_t dvH;


    if ((((fd) & 0xffff0000))) {
        return;
    }

    if (pp = procSearch(pid, &lhandle)) {
        int i;
        const int lastSlot = pp->lastFdSlot;
        dvH = NULL;

        for (i = 0, ep = pp->fdTable; i < lastSlot; i++, ep++) {
            if ((fd == ep->fd) && !((ep)->flags == 0x0)) {

                dvH = ep->dvh;
                ep->dvh = NULL;
                if (dvH) {

                    pp->fdActive--;
                }

                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KENV_PR_CLOSE_FD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(fd), (long)pid, (long)ep->flags, (long)i),0) : 0);



                do { ; (ep)->flags = 0x0; (ep)->fd = 0; } while ( 0);




                if ((i > 2) && ((i + 1) == lastSlot)) {

                    while (i >= 0) {
                        if (((ep)->flags == 0x0)) {
                            pp->lastFdSlot = i;
                            ep--; i--;
                        } else {

                            break;
                        }
                    }
                }
                break;
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));

        if (dvH) {
            pal_releVnode(dvH);
        }
    }
}
void
kenv_procLazyCloseFd(pal_pid_t pid, int fd)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    fdEntry_t *ep;
    pal_vnodeH_t dvH;
    int i, fdFlags, foundFd, closeSlot;


    if ((((fd) & 0xffff0000))) {
        return;
    }

    if (pp = procSearch(pid, &lhandle)) {
        const int lastSlot = pp->lastFdSlot;
        foundFd = 0;
        dvH = NULL;

        for (i = 0, ep = pp->fdTable; i < lastSlot; i++, ep++) {
            if ((fd == ep->fd) && !((ep)->flags == 0x0)) {
                foundFd = 1;
                closeSlot = i;
                if ((closeSlot == 0) ||
                    (pp->fdActive < 4)) {
                    ep->flags |= 0x20;
                    fdFlags = ep->flags;
                } else {

                    dvH = ep->dvh;
                    ep->dvh = NULL;
                    if (dvH) {

                        pp->fdActive--;
                    }

                    fdFlags = ep->flags;
                    do { ; (ep)->flags = 0x0; (ep)->fd = 0; } while ( 0);





                    if ((i > 2) && ((i + 1) == lastSlot)) {
                        while(((ep)->flags == 0x0) && (i >= 0)) {
                            pp->lastFdSlot = i;
                            ep--; i--;
                        }
                    }
                }
                break;
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));

        if (foundFd) {
            if (dvH) {
                pal_releVnode(dvH);
            }
            ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[1])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[1], KT_TRACE_KENV_PR_CLOSE_FD, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(fd), (long)pid, (long)fdFlags, (long)closeSlot),0) : 0);


        }
    }
}
pal_vnodeH_t
kenv_procGetFdDirVnode(pal_pid_t pid, int fd)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    fdEntry_t *ep;
    pal_vnodeH_t dvH = NULL;
    int i;


    if ((((fd) & 0xffff0000))) {
        return dvH;
    }

    if (pp = procSearch(pid, &lhandle)) {
        const int lastSlot = pp->lastFdSlot;
        ep = pp->fdTable;
        for (i = 0; i < lastSlot; i++, ep++) {
            if ((ep->fd == fd) && ((ep)->dvh && (((ep)->flags & (0x1 | 0x20)) == 0x1))) {
                dvH = ep->dvh;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_RET_FDINFO, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((((sizeof(char *) == 4) ? 2 : 4))<<16)), (long)(fd), (long)pid, (long)ep->flags, (long)dvH),0) : 0);




                break;
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (dvH) {
        pal_holdVnode(dvH);
    }
    return dvH;
}
void
kenv_procSetFdFlags(pal_pid_t pid, int fd, int flags)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    fdEntry_t *ep;
    int i;


    if ((((fd) & 0xffff0000))) {
        return;
    }
    if (flags != 0x10) {
        return;
    }

    if (pp = procSearch(pid, &lhandle)) {
        const int lastSlot = pp->lastFdSlot;
        for (i = 0, ep = pp->fdTable; i < lastSlot; i++, ep++) {
            if ((ep->fd == fd) && ((ep)->dvh && (((ep)->flags & (0x1 | 0x20)) == 0x1))) {
                ep->flags |= flags;
                break;
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
void
kenv_procCloseAllFdesc(pal_pid_t pid, int fdLow)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;


    if (pp = procSearch(pid, &lhandle)) {
        closeOpens(pp, fdLow, 0);
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
int
kenv_procAddFd(pal_pid_t pid, int fd, pal_vnodeH_t dvH)
{
    int didAdd = 0;
    procRecord_t *pp;
    proc_lhandle_t lhandle;


    if ((((fd) & 0xffff0000))) {
        return 0;
    }

    if (pp = procSearch(pid, &lhandle)) {
        didAdd = addFd(pp, fd, dvH);
        (kail_mutex_unlock(&(lhandle)->lock));
    }

  out:
    return didAdd;
}
void
kenv_procDupFd(pal_pid_t pid, int fd, int dupFd)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    fdEntry_t *ep, *found;
    int i;

    if ((((fd) & 0xffff0000)) || (((dupFd) & 0xffff0000))) {
        return;
    }

    if (pp = procSearch(pid, &lhandle)) {
        const int lastSlot = pp->lastFdSlot;
        for (i = 0, ep = pp->fdTable, found = NULL;
            !found && (i < lastSlot); i++, ep++) {
            if ((ep->fd == fd) && ((ep)->dvh && (((ep)->flags & (0x1 | 0x20)) == 0x1))) {
                found = ep;
            }
        }

        if (found) {
            (void)addFd(pp, dupFd, found->dvh);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
int
kenv_procRegisterPid(pal_pid_t pid)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int didMark = 0;


    if ((pp = procSearch(pid, &lhandle)) == NULL) {
        if (pid == kail_pid_get_epid(kail_current_tid())) {
            kenv_procAdd(pid, 0, 0x8);
            pp = procSearch(pid, &lhandle);
        }
    }

    if (pp) {
        if (!(pp->cstate.pflags & 0x80)) {
            pp->cstate.pflags |= 0x80;



            procAdjustRegisteredCount(1);
            didMark = 1;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return didMark;
}
void
kenv_procPurgeStale(int specialOnly)
{
    int h, doCheck;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp, *qpNext;


    for (h = 0; h < 367; h++) {
        do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
        hq = &procQueue[h];
        for (qp = ((hq)->next); qp != hq; qp = qpNext) {
            qpNext = ((qp)->next);
            pp = (procRecord_t *)qp;

            if (specialOnly) {
                doCheck = (pp->cstate.pflags &
                        (0x80 | 0x1));
            } else {
                doCheck = 1;
            }

            if (doCheck && !kail_check_pid((int)(pp->pid)) && !(pp->streamCount)) {
                (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));
                kenv_procClearExecMem((void *)pp);
                procDelete(pp);
            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
int
kenv_procAddProcFlagsByName(char *pn, pal_rawFid_t *rfp,
                            kenv_procFlags_t pflags, int cflags)
{
    int h, count = 0;
    kenv_procFlags_t pf;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp;

    if (!pn || (*pn == '\0'))
        return 0;

    for (h = 0; h < 367; h++) {
        do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
        hq = &procQueue[h];
        for (qp = ((hq)->next); qp != hq; qp = ((qp)->next)) {
            pf = pflags;
            pp = (procRecord_t *)qp;
            if (pp->pgmPath && (pp->cstate.pflags & 0x100) &&
                (((((!memcmp((&((rfp))->fid),(&((&pp->pgmFid))->fid),((&((rfp))->fid)->fid_data_len + (sizeof(uint32_t) + sizeof(uint32_t) + sizeof(uint16_t) + sizeof(uint16_t))))) && ((&((rfp))->fsid)->val[0] == (&((&pp->pgmFid))->fsid)->val[0]))) ? (0x100 | 0x1 | 0x2): 0x8000) & 0x1)) {



                if (cflags & 1) {

                    pp->cstate.pflags &= ~((0x4|0x8|0x2|0x00100000));
                }
                (void)addProcFlags(pp, &pf);
                count++;
                ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_ADD_FLAGS_BNAME, (((2)<<28) + ((1)<<24) + ((2)<<20) + ((1)<<16)), (long)(pp->pid), (long)pp->pgmPath, (long)pf, (long)pn),0) : 0);




            }
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return count;
}
int
kenv_procGetInfo(
    pal_pid_t searchPid,
    kenv_procFlags_t *procFlags,
    pal_idList_t *idList,
    pal_rawFid_t *rfp)
{
    procCoreState_t cstate;
    pal_authID_t accId;
    kenv_procFlags_t pf;
    pal_pid_t pid = searchPid, myPid = kail_pid_get_epid(kail_current_tid());
    int found = 0;


    pal_getREUids(idList);
    if (!pid) {
        pid = myPid;
    }

    pf = procGetExtendedInfo(pid, NULL, &cstate, rfp, NULL, NULL);
    if (!(pf & 0x80000000)) {
        found = 1;
        accId = (pf & 0x200)? cstate.impId: cstate.accId;
        if (pid != myPid) {
            idList->effId = idList->realId = -2;
        }
    } else {
        if (pf & 0x1) {

            accId = idList->effId = idList->accId = idList->realId = 0;
        } else if (pid == myPid) {

            accId = idList->realId;
        } else {

            accId = idList->effId = idList->accId = idList->realId = -2;
            pf |= 0x20;
        }
    }

    idList->accId = accId;
    *procFlags = pf;
    return found;
}
int
kenv_procGetInfoExt(pal_pid_t searchPid, kenv_procFlags_t *procFlags,
                    pal_idList_t *idList, void **uniquep)
{
    procCoreState_t cstate;
    pal_authID_t accId;
    kenv_procFlags_t pf;
    pal_pid_t pid = searchPid, myPid = kail_pid_get_epid(kail_current_tid());
    int found = 0;
    proc_lhandle_t lhandle;
    procRecord_t *pp;

    pal_getREUids(idList);
    if (!pid) {
        pid = myPid;
    }






    pp = procSearch(pid, &lhandle);
    pf = procGetExtendedInfo(pid, pp, &cstate, NULL, NULL, NULL);
    if (pp) {
        *uniquep = pp->uniquifier;
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    if (!(pf & 0x80000000)) {
        found = 1;
        accId = (pf & 0x200)? cstate.impId: cstate.accId;
        if (pid != myPid) {
            idList->effId = idList->realId = -2;
        }
    } else {
        if (pf & 0x1) {

            accId = idList->effId = idList->accId = idList->realId = 0;
        } else if (pid == myPid) {

            accId = idList->realId;
        } else {

            accId = idList->effId = idList->accId = idList->realId = -2;
            pf |= 0x20;
        }
    }

    idList->accId = accId;
    *procFlags = pf;
    return found;
}
int
kenv_procGetProcPPid(pal_pid_t searchPid, pal_pid_t *parPid)
{
    procCoreState_t cstate;
    kenv_procFlags_t pf;
    pal_pid_t pid = searchPid, myPid = kail_pid_get_epid(kail_current_tid());
    int found = 0;
    proc_lhandle_t lhandle;
    procRecord_t *pp;
    if (!pid) {
        pid = myPid;
    }





    *parPid = 1;


    pp = procSearch(pid, &lhandle);
    pf = procGetExtendedInfo(pid, pp, &cstate, NULL, NULL, NULL);
    if (pp) {
        if (!(pf & 0x80000000)) {
            *parPid = pp->ppid;
            found = 1;
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    return found;
}
int
kenv_procGetInfoNotPar(
    pal_pid_t searchPid,
    void * unique,
    kenv_procFlags_t *procFlags,
    pal_idList_t *idList,
    pal_rawFid_t *rfp)
{
    procCoreState_t cstate;
    pal_authID_t accId = -2;
    kenv_procFlags_t pf;
    int found = 0;
    procRecord_t *pp=(procRecord_t *)NULL;
    pp = procSearchDead(searchPid, unique);

    if (pp) {
        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 1) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_USE_DEAD, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pp), (long)(int)searchPid),0) : 0);

    }

    pf = procGetExtendedInfo(searchPid, pp, &cstate, rfp, NULL, NULL);
    if (pp) {
        (kail_mutex_unlock(&procMainLock));;
    }

    if (!(pf & 0x80000000)) {
        found = 1;
        accId = (pf & 0x200)? cstate.impId: cstate.accId;






    } else {
        if (pf & 0x1) {

            accId = idList->effId = idList->accId = idList->realId = 0;
        }
    }

    idList->accId = accId;
    *procFlags = pf;
    return found;
}
void
kenv_procFdCloseAll(void)
{
    int h;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp, *qpNext;


    for (h = 0; h < 367; h++) {
        do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
        hq = &procQueue[h];
        for (qp = ((hq)->next); qp != hq; qp = qpNext) {
            qpNext = ((qp)->next);
            pp = (procRecord_t *)qp;
            closeOpens(pp, 0, 0);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
int
kenv_procIsPrivPid(pal_pid_t pid)
{
    kenv_procFlags_t pf;


    pf = procGetExtendedInfo(pid, NULL, NULL, NULL, NULL, NULL);
    return ((pf & 0x1)? 1: 0);
}
int
kenv_procAddProcFlags(pal_pid_t pid, kenv_procFlags_t *flags)
{
    procCoreState_t cs;
    int found = 0;

    cs.pflags = *flags;
    found = procSetCoreState(pid, 0x1 | 0x1000, &cs);
    if (found >= 0) {
        *flags = cs.pflags;
        found = 1;
    } else {
        found = 0;
    }

    return found;
}
void
kenv_procUpdateAccId(pal_pid_t pid, pal_authID_t accId)
{
    procCoreState_t cs;
    int didSet;


    cs.accId = accId;
    didSet = procSetCoreState(pid, 0x4, &cs);
    if (didSet >= 0) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_SET_ACC_ID, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pid), (long)(int)accId),0) : 0);


    }
}
int
kenv_procSetImpId(pal_pid_t pid, pal_authID_t impId)
{
    procCoreState_t cs;
    int didSet;


    cs.impId = impId;
    didSet = procSetCoreState(pid, 0x8, &cs);
    if (didSet >= 0) {
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_SET_IMP_ID, (((2)<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pid), (long)(int)impId),0) : 0);


    }
    return didSet;
}
int
kenv_procGetTrueAccId(pal_pid_t pid, pal_authID_t *retId)
{
    int found;
    kenv_procFlags_t pf;
    procCoreState_t cs;
    pal_authID_t impId;


    pf = procGetExtendedInfo(pid, NULL, &cs, NULL, NULL, NULL);
    found = (pf & 0x80000000)? 0: 1;
    if (found) {
        *retId = cs.accId;
        impId = (pf & 0x200)? cs.impId: cs.accId;
        ((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PR_GET_TRUE_ACCID, (((2)<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pid), (long)(int)cs.accId, (long)(int)impId, (long)(int)pf),0) : 0);




    }
    return found;
}
void
kenv_procSetLoginState(pal_pid_t pid, int32_t lstate)
{
    procCoreState_t cs;


    cs.loginState = lstate;
    (void)procSetCoreState(pid, 0x2, &cs);
}
int32_t
kenv_procGetLoginState(pal_pid_t pid)
{
    int32_t lstate = 0;
    kenv_procFlags_t pf;
    procCoreState_t cs;


    pf = procGetExtendedInfo(pid, NULL, &cs, NULL, NULL, NULL);
    if (pf & 0x800) {
        lstate = cs.loginState;
    }
    return lstate;
}
void
kenv_procSetDirectLoginID(pal_pid_t pid, pal_authID_t lid)
{
    procCoreState_t cs;


    cs.accId = lid;
    cs.directLoginId = lid;
    (void)procSetCoreState(pid, 0x4|0x10, &cs);
}
int
kenv_procGetDirectLoginID(pal_pid_t pid, pal_authID_t *lid)
{
    int found = 0;
    procCoreState_t cs;
    kenv_procFlags_t pf;


    pf = procGetExtendedInfo(pid, NULL, &cs, NULL, NULL, NULL);
    if (pf & 0x40000) {
        found = 1;
        *lid = cs.directLoginId;
    }
    return found;
}
int
kenv_procGetPidList(
    kenv_procPidList_t **pidListOutp,
    kenv_procFlags_t flagsFilter)
{
    int rc, h, listSize, getMemory, addCount, retries;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp, *qpNext;
    kenv_procPidList_t *plistp;
    pal_pid_t *pidsp;


    *pidListOutp = NULL;
    plistp = (kenv_procPidList_t *)pal_alloc(sizeof(*plistp));
    if (plistp == NULL) {
        return ENOMEM;
    }

    rc = 0;
    retries = 0;
    getMemory = 1;
    while (getMemory) {
        (kail_mutex_lock(&procMainLock));;
        listSize = kenv_procStats.activeProcs;
        (kail_mutex_unlock(&procMainLock));;

        listSize += ((listSize / 5) + 10);
        plistp->pids = (pal_pid_t *)pal_alloc(listSize * sizeof(pal_pid_t));
        if (plistp->pids == NULL) {
            pal_free(plistp, sizeof(*plistp));
            rc = ENOMEM;
            break;
        }

        addCount = 0;
        getMemory = 0;
        pidsp = plistp->pids;

        for (h = 0; h < 367; h++) {
            do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
            hq = &procQueue[h];
            for (qp = ((hq)->next); qp != hq; qp = ((qp)->next)) {
                pp = (procRecord_t *)qp;
                if ((flagsFilter == 0) ||
                    ((pp->cstate.pflags & flagsFilter) == flagsFilter)) {
                    if ((++addCount) < (listSize - 1)) {
                        *(pidsp++) = pp->pid;
                    } else {



                        if (retries < 10) {
                            retries++;
                            getMemory = 1;
                        } else {
                            rc = ENOMEM;
                        }
                        break;
                    }
                }
            }
            (kail_mutex_unlock(&(lhandle)->lock));

            if (rc) {
                break;
            }

            if (getMemory) {
                pal_free(plistp->pids, listSize * sizeof(pal_pid_t));
                plistp->pids = NULL;
                break;
            }
        }
    }

    if (rc == 0) {
        if (addCount) {
            ;

            plistp->pids[addCount] = 0;
            plistp->listAllocSize = listSize;
            *pidListOutp = plistp;




        } else {
            if (plistp->pids) {
                pal_free(plistp->pids, listSize * sizeof(pal_pid_t));
            }
            pal_free(plistp, sizeof(*plistp));
        }
    }
    return rc;
}
void
kenv_procFreePidList(kenv_procPidList_t *listp)
{
    ;


    pal_free(listp->pids, listp->listAllocSize * sizeof(pal_pid_t));
    pal_free(listp, sizeof(*listp));
}
static int
freeLazyFdes(procRecord_t *pp)
{
    int i, lastSlot, freed = 0;
    fdEntry_t *ep;


    lastSlot = pp->lastFdSlot;
    for (i = 0, ep = pp->fdTable; i < lastSlot; i++, ep++) {
        if (!((ep)->flags == 0x0) && ((ep)->flags & 0x20)) {

            do { if ((ep)->dvh) { pal_releVnode((ep)->dvh); (ep)->dvh = NULL; (pp)->fdActive--; ; } (ep)->fd = 0; (ep)->flags = 0x0; } while ( 0);
            freed++;
        }
    }

    return freed;
}
void
kenv_procFreeAllLazyCloses(void)
{
    int h, freeCount;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp, *qpNext;


    for (h = 0; h < 367; h++) {
        do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
        hq = &procQueue[h];
        for (qp = ((hq)->next); qp != hq; qp = ((qp)->next)) {
            pp = (procRecord_t *)qp;
            freeCount = freeLazyFdes(pp);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
}
int
kenv_procIncStreamCount(pal_pid_t pid)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int rc = -1;

    if (pp = procSearch(pid, &lhandle)) {
        (pp->streamCount) += 1;
        rc = pp->streamCount;
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_BUMP_STREAM_COUNT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pp), (long)(int)pid, (long)1, (long)rc),0) : 0);



    return(rc);
}
int
kenv_procDecStreamCount(pal_pid_t pid, void *unique)
{
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    int rc = -1;
    kutil_q_t *qp, *qpNext;


    pp = procSearchDead(pid, unique);
    if (pp) {



        (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event2((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_PROC_USE_DEAD, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((0)<<20) + ((0)<<16)), (long)(pp), (long)(int)pid),0) : 0);

        (pp->streamCount) -= 1;
        rc = pp->streamCount;

        if (pp->streamCount == 0) {
            (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));
            (kail_mutex_unlock(&procMainLock));;
            kenv_procClearExecMem((void *)pp);
            procDelete(pp);
        } else {
            (kail_mutex_unlock(&procMainLock));;
        }
    } else if (pp = procSearch(pid, &lhandle)) {



        (pp->streamCount) -= 1;
        rc = pp->streamCount;

        if ((pp->streamCount == 0) && !kail_check_pid((int)(pp->pid))) {
            (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));
            kenv_procClearExecMem((void *)pp);
            procDelete(pp);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }

    (((((kt_channel_t *)(kt_chanID_t)&kt_defChannels[2])->active) >= 3) ? (kt_Event4((kt_chanID_t)&kt_defChannels[2], KT_TRACE_KENV_BUMP_STREAM_COUNT, (((((sizeof(char *) == 4) ? 2 : 4))<<28) + ((2)<<24) + ((2)<<20) + ((2)<<16)), (long)(pp), (long)(int)pid, (long)-1, (long)rc),0) : 0);



    return(rc);
}

int kenv_procSysCallCheckPid=0;
int kenv_procSysCallCheckPidOnly=0;
int
kenv_procIsCopyShmid(int id)
{
    int curid;


    curid = kenv_pathGetShmid();
    if (curid == id) {
        return(1);
    } else {
        return(0);
    }
}
int
kenv_procCheckShmat(void *shmaddr, kenv_pathMemInfo_t *memInfoP)
{
    int rc=0;
    return(rc);
}
sharedMemPtr_t
kenv_procGetPathMem(char *path,int len,kenv_pathMemInfo_t *memInfoP,int *fail)
{
    sharedMemPtr_t memp=(sharedMemPtr_t)NULL;
    return(memp);
}

void
kenv_procPutPathMem(void *pMem, kenv_pathMemInfo_t *memInfoP)
{
}
void
kenv_procInit(void)
{
    int i, j;

    ((&procDeadQ)->next = (&procDeadQ)->prev = (&procDeadQ));
    for (i = 0; i < 367; i++)
        ((&procQueue[i])->next = (&procQueue[i])->prev = (&procQueue[i]));

    for (i = 0; i < 128; i++) {
        (kail_mutex_init(&procHashLocks[i].lock));;
        procHashLocks[i].index = i;
        for (j=0; j < 16; j++) {
            procHashLocks[i].cacheLinePad[j] = 0x0eeeee00;
        }
    }

    (kail_mutex_init(&procRegisterLock));
    (kail_mutex_init(&procMainLock));;
}
void
kenv_procShutdown(void)
{
    int h;
    procRecord_t *pp;
    proc_lhandle_t lhandle;
    kutil_q_t *hq, *qp, *qpNext;


    procShuttingDown = 1;
    for (h = 0; h < 367; h++) {
        do { (lhandle) = &procHashLocks[(((h)) & (128 - 1))]; (kail_mutex_lock(&((lhandle))->lock)); } while ( 0);
        hq = &procQueue[h];
        for (qp = ((hq)->next); qp != hq; qp = qpNext) {
            qpNext = ((qp)->next);
            pp = (procRecord_t *)qp;
            (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));
            kenv_procClearExecMem((void *)pp);
            procDelete(pp);
        }
        (kail_mutex_unlock(&(lhandle)->lock));
    }
    procShuttingDown = 0;


    (kail_mutex_lock(&procMainLock));;
    for (qp = ((&procDeadQ)->next); qp != &procDeadQ; qp = qpNext) {
        qpNext = ((qp)->next);
        pp = (procRecord_t *)qp;
        (((&pp->q)->next)->prev = ((&pp->q)->prev), ((&pp->q)->prev)->next = ((&pp->q)->next));
        ((&pp->q)->next = (&pp->q)->prev = (&pp->q));
        kenv_procClearExecMem((void *)pp);
        procDelete(pp);
    }
    (kail_mutex_unlock(&procMainLock));;







}
