
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *
 *
 * IBM Tivoli Access Manager for Operating Systems 6.0.0
 * 5698-PDO
 * Licensed Materials - Property of IBM
 * 
 * (C) Copyright IBM Corp. 2000,2006. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 *
*/

static char sccsid[]="@(#)60	1.11  src/oss/kazn/kmsg/kmsg_syscall.c, oss.kazn.src, oss600, 040618a  6/1/04  14:38:33";
#include <linux/kernel.h>

#include <linux/stddef.h>


#include <asm/string.h>

#include <asm/byteorder.h>






#include <linux/stat.h>


#include <linux/limits.h>

#include <linux/errno.h>

#include <asm/ptrace.h>

#include <asm/fcntl.h>
  typedef int intptr_t;


 typedef unsigned int uintptr_t;


typedef __kernel_uid32_t uid32_t;
typedef __kernel_gid32_t gid32_t;
typedef struct kail_vfs
{
    void *mnt;
    void *mnt_parent;
    char devname[64];
} kail_vfs_t;






typedef struct {
        long val[2];
} kail_fsid_t;

typedef struct kail_fid {
    uint32_t fid_ino;
    uint32_t fid_gen;
    uint16_t fid_flags;
    uint16_t fid_data_len;

    char fid_data[(sizeof(char) * 64)];
} kail_fid_t;

typedef mode_t kail_fmode_t;
typedef dev_t kail_dev_t;
typedef void * kail_vnodeH_t;
typedef struct _kail_rfid {
    uint32_t ctime;
    kail_fsid_t fsid;
    kail_fid_t fid;
} kail_rawFid_t;
typedef struct _kail_cred {

        uid_t uid,euid,suid,fsuid;
        gid_t gid,egid,sgid,fsgid;
        int ngroups;
        int cr_ref;
        gid_t groups[32 ];
} kail_cred_t;

typedef int64_t kail_authID_t;
enum kail_ftypes { KAIL_FTYPE_NONE, KAIL_FTYPE_FILE, KAIL_FTYPE_DIR,
             KAIL_FTYPE_BLKDEV, KAIL_FTYPE_CHARDEV, KAIL_FTYPE_LNK,
             KAIL_FTYPE_SOCK, KAIL_FTYPE_BAD, KAIL_FTYPE_FIFO,
             KAIL_FTYPE_MPC, KAIL_FTYPE_OTHER};
typedef enum kail_ftypes kail_ftypes_t;

typedef struct _kail_fattr {
    kail_authID_t uid;
    kail_authID_t gid;
    kail_ftypes_t ftype;
    kail_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    dev_t dev;
    kail_vfs_t check_vfsp;
} kail_fattr_t;




extern volatile struct timespec *kail_xtime;





extern asmlinkage int (*kail_printk)(const char *, ...);
extern asmlinkage int (*kail_sprintf)(char * buf, const char * fmt, ...);
extern asmlinkage int (*kail_do_fork)(unsigned long, unsigned long, struct pt_regs *, unsigned long);


extern asmlinkage int kail_kernel_thread(int (*)(void *), void *,unsigned long);
extern asmlinkage int kail_kill_proc(pid_t, int, int);
extern asmlinkage long kail_strncpy_from_user(char *, const char *, long);
extern asmlinkage long kail_strncpy_from_DND(char *, void *, long);
extern unsigned long FASTCALL(kail_copy_to_user(void *, const void *, unsigned long));
extern unsigned long FASTCALL(kail_copy_from_user(void *, const void *, unsigned long));

extern void FASTCALL(kail_kernel_free(void *,unsigned long));
extern void * FASTCALL(kail_kernel_malloc(unsigned long));





extern asmlinkage void kail_mutex_init(void **);
extern void FASTCALL(kail_mutex_lock(void **));
extern int FASTCALL(kail_mutex_trylock(void **));
extern void FASTCALL(kail_mutex_unlock(void **));
extern asmlinkage void kail_mutex_destroy(void **);

extern asmlinkage void kail_cond_init(void **);
extern void FASTCALL(kail_wake_up(void **));
extern void FASTCALL(kail_cond_wait(void **, void **));
extern int FASTCALL(kail_cond_wait_intr(void **, void **));
extern asmlinkage int kail_condTimedWait(void **, void **, int64_t, int);
extern asmlinkage void kail_cond_destroy(void **);

extern asmlinkage void kail_iclock_init(void **);
extern void FASTCALL(kail_iclock_lock(void **));
extern void FASTCALL(kail_iclock_unlock(void **));
extern int FASTCALL(kail_iclock_trylock(void **));
extern asmlinkage void kail_iclock_destroy(void **);

extern void FASTCALL(kail_iclock_cond_wait(void **,void **));

extern asmlinkage int kail_current_pid(void);
extern asmlinkage int kail_current_tid(void);
extern asmlinkage int kail_current_Ppid(void);
extern int FASTCALL(kail_tid_to_pid(int));

extern pid_t FASTCALL(kail_pid_get_epid(pid_t));
extern void FASTCALL(kail_pid_delete(pid_t));
extern void FASTCALL(kail_epid_delete(pid_t));
extern void FASTCALL(kail_pid_add(pid_t,pid_t));

extern asmlinkage int kail_current_uid(void);
extern asmlinkage int kail_current_euid(void);
extern asmlinkage int kail_current_suid(void);
extern asmlinkage int kail_current_gid(void);
extern asmlinkage int kail_current_egid(void);
extern int FASTCALL(kail_current_files_close_on_exec(int));

extern asmlinkage int kail_socket_protocol(void *);
extern asmlinkage int kail_socket_getname(void *,void *,int *,int);

extern int FASTCALL(kail_fd_to_dev(int, dev_t *));
extern int FASTCALL(kail_fd_to_name(int, char **, int *));
extern int FASTCALL(kail_fd_to_socket(int,void **));

extern int FASTCALL(kail_socket_shutdown(void *));




extern int FASTCALL(kail_check_pid(int));
extern int FASTCALL(kail_get_pid_pgrp(int,int *));
extern int FASTCALL(kail_get_pid_uid(int,int *,int *));
extern void FASTCALL(kail_scan_procs(void *));

extern asmlinkage void kail_daemonize(const char *);
extern asmlinkage int kail_total_ram_mb(void);
extern void FASTCALL(kail_atomic_add(int,void *));

extern asmlinkage int kail_kernel_address_mode(void);






extern asmlinkage int kail_decomposePath(char *, int, kail_rawFid_t *, int *, kail_rawFid_t *, int *, kail_fattr_t *, kail_vnodeH_t *);
extern asmlinkage int kail_LookupFidAndDir(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, int *);
extern asmlinkage int kail_lookupFidsAndInfo(char *, int, kail_rawFid_t *, kail_rawFid_t *, kail_fattr_t *, kail_vnodeH_t *, kail_vnodeH_t *, int *);
extern asmlinkage int kail_dirFidToPathFids( kail_rawFid_t *, kail_rawFid_t **, int *);
extern asmlinkage int kail_unixDescToRawFid( int , kail_rawFid_t *);
extern asmlinkage int kail_vnodesToFids( kail_vnodeH_t, kail_vnodeH_t, kail_rawFid_t *, kail_rawFid_t *, kail_rawFid_t **, int *, kail_fattr_t *);
extern asmlinkage int kail_makeFidChain(void *, kail_rawFid_t *, int *, const kail_cred_t *, int );




struct kail_register_chrdev_parameters {
        unsigned int dev_number;
        char *name;
        void *ownerp;
        void *readp;
        void *writep;
        void *ioctlp;
        void *openp;
        void *releasep;
        unsigned int ioctl_cnt;
        unsigned int *ioctl_cmds;
} ;

extern asmlinkage int kail_register_chrdev(struct kail_register_chrdev_parameters *, void **);
extern asmlinkage int kail_unregister_chrdev(struct kail_register_chrdev_parameters *, void *);
extern int FASTCALL(kail_minor(void *));

extern asmlinkage int kail_file_read(char *, kail_vnodeH_t *,char *, long, long);
extern asmlinkage void kail_write_log(const char *,const char *, int, int);
extern asmlinkage void kail_log_init(const char *);

extern asmlinkage int kail_pathToFullPath( char *, int , char **, char *,int);
extern void * FASTCALL(kail_unixDescToVnode(int));
extern void FASTCALL(kail_releVnode(void *));
extern void FASTCALL(kail_holdVnode(void *));
extern asmlinkage char * kail_readSymLink(char *, int *);



extern asmlinkage int kail_vfs_mounted(kail_vfs_t *);
extern asmlinkage int kail_vfs_check(kail_vfs_t *);


typedef struct {
        void *alloc;
        void *free;
        void *fcc_find;
        void *fcc_add;
} kail_call_back_t;

extern asmlinkage void kail_call_backs(kail_call_back_t *);
extern asmlinkage void kail_kernel_interface(void);
extern asmlinkage void kail_kernel_interface_shutdown(void);

typedef asmlinkage long (* sys_call_fn)();
struct kail_syscall_prepost {
        int call_index;
        sys_call_fn call_pre;
        sys_call_fn call_post;
};

extern int struct_cppath_size;

extern asmlinkage int kail_trap_syscalls(struct kail_syscall_prepost *);



extern asmlinkage void kail_restore_syscalls(void);

struct nameidata;
struct kail_datanameidata {
        char cdata[4];
        char *path;
        struct nameidata *nd;
};
#define KAIL_LOOKUP_BIT 0x40000000
#ifdef LINUX_RHEL4
#define SET_LOOKUP_FLAG(n) (n)->intent.open.flags = KAIL_LOOKUP_BIT;
#define CLEAR_LOOKUP_FLAG(n) (n)->intent.open.flags &= ~KAIL_LOOKUP_BIT;
#define CHECK_LOOKUP_FLAG(n) ((n)->intent.open.flags == KAIL_LOOKUP_BIT)
#endif 
#ifdef LINUX_SLES9
#define SET_LOOKUP_FLAG(n)
#define CLEAR_LOOKUP_FLAG(n)
#define CHECK_LOOKUP_FLAG(n)
#endif 
typedef unsigned char byte_t;





typedef int64_t oss_uid_t;
typedef int64_t oss_gid_t;
typedef struct {
    int ipV6:1;
    int ipV6V4Mapped:1;
    int ipV6V4Compat:1;
    union {
        uint32_t a32[4];
        uint16_t a16[8];
        uint8_t a8[16];
        struct {
            uint32_t pad[3];
            uint32_t addr;
        } addrClassic;
    } addr;
} oss_nwIP_t;





typedef struct {
    uint16_t protocol;
    uint16_t port;
} oss_nwService_t;

typedef struct {
    oss_nwIP_t ip;
    oss_nwService_t service;
} oss_nwAddr_t;

typedef struct {
    uint32_t count;
    oss_nwIP_t* ip;
} oss_nwIPList_t;

typedef struct {
    uint32_t count;
    char** name;
} oss_nwNameList_t;
typedef pid_t tid_t;



typedef pid_t pal_pid_t;
typedef tid_t pal_tid_t;




typedef unsigned long pal_scall_parm_t;


typedef void * pal_caller_t;



typedef kail_fmode_t pal_fmode_t;
typedef kail_dev_t pal_dev_t;
typedef kail_vnodeH_t pal_vnodeH_t;
typedef kail_vfs_t pal_vfs_val_t;



typedef kail_fsid_t pal_fsid_t;
typedef kail_fid_t pal_fid_t;
typedef kail_cred_t cred_t;

static inline int pal_pinMem(void *mem, size_t size)
{ return 0; }

static inline int pal_unpinMem(void *mem, size_t size)
{ return 0; }
static inline int pal_copyin(char *uaddr, char *kaddr, size_t count)
{
    return (int)kail_copy_from_user(kaddr, uaddr, count);
}
static inline int pal_copyout(char *kaddr, char *uaddr, size_t count)
{
    return (int)kail_copy_to_user(uaddr, kaddr, count);
}
static inline int
pal_copyinstr(char *uaddr, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_user(kaddr, uaddr, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int
pal_copyinstr_LSM(void *dnd, char *kaddr, const size_t max, size_t *actual)
{
    const int rc = (int) kail_strncpy_from_DND(kaddr, dnd, max);

    *actual = rc + 1;


    if (rc == max)
            return E2BIG;
    else if ((rc == -EFAULT) || (rc == 0))
            return EFAULT;
    else
            return 0;
}
static inline int pal_suser(void)
{
    return (kail_current_euid() == 0);
}
static inline int
pal_unixDescIsCOE(int fd)
{
        return kail_current_files_close_on_exec(fd);
}
static inline void
pal_releVnode(pal_vnodeH_t vnh)
{
    ;
    kail_releVnode((void *)vnh);
}
static inline void
pal_holdVnode(pal_vnodeH_t vnh)
{
    ;
    kail_holdVnode((void *)vnh);
}





typedef void * pal_mutex_t;
typedef void * pal_cond_t;
typedef void * pal_icLock_t;
static inline int
pal_file_read(char *path, pal_vnodeH_t vnodeH, char *buffer, long offset, long len)
{
        return kail_file_read(path,vnodeH,buffer,offset,len);
}
extern char *pal_immunePrograms[];

extern char *pal_loginPrograms[];






extern void pal_machInit(void);
extern void pal_machShutdown(void);
extern int pal_mapOpenFlags(int);
extern void pal_fccInit(void);
extern void pal_fccShutdown(void);
extern void pal_fccFlush(void);
extern int pal_checkLoginBypassMach(char *, int, void *,void *, int32_t *);

extern void pal_errLogInit(void);
typedef oss_nwAddr_t pal_nwAddr_t;







typedef struct _pal_time {
    uint32_t secs;
    int32_t usecs;
} pal_timestruct_t;




typedef int64_t pal_time_t;
typedef oss_uid_t pal_uid_t;
typedef oss_gid_t pal_gid_t;

typedef pal_uid_t pal_authID_t;


typedef uint32_t pal_ptr32_t;
typedef struct _ids {
    pal_authID_t idVal;
    int setMask;
} pal_idSet_t;
typedef struct _idlist {
    pal_authID_t realId;
    pal_authID_t effId;
    pal_authID_t accId;


} pal_idList_t;
enum pal_ftypes { PAL_FTYPE_NONE, PAL_FTYPE_FILE, PAL_FTYPE_DIR,
             PAL_FTYPE_BLKDEV, PAL_FTYPE_CHARDEV, PAL_FTYPE_LNK,
             PAL_FTYPE_SOCK, PAL_FTYPE_BAD, PAL_FTYPE_FIFO,
             PAL_FTYPE_MPC, PAL_FTYPE_OTHER};
typedef enum pal_ftypes pal_ftypes_t;
typedef struct _fattr {
    pal_authID_t uid;
    pal_authID_t gid;
    pal_ftypes_t ftype;
    pal_fmode_t mode;
    uint16_t links;
    uint16_t attrFlags;
    pal_dev_t dev;
    pal_vfs_val_t check_vfsp;
} pal_fattr_t;
typedef struct _rfid {
    uint32_t ctime;
    pal_fsid_t fsid;
    pal_fid_t fid;
} pal_rawFid_t;
typedef struct pal_ph {
    char *path;
    char *pbuf;
    int pathLen;
    int pbLen;
    int flags;
} pal_pathBuf_t;
extern int pal_sysMemMB;
typedef char * pal_pathMemInfo_t;
extern char *pal_readSymLink(char *, int *);





extern void pal_delay(int);
extern int pal_kthreadCreate(void (*)(), void *, char *);
extern pal_authID_t pal_getEGid(void);







extern void pal_logErrMach(char *, int);
typedef char * sharedMemPtr_t;
extern char *pal_alloc(size_t);
extern void pal_free(void *, size_t);



extern void pal_getAllocInfo(int *, size_t *);
extern void pal_logErr(int, char *);
extern int pal_copyin(char *, char *, size_t);
extern int pal_copyinstr(char *, char *, size_t, size_t *);
extern int pal_copyout(char *, char *, size_t);
extern int pal_decomposePath(char *, int, pal_rawFid_t *, int *,
                        pal_rawFid_t *, int *, pal_fattr_t *, pal_vnodeH_t *);
extern int pal_LookupFidAndDir(char *, int, pal_rawFid_t *,
                               pal_rawFid_t *, pal_fattr_t *, int *);
extern int pal_vnodesToFids(pal_vnodeH_t, pal_vnodeH_t,
                            pal_rawFid_t *, pal_rawFid_t *, pal_rawFid_t **,
                            int *, pal_fattr_t *);
extern int pal_pathToFullPath(char *, int, pal_pathBuf_t *);
extern int pal_dirFidToPathFids(pal_rawFid_t *, pal_rawFid_t **, int *);
extern int pal_unixDescToRawFid(int, pal_rawFid_t *);
extern pal_vnodeH_t pal_unixDescToVnode(int);
extern int pal_unixDescToBaseName(int, pal_vnodeH_t, pal_pathBuf_t *);
extern int pal_unixDescIsCOE(int);



extern int pal_suser(void);
extern pal_authID_t pal_getEuid(void);
extern void pal_getREUids(pal_idList_t *);
extern void pal_holdVnode(pal_vnodeH_t);
extern void pal_releVnode(pal_vnodeH_t);
extern int pal_pinMem(void *, size_t);
extern int pal_unpinMem(void *, size_t);
extern int pal_getLocalTermDevice(char *, int, pal_dev_t *);
int pal_checkInheritLoginState(char *, uint32_t, int32_t, int32_t *);
int pal_execChecking(char *, int32_t *, uint32_t *, uint32_t *);
void pal_loginOriginWasReset(int32_t *);
extern int pal_checkLoginBypass(char *, int,
                                pal_idSet_t *, pal_idList_t *, int32_t *);
extern int32_t pal_devToInt32(pal_dev_t);
extern int pal_isImmunePath(char *);
extern int pal_expandExecArgs(void *, char *, int, int);


extern int pal_lookupFidsAndInfo(char *, int, pal_rawFid_t *,
        pal_rawFid_t *, pal_fattr_t *, pal_vnodeH_t *, pal_vnodeH_t *, int *);
extern int pal_pathFidsFromDirVnh(pal_vnodeH_t, pal_rawFid_t *, int *);
extern int pal_file_read(char *,pal_vnodeH_t,char *, long, long);





extern void pal_init(void);
extern void pal_shutdown(void);
extern uint32_t kutil_kossInitTime;

extern void kutil_freeStringWithLocal(char *, char *, int);
extern int kutil_setStringWithLocal(char *, int *, char *, int, char **);
extern char *kutil_prefixString(char *, int, char *, int *, int);

extern void kutil_pathBaseName(char *);
extern char * kutil_pathExtractBaseName(char *);
extern void kutil_pathToDotPath(char *, int);

extern char* kutil_pathToDotPathAndLeaf(char *, int);

extern void kutil_pathToDotDotPath(char *, int);
extern int kutil_pathCleanupTail(char *, int *);
extern int kutil_commonInit(void);
extern int kutil_commonShutdown(void);




extern void kutil_privInit(void);
extern void kutil_privShutdown(void);
extern int kutil_privCheck(int, pal_authID_t);
extern int kutil_isPrivUid(pal_authID_t);
struct uio {
        char *uio_base;
        char *uio_current;
        int32_t uio_left;
} ;
typedef struct uio uio_t;
typedef struct uio pal_uio_t;
static inline int
pal_uio_read(const char * const kaddr, const size_t count, pal_uio_t *const uiop)
{

        if (count < uiop->uio_left) {

                memcpy(uiop->uio_current,kaddr,count);


                uiop->uio_current += count;
                uiop->uio_left -= count;
                return 0;
        }
        else
        {




                return EFAULT;
        }
}
static inline int
pal_uio_write(char * const kaddr, const size_t count, pal_uio_t * const uiop)
{
    int rc = EFAULT;

        if (count <= uiop->uio_left) {

            memcpy(kaddr,uiop->uio_current,count);


            uiop->uio_current += count;
            uiop->uio_left -= count;
            return 0;
        }
        else
        {




                return EFAULT;
        }
}
#include <linux/ioctl.h>
static char KMSG_DEVICE[][14] = {
    "/dev/kossazn",
    "/dev/kossaud"
};




extern int kmsgDebug;
typedef struct chStatus {
    uint32_t opens;
    uint32_t msgs;
    uint32_t downCount;
    uint32_t rwCount;
    uint32_t gt1sec;
    uint32_t gt10sec;
    uint32_t waitTouts;
    uint32_t toRetries;
    uint32_t timeOutErrs;
    uint32_t downErrs;
    uint32_t downToToutErrs;
    uint32_t nobufs;
    uint32_t badTranID;
    uint32_t noDev;
    pal_time_t lastRead;
    pal_time_t lastResponse;
    pal_time_t downTime;
} kmsg_chanStats_t;


typedef struct chanInfo {
    int devStates;
    int chanId;
    kmsg_chanStats_t cs;
} kmsg_chanInfo_t;
extern kmsg_chanInfo_t kmsg_devData[];

extern void kmsg_Init(void);
extern void *kmsg_kGetMsgHandle(int, int, int *);
extern void kmsg_kPutMsgHandle(void *);
extern int kmsg_kAppendData(void *, char *, int);
extern int kmsg_kGetResponse(void *, char *, int, int *);
extern void kmsg_kSetTimeout(void *, int);
extern int kmsg_read(int, pal_uio_t *);
extern int kmsg_write(int, pal_uio_t *);
extern int kmsg_ioctl(int, int, char *);
extern int kmsg_open(int);
extern int kmsg_close(int);
typedef struct amsg_hdr_t {
    uint32_t class_id;
    uint32_t class_fmt_vers;
    uint32_t message_id;
    uint32_t msg_fmt_vers;
} amsg_hdr_t;
typedef struct kpc_resFlags {






    int isLoginPgm:1;

    int isSecPgm:1;


    int isSecFile:1;

    int isXdmPgm:1;

    int isImpersonator:1;




    int hasAcl:1;


    int isTCB:1;



    int hasCond:1;






    int isWC:1;







    int isPrivPgm:1;


    int isTerminal:1;




    int defToNWTerm:1;
    int hasViaPgm:1;

    int hasTod:1;

    int condOther:1;



    int isRootDir:1;

    int isImSurPgm:1;


    int isVia:1;


    int hasPop:1;

    int hasAuthz:1;
} kpc_resFlags_t;
typedef struct amsg_common {
    uint32_t sys_obj_type;
    uint32_t cflags;
    int64_t accessor_id __attribute__ ((aligned (8)));
    uint64_t action __attribute__ ((aligned (8)));
    int64_t accessor_euid __attribute__ ((aligned (8)));
    int64_t accessor_ruid __attribute__ ((aligned (8)));
    uint32_t accessing_pid;
    uint32_t runng_prog_kpon_len;
    uint32_t runng_prog_srn_len;
    uint32_t branchId;
    kpc_resFlags_t resource_flags;

    kpc_resFlags_t runng_prog_kpon_resource_flags;
    uint32_t extended_data_len;
} __attribute__ ((aligned (8))) amsg_common_t;
typedef struct amsg_ois_file {
    uint32_t fflags;
    uint32_t file_kpon_len;
    uint32_t file_srn_len;
    uint32_t alt_kpon_cnt;
} amsg_ois_file_t;
typedef struct amsg_ois_id_mod {
    uint32_t id_mask;
    int64_t new_ID __attribute__ ((aligned (8)));
    uint32_t local_term_kpon_len;
    uint32_t local_term_extdata_len;
    uint32_t remote_term_cand_cnt;
} __attribute__ ((aligned (8))) amsg_ois_id_mod_t;
typedef struct amsg_rem_term_cand {
    oss_nwAddr_t term_loc;
    uint32_t term_kpon_len;

} amsg_rem_term_cand_t;
typedef struct amsg_ois_network {
    uint32_t nwflags;
    oss_nwAddr_t local_conn;
    oss_nwAddr_t remote_conn;
    uint32_t network_kpon_len;
    uint32_t alt_kpon_cnt;
    int64_t policyVersion __attribute__ ((aligned (8)));

    pal_ptr32_t pHost;



} __attribute__ ((aligned (8))) amsg_ois_network_t;

typedef struct amsg_ois_network_alt {
    int64_t policyVersion __attribute__ ((aligned (8)));

    pal_ptr32_t pHost;



    uint32_t network_kpon_len;
} __attribute__ ((aligned (8))) amsg_ois_network_alt_t;
typedef uint32_t amsg_response_result_t;

typedef struct amsg_response {
    amsg_hdr_t header;
    amsg_response_result_t result;
} amsg_response_t;
typedef int kmsg_AznReq1;
typedef int kmsg_AznResp1;
extern kmsg_syscall(pal_scall_parm_t, pal_scall_parm_t,
                    pal_scall_parm_t, pal_scall_parm_t,
                    pal_scall_parm_t, int *);
#include <linux/errno.h>
int
kmsg_DoAznFTest( char * pcRunngPrg, char * pcFileK, char * pcFileS,
                 int *piStatus )
{
    int iRet = 0, iRC, iReply, iLen, iCount, iRespSize,
        iTag = 10000 +3, oStatus;
    void * pMsg;

    amsg_hdr_t tHeader;
    amsg_common_t tCommon;
    amsg_ois_file_t tFile;

    *piStatus = 0;

    pMsg = kmsg_kGetMsgHandle( 0, 0, &oStatus );
    if ( !pMsg ) {
        *piStatus = ENOMEM;
    } else {
        ;


        tHeader.class_id = 1;
        tHeader.class_fmt_vers = 1;
        tHeader.message_id = 1;
        tHeader.msg_fmt_vers = 1;


        tCommon.sys_obj_type = 1;
        tCommon.cflags = 0;
        tCommon.accessor_id = (int64_t)2;
        tCommon.action = (uint64_t)0x1000 | 0x4000;
        tCommon.accessing_pid = 2222;
        tCommon.accessor_euid = (int64_t)8;
        (*((int *)&tCommon.resource_flags) = 0);
        tCommon.resource_flags.isLoginPgm = 1;
        tCommon.runng_prog_kpon_len = strlen( pcRunngPrg ) + 1;
        tCommon.runng_prog_srn_len = 0;
        tCommon.extended_data_len = 0;
        tCommon.branchId = 1;


        tFile.fflags = 0;
        tFile.file_kpon_len = strlen( pcFileK ) + 1;
        tFile.file_srn_len = strlen( pcFileS ) + 1;
        tFile.alt_kpon_cnt = 0;


        iRC = kmsg_kAppendData( pMsg, (char *)&tHeader, sizeof(tHeader) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&tCommon, sizeof(tCommon) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)pcRunngPrg,
                                tCommon.runng_prog_kpon_len );
        if ( iRC == 0 ) {
            ;

        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&tFile, sizeof(tFile) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)pcFileK,
                                tFile.file_kpon_len );
        if ( iRC == 0 ) {
            ;

        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)pcFileS,
                                tFile.file_srn_len );
        if ( iRC == 0 ) {
            ;

        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }


        iRC = kmsg_kGetResponse( pMsg, (char *)&tHeader,sizeof(tHeader),
                                 &iLen );
        if ( iRC == 0 && iLen == sizeof(tHeader) ) {

        } else if ( iRC != 0 ) {
            *piStatus = EIO;
            goto FREE_MSG;
        } else {
            *piStatus = EMSGSIZE;
            goto FREE_MSG;
        }
        iRC = kmsg_kGetResponse( pMsg, (char *)&iRespSize,sizeof(iRespSize),
                                 &iLen );
        if ( iRC == 0 && iLen == sizeof(iRespSize) ) {

        } else if ( iRC != 0 ) {
            *piStatus = EIO;
        } else {
            *piStatus = EMSGSIZE;
        }

    FREE_MSG:
        kmsg_kPutMsgHandle( pMsg );
    }

    return( iRet );
}
int
kmsg_DoAznIDTest( char * pcRunngPrg, int iNewId, char * pcLocTermK,
                  int *piStatus )
{
    int iRet = 0, iRC, iReply, iLen, iCount, iRespSize,
        iTag = 10000 +3, oStatus;
    void * pMsg;

    amsg_hdr_t tHeader;
    amsg_common_t tCommon;
    amsg_ois_id_mod_t tIdMod;

    *piStatus = 0;

    pMsg = kmsg_kGetMsgHandle( 0, 0, &oStatus );
    if ( !pMsg ) {
        *piStatus = ENOMEM;
    } else {
        ;


        tHeader.class_id = 1;
        tHeader.class_fmt_vers = 1;
        tHeader.message_id = 2;
        tHeader.msg_fmt_vers = 1;


        tCommon.sys_obj_type = 2;
        tCommon.cflags = 0;
        tCommon.accessor_id = (int64_t)200;
        tCommon.action = (uint64_t)0x1000 | 0x4000;
        tCommon.accessing_pid = 27;
        tCommon.accessor_euid = (int64_t)300;
        (*((int *)&tCommon.resource_flags) = 0);
        tCommon.resource_flags.isSecPgm = 1;
        tCommon.runng_prog_kpon_len = strlen( pcRunngPrg ) + 1;
        tCommon.runng_prog_srn_len = 0;
        tCommon.extended_data_len = 0;
        tCommon.branchId = 0;


        tIdMod.id_mask = 0x8;
        tIdMod.new_ID = iNewId;
        tIdMod.local_term_kpon_len = strlen( pcLocTermK ) + 1;
        tIdMod.local_term_extdata_len = 0;
        tIdMod.remote_term_cand_cnt = 0;


        iRC = kmsg_kAppendData( pMsg, (char *)&tHeader, sizeof(tHeader) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&tCommon, sizeof(tCommon) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)pcRunngPrg,
                                tCommon.runng_prog_kpon_len );
        if ( iRC == 0 ) {
            ;

        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&tIdMod, sizeof(tIdMod) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg,(char *)pcLocTermK,
                                tIdMod.local_term_kpon_len );
        if ( iRC == 0 ) {
            ;

        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }


        iRC = kmsg_kGetResponse( pMsg, (char *)&tHeader,sizeof(tHeader),
                                 &iLen );
        if ( iRC == 0 && iLen == sizeof(tHeader) ) {

        } else if ( iRC != 0 ) {
            *piStatus = EIO;
            goto FREE_MSG;
        } else {
            *piStatus = EMSGSIZE;
            goto FREE_MSG;
        }
        iRC = kmsg_kGetResponse( pMsg, (char *)&iRespSize,sizeof(iRespSize),
                                 &iLen );
        if ( iRC == 0 && iLen == sizeof(iRespSize) ) {

        } else if ( iRC != 0 ) {
            *piStatus = EIO;
        } else {
            *piStatus = EMSGSIZE;
        }

    FREE_MSG:
        kmsg_kPutMsgHandle( pMsg );
    }

    return( iRet );
}
int
kmsg_DoAznReq1( int *piStatus )
{
    int iRet = 0, iRC, iReply, iLen, iReqValue, oStatus;
    void * pMsg;

    *piStatus = 0;
    iReqValue = 10000 +1;

    pMsg = kmsg_kGetMsgHandle( 0, 0, &oStatus );
    if ( !pMsg ) {
        *piStatus = ENOMEM;
    } else {
        ;

        iRC = kmsg_kAppendData( pMsg, (char *)&iReqValue, sizeof(iReqValue) );
        if ( iRC == 0 ) {
            ;


            iRC = kmsg_kGetResponse( pMsg, (char *)&iReply,
                                     sizeof(iReply), &iLen );
            if ( iRC == 0 && iLen == sizeof(iReply) ) {

                if ( iReply == 0x1 ) {
                    iRet = 0;
                } else if ( iReply == 0x2 ) {
                    iRet = 0;
                } else {
                    ;

                    *piStatus = EBADMSG;
                }
            } else if ( iRC != 0 ) {
                *piStatus = EIO;
            } else {
                *piStatus = EMSGSIZE;
            }
        } else {

            *piStatus = E2BIG;
        }

        kmsg_kPutMsgHandle( pMsg );
    }

    return( iRet );
}
int
kmsg_DoAznReq2( int iReqValue, int *piStatus )
{
    int iRet = 0, iRC, iReply, iLen,
        iTag = 10000 +2, oStatus;
    void * pMsg;

    *piStatus = 0;

    pMsg = kmsg_kGetMsgHandle( 0, 0, &oStatus );
    if ( !pMsg ) {
        *piStatus = ENOMEM;
    } else {
        ;

        iRC = kmsg_kAppendData( pMsg, (char *)&iTag, sizeof(iTag) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&iReqValue, sizeof(iReqValue) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }

        iRC = kmsg_kGetResponse( pMsg, (char *)&iReply,sizeof(iReply), &iLen );
        if ( iRC == 0 && iLen == sizeof(iReply) ) {

            if ( iReply == iReqValue + 1 ) {
                iRet = 0;
            } else if ( iReply == iReqValue - 1 ) {
                iRet = 1;
            } else {
                ;
                *piStatus = EBADMSG;
            }
        } else if ( iRC != 0 ) {
            *piStatus = EIO;
        } else {
            *piStatus = EMSGSIZE;
        }

    FREE_MSG:
        kmsg_kPutMsgHandle( pMsg );
    }

    return( iRet );
}
int
kmsg_DoAznReq3( int iReqSize, int iReqValue, int *piStatus )
{
    int iRet = 0, iRC, iReply, iLen, iCount, iRespSize,
        *piData=(int *)NULL,
        iTag = 10000 +3, oStatus;
    void * pMsg;

    *piStatus = 0;

    pMsg = kmsg_kGetMsgHandle( 0, 0, &oStatus );
    if ( !pMsg ) {
        *piStatus = ENOMEM;
    } else {
        ;


        piData = (int *)pal_alloc( iReqSize * sizeof(iReqValue) );
        if ( piData == (int *)NULL ) {
            ;
            *piStatus = ENOMEM;
            goto FREE_MSG;
        }
        for( iCount = 0; iCount < iReqSize; iCount++ ) {
            piData[iCount] = iReqValue;
        }


        iRC = kmsg_kAppendData( pMsg, (char *)&iTag, sizeof(iTag) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)&iReqSize, sizeof(iReqSize) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }
        iRC = kmsg_kAppendData( pMsg, (char *)piData,
                                iReqSize*sizeof(iReqValue) );
        if ( iRC == 0 ) {
            ;
        } else {
            *piStatus = E2BIG;
            goto FREE_MSG;
        }


        iRC = kmsg_kGetResponse( pMsg, (char *)&iRespSize,sizeof(iRespSize),
                                 &iLen );
        if ( iRC == 0 && iLen == sizeof(iRespSize) ) {

            if ( iRespSize != iReqSize ) {
                ;

                iRet = 1;
            } else {
                iRC = kmsg_kGetResponse( pMsg, (char *)piData,
                                         iReqSize*sizeof(iReqValue), &iLen );
                if ( iRC == 0 && iLen == iReqSize*sizeof(iReqValue) ) {
                    ;

                } else if ( iRC != 0 ) {
                    *piStatus = EIO;
                } else {
                    *piStatus = EMSGSIZE;
                }
            }
        } else if ( iRC != 0 ) {
            *piStatus = EIO;
        } else {
            *piStatus = EMSGSIZE;
        }

    FREE_MSG:
        kmsg_kPutMsgHandle( pMsg );
        if ( piData ) pal_free( piData, iReqSize*sizeof(iReqValue) );
    }

    return( iRet );
}
int kmsg_syscall(pal_scall_parm_t iType,
                 pal_scall_parm_t p1,
                 pal_scall_parm_t p2,
                 pal_scall_parm_t p3,
                 pal_scall_parm_t p4,
                 int *piVal)
{
    int code = 0, iValue, iSize, iSizes[3];
    char pc1[100], pc2[100], pc3[100];

    ;

    if (!kutil_privCheck(0,0))
        return EPERM;
    *piVal = 0;

    switch (iType) {
    case 10000 +1:


        ;
        code = kmsg_DoAznReq1( piVal );
        break;
    case 10000 +2:


        if ( !p1 ) {
            *piVal = EINVAL;
        } else {






            iValue = (int)p1;
            ;
            code = kmsg_DoAznReq2( iValue, piVal );
        }
        break;
    case 10000 +3:

        if ( !p1 || !p2 ) {
            *piVal = EINVAL;
            ;
        } else {
            iSize = (int)p1;
            iValue = (int)p2;
            ;
            code = kmsg_DoAznReq3( iSize, iValue, piVal );
        }
        break;
    case 11001:

        if ( !p1 || !p2 || !p3 || !p4 ) {
            *piVal = EINVAL;
            ;

        } else {

            code = pal_copyin((char *)p1, (char *)iSizes, 3*sizeof(int));
            if ( code != 0 ) {
                ;
                break;
            }



            if ( iSizes[0] > 100 || iSizes[1] > 100 ||
                 iSizes[2] > 100 ) {
                ;

                break;
            }

            code = pal_copyin((char *)p2, pc1, iSizes[0]);
            if ( code != 0 ) {
                ;
                break;
            }
            code = pal_copyin((char *)p3, pc2, iSizes[1]);
            if ( code != 0 ) {
                ;
                break;
            }
            code = pal_copyin((char *)p4, pc3, iSizes[2]);
            if ( code != 0 ) {
                ;
                break;
            }
            kmsg_DoAznFTest( pc1, pc2, pc3, piVal );
        }
        break;
    case 11002:

        if ( !p1 || !p2 || !p3 ) {
            *piVal = EINVAL;
            ;
        } else {

            code = pal_copyin((char *)p1, (char *)iSizes, 2*sizeof(int));
            if ( code != 0 ) {
                ;
                break;
            }



            if ( iSizes[0] > 100 || iSizes[1] > 100 ) {
                ;

                break;
            }

            code = pal_copyin((char *)p2, pc1, iSizes[0]);
            if ( code != 0 ) {
                ;
                break;
            }
            code = pal_copyin((char *)p3, pc2, iSizes[1]);
            if ( code != 0 ) {
                ;
                break;
            }
            kmsg_DoAznIDTest( pc1, 0, pc2, piVal );
        }
        break;
    default:
        ;
        code = EINVAL;
    }
    return code;
}
